<?php
/**
 *
 * @category        frontend
 * @package         account
 * @author          WebsiteBaker Project
 * @copyright       Ryan Djurovich
 * @copyright       WebsiteBaker Org. e.V.
 * @link            http://websitebaker.org/
 * @license         http://www.gnu.org/licenses/gpl.html
 * @platform        WebsiteBaker 2.10.1
 * @requirements    PHP 5.3.6 and higher
 * @version         $Id: details.php 68 2018-09-17 16:26:08Z Luisehahne $
 * @filesource      $HeadURL: svn://isteam.dynxs.de/wb/2.12.x/tags/2.12.1/account/details.php $
 * @lastmodified    $Date: 2018-09-17 18:26:08 +0200 (Mo, 17. Sep 2018) $
 *
 */

// Must include code to stop this file being access directly
if (!defined('SYSTEM_RUN')) { header($_SERVER['SERVER_PROTOCOL'].' 404 Not Found'); echo '404 File not found'; flush(); exit;}

    if (!\bin\SecureTokens::checkFTAN ()) {
        throw new \Exception ($oTrans->MESSAGE_GENERIC_SECURITY_ACCESS);
    }

// sanitize entered values
    $display_name = strip_tags($wb->StripCodeFromText($wb->get_post('display_name')));
    $display_name = ( $display_name == '' ? $wb->get_display_name() : $display_name );
    $language = preg_match('/^[a-z]{2}$/si', $wb->get_post('language'))
                ? $wb->get_post('language') : 'EN';
    $user_time = true;
// timezone must be between -12 and +13  or -20 as system_default
    $timezone         = filter_var($wb->get_post('timezone'),FILTER_VALIDATE_INT);
    $timezone         = (is_numeric($timezone) ? $timezone : DEFAULT_TIMEZONE/3600);
    $timezone         = (($timezone >= -12 && $timezone <= 13) ? $timezone : DEFAULT_TIMEZONE/3600) * 3600;

    $date_format = $wb->StripCodeFromText($wb->get_post('date_format'));
    $time_format = $wb->StripCodeFromText($wb->get_post('time_format'));
    // check that display_name is unique in whoole system (prevents from User-faking)
    $sql  = 'SELECT COUNT(*) FROM `'.TABLE_PREFIX.'users` '
          . 'WHERE `user_id` <> '.(int)$wb->get_user_id().' '
          .   'AND `display_name` LIKE \''.$display_name.'\'';
    if ($database->get_one($sql)) {
        $error[] = ( isset($oTrans->MESSAGE_USERS_DISPLAYNAME_TAKEN) ? $oTrans->MESSAGE_USERS_DISPLAYNAME_TAKEN : $oTrans->MESSAGE_MEDIA_BLANK_NAME.' ('.$oTrans->TEXT_DISPLAY_NAME.')');
    } else {
// Update the database
    $sql  = 'UPDATE `'.TABLE_PREFIX.'users` SET '
          .     '`display_name` = \''.$database->escapeString($display_name).'\', '
          .     '`language` = \''.$database->escapeString($language).'\', '
          .     '`timezone` = \''.$database->escapeString($timezone).'\', '
          .     '`date_format` = \''.$database->escapeString($date_format).'\', '
          .     '`time_format` = \''.$database->escapeString($time_format).'\' '
          . 'WHERE `user_id` = \''.$wb->get_user_id().'\'';
          $database->query($sql);
          if($database->is_error()) {
              $error[] = $database->get_error();
          } else {
              $success[] = $oTrans->MESSAGE_PREFERENCES_DETAILS_SAVED;
              $_SESSION['DISPLAY_NAME'] = $display_name;
              $_SESSION['LANGUAGE'] = $language;
              $_SESSION['TIMEZONE'] = $timezone;
          // Update date format
              if($date_format != '') {
                  $_SESSION['DATE_FORMAT'] = $date_format;
                  if(isset($_SESSION['USE_DEFAULT_DATE_FORMAT'])) { unset($_SESSION['USE_DEFAULT_DATE_FORMAT']); }
              } else {
                  $_SESSION['USE_DEFAULT_DATE_FORMAT'] = true;
                  if(isset($_SESSION['DATE_FORMAT'])) { unset($_SESSION['DATE_FORMAT']); }
              }

        // Update time format
            if($time_format != '') {
                $_SESSION['TIME_FORMAT'] = $time_format;
                if(isset($_SESSION['USE_DEFAULT_TIME_FORMAT'])) { unset($_SESSION['USE_DEFAULT_TIME_FORMAT']); }
            } else {
                $_SESSION['USE_DEFAULT_TIME_FORMAT'] = true;
                if(isset($_SESSION['TIME_FORMAT'])) { unset($_SESSION['TIME_FORMAT']); }
            }
        }
    }
