<?php
/**
 *
 * @category        frontend
 * @package         account
 * @author          WebsiteBaker Project
 * @copyright       Website Baker Org. e.V.
 * @link            http://websitebaker.org/
 * @license         http://www.gnu.org/licenses/gpl.html
 * @platform        WebsiteBaker 2.10.1
 * @requirements    PHP 5.3.6 and higher
 * @version         $Id: forgot_form.php 162 2018-10-18 07:54:59Z Luisehahne $
 * @filesource      $HeadURL: svn://isteam.dynxs.de/wb/2.12.x/tags/2.12.1/account/forgot_form.php $
 * @lastmodified    $Date: 2018-10-18 09:54:59 +0200 (Do, 18. Okt 2018) $
 *
 */

// Must include code to stop this file being access directly
if (!defined('SYSTEM_RUN')) { header($_SERVER['SERVER_PROTOCOL'].' 404 Not Found'); echo '404 File not found'; flush(); exit;}
// Check if the user has already submitted the form, otherwise show it

// get request method
    $oRequest = (object) filter_input_array (
                (strtoupper ($_SERVER['REQUEST_METHOD']) == 'POST' ? INPUT_POST : INPUT_GET), FILTER_UNSAFE_RAW
    );

$sCallingScript = WB_URL;
$redirect_url = ((isset($_SESSION['HTTP_REFERER']) && $_SESSION['HTTP_REFERER'] != '') ? $_SESSION['HTTP_REFERER'] : $sCallingScript );
$redirect_url = ( isset($redirect) && ($redirect!='') ? $redirect : $redirect_url);

$oTrans = Translate::getInstance();
$oTrans->enableAddon('\\account');

if(isset($oRequest->email))
{
    if (!\bin\SecureTokens::checkFTAN ()) {
        throw new \Exception ($oTrans->MESSAGE_GENERIC_SECURITY_ACCESS);
    }
}
$errMsg  = [];
$aMessage = [];
$aSuccess = [];
$display_form = true;
$aMessage[] = $MESSAGE['FORGOT_PASS_NO_DATA'];
// testing the messages
/*
$errMsg[] = $MESSAGE['FORGOT_PASS_ALREADY_RESET'];
$errMsg[] = $MESSAGE['FORGOT_PASS_EMAIL_NOT_FOUND'];
$aSuccess[] = $MESSAGE['FORGOT_PASS_PASSWORD_RESET'];
$display_form = false;
*/
if(isset($oRequest->email) && $oRequest->email != "" )
{
    $email = strip_tags($oRequest->email);
    if($admin->validate_email($email) == false)
    {
        $errMsg[] = $MESSAGE['USERS_INVALID_EMAIL'];
        $email = '';
    } else {
// Check if the email exists in the database
    $sql  = 'SELECT `user_id`,`username`,`display_name`,`email`,`last_reset`,`password` '.
            'FROM `'.TABLE_PREFIX.'users` '.
            'WHERE `email`=\''.$database->escapeString($email).'\'';
    if(($results = $database->query($sql)))
    {
        if(($results_array = $results->fetchRow(MYSQLI_ASSOC)))
        { // Get the id, username, email, and last_reset from the above db query
        // Check if the password has been reset in the last 2 hours
            if( (time() - (int)$results_array['last_reset']) < (2 * 3600) ) {
            // Tell the user that their password cannot be reset more than once per hour
                $errMsg[] = $MESSAGE['FORGOT_PASS_ALREADY_RESET'];
            } else {
                if (!\class_exists('PasswordHash')){require(WB_PATH.'/framework/PasswordHash.php');}
                $pwh = new \PasswordHash(0, true);
                $old_pass = $results_array['password'];
            // Generate a random password then update the database with it
                $new_pass = $pwh->NewPassword();
/* */
                $sql  = 'UPDATE `'.TABLE_PREFIX.'users` SET '
                      . '`password`=\''.$database->escapeString($pwh->HashPassword($new_pass, true)).'\', '
                      . '`last_reset`='.time().' '
                      . 'WHERE `user_id`='.(int)$results_array['user_id'];

                unset($pwh); // destroy $pwh-Object
                if($database->query($sql))
                { // Setup email to send
                    $mail_to = $email;
                    $sDomain = parse_url(WB_URL, PHP_URL_HOST);

                    $mail_subject = str_replace('WB', $sDomain,$MESSAGE['SIGNUP2_SUBJECT_LOGIN_INFO']);
                // Replace placeholders from language variable with values
                    $search  = array('{LOGIN_DISPLAY_NAME}', '{LOGIN_WEBSITE_TITLE}', '{LOGIN_NAME}', '{LOGIN_PASSWORD}');
                    $replace = array($results_array['display_name'], WEBSITE_TITLE, $results_array['username'], $new_pass);
                    $mail_message = str_replace($search, $replace, $MESSAGE['SIGNUP2_BODY_LOGIN_FORGOT']);
                // Try sending the email
                    if ($wb->mail(SERVER_EMAIL,$mail_to,$mail_subject,$mail_message)) {
                        $aSuccess[] = $MESSAGE['FORGOT_PASS_PASSWORD_RESET'];
                        $display_form = false;
                    }else { // snd mail failed, rollback
                        $sql = 'UPDATE `'.TABLE_PREFIX.'users` '.
                               'SET `password`=\''.$database->escapeString($old_pass).'\' '.
                               'WHERE `user_id`='.(int)$results_array['user_id'];
                        $database->query($sql);
                        $errMsg[] = $MESSAGE['FORGOT_PASS_CANNOT_EMAIL'];
                    }
                }else { // Error updating database
                    $errMsg[] = $MESSAGE['RECORD_MODIFIED_FAILED'];
//                    if(DEBUG) {
//                        $message[] = $database->get_error();
//                        $message[] = $sql;
//                    }
                }
            }
        }else { // no record found - Email doesn't exist, so tell the user
            $errMsg[] = $MESSAGE['FORGOT_PASS_EMAIL_NOT_FOUND'];
        }
    } else { // Query failed
        $errMsg[] = 'SystemError:: Database query failed!';
//        if(DEBUG) {
//            $errMsg[] = $database->get_error();
//            $errMsg[] = $sql;
//        }
    }
    }
} else {
    $email = '';
//    $errMsg[] = $MESSAGE['SIGNUP_NO_EMAIL'];
}
/*--------------------------------------------------------------------------------*/

    $sTemplate  = 'forgot_form.htt';
    $sTemplatePath = WB_PATH.'/account/templates/';
    if (file_exists(WB_PATH .'/templates/'.TEMPLATE.'/templates/'.$sTemplate)) {
       $sTemplatePath = WB_PATH .'/templates/'.TEMPLATE.'/templates/';
    }

    $template = new \vendor\phplib\Template($sTemplatePath);
    $template->set_file('page', $sTemplate);
    $template->set_block('page', 'main_block', 'main');

    $template->set_block('main_block', 'back_block', 'back');
    $template->parse('back', 'back_block', true);

    $template->set_block('main_block', 'success_block', 'success');
    $template->set_block('main_block', 'error_block', 'error');
    $template->set_block('main_block', 'heading_block', 'heading');

    if (sizeof($aSuccess)) {
        $template->set_block('success_block', 'success_list_block', 'success_list');
        foreach($aSuccess as $sSuccess) {
            $template->set_var('MESSAGE', $sSuccess);
            $template->parse('success_list', 'success_list_block', true);
        }
        $template->parse('success', 'success_block', true);
        $template->set_block('error', '');
        $template->set_block('heading', '');
    } else {
        $template->set_block('success', '');
    }

    if (sizeof($errMsg)) {
        $template->set_block('error_block', 'error_list_block', 'error_list');
        foreach($errMsg as $sErrorLine) {
            $template->set_var('MESSAGE', $sErrorLine);
            $template->parse('error_list', 'error_list_block', true);
        }
        $template->parse('error', 'error_block', true);
    } else {
        $template->set_block('error', '');
    }

    if (sizeof($aMessage)) {
        $template->set_block('heading_block', 'heading_list_block', 'heading_list');
        foreach($aMessage as $sMessage) {
            $template->set_var('MESSAGE', $sMessage);
            $template->parse('heading_list', 'heading_list_block', true);
        }
        $template->parse('heading', 'heading_block', true);
    }

    $template->set_block('main_block', 'display_form_block', 'display_form');
    if (!isset($display_form) || $display_form == false) {
        $template->set_block('display_form_block', '');
    } else {
     $template->parse('display_form', 'display_form_block', true);
    }

    $template->set_ftan(\bin\SecureTokens::getFTAN());
    $template->set_var($oTrans->getLangArray());
    $template->set_var('WB_URL', WB_URL);
    $template->parse('main', 'main_block', false);
    $template->pparse('output', 'page');

/*--------------------------------------------------------------------------------*/
