<?php
/**
 *
 * @category        frontend
 * @package         account
 * @author          WebsiteBaker Project
 * @copyright       2004-2009, Ryan Djurovich
 * @copyright       2009-2011, Website Baker Org. e.V.
 * @link            http://www.websitebaker2.org/
 * @license         http://www.gnu.org/licenses/gpl.html
 * @platform        WebsiteBaker 2.8.x
 * @requirements    PHP 5.2.2 and higher
 * @version         $Id: preferences.php 68 2018-09-17 16:26:08Z Luisehahne $
 * @filesource        $HeadURL: svn://isteam.dynxs.de/wb/2.12.x/tags/2.12.1/account/preferences.php $
 * @lastmodified    $Date: 2018-09-17 18:26:08 +0200 (Mo, 17. Sep 2018) $
 *
 */

if (!defined( 'WB_PATH')){ require(dirname(__DIR__).'/config.php'); }
if (!class_exists('frontend')) {require(WB_PATH.'/framework/class.frontend.php');}

require_once(WB_PATH.'/framework/functions.php');
$oTrans = Translate::getInstance();
$oTrans->enableAddon('templates\\DefaultTemplate');

// Create new frontend object
if (!isset($wb) || !($wb instanceof frontend)) {
  $wb = new frontend();
}

if(!FRONTEND_LOGIN) {
    header('Location: '.WB_URL.'/index.php');
    exit(0);
}

if ($wb->is_authenticated()==false) {
    header('Location: '.WB_URL.'/account/login.php');
    exit(0);
}
$redirect_url = ((isset($_SESSION['HTTP_REFERER']) && $_SESSION['HTTP_REFERER'] != '') ? $_SESSION['HTTP_REFERER'] : WB_URL );
$redirect_url = ( isset($redirect) && ($redirect!='') ? $redirect : $redirect_url);
$page_id = isset($_SESSION['PAGE_ID']) ? $_SESSION['PAGE_ID'] : 0;

// Required page details
$page_description = '';
$page_keywords = '';
define('PAGE_ID', $page_id);
define('ROOT_PARENT', 0);
define('PARENT', 0);
define('LEVEL', 0);

define('PAGE_TITLE', $oTrans->MENU_PREFERENCES);
define('MENU_TITLE', $oTrans->MENU_PREFERENCES);
define('MODULE', '');
define('VISIBILITY', 'public');

define('PAGE_CONTENT', WB_PATH.'/account/preferences_form.php');
// Include the index (wrapper) file
$no_intro = true;
require(WB_PATH.'/index.php');
