<?php
/**
 *
 * @category        frontend
 * @package         account
 * @author          WebsiteBaker Project
 * @copyright       Ryan Djurovich
 * @copyright       WebsiteBaker Org. e.V.
 * @link            http://websitebaker.org/
 * @license         http://www.gnu.org/licenses/gpl.html
 * @platform        WebsiteBaker 2.10.1
 * @requirements    PHP 5.3.6 and higher
 * @version         $Id: preferences_form.php 68 2018-09-17 16:26:08Z Luisehahne $
 * @filesource      $HeadURL: svn://isteam.dynxs.de/wb/2.12.x/tags/2.12.1/account/preferences_form.php $
 * @lastmodified    $Date: 2018-09-17 18:26:08 +0200 (Mo, 17. Sep 2018) $
 *
 */
// prevent this file from being accesses directly
if (!defined('SYSTEM_RUN')) { header($_SERVER['SERVER_PROTOCOL'].' 404 Not Found'); echo '404 File not found'; flush(); exit;}
    $sCallingScript = WB_URL;

    $redirect_url = (isset($_SESSION['HTTP_REFERER']) && ($_SESSION['HTTP_REFERER'] != '') ? $_SESSION['HTTP_REFERER'] : $sCallingScript );
    $redirect_url = (isset($redirect) && ($redirect!='') ? $redirect : $redirect_url);
    if($wb->is_authenticated() === false) {
// User needs to login first
        header("Location: ".WB_URL."/account/login.php?redirect=".$wb->link);
        exit(0);
    }
// load module default language file (EN)
$sAddonName = basename(__DIR__);
$oTrans = Translate::getInstance();
    $oTrans->enableAddon('\\account');

//require(WB_PATH .'/'.$sAddonName.'/languages/EN.php');
//if(file_exists(WB_PATH .'/'.$sAddonName.'/languages/'.LANGUAGE .'.php')) {
//    require(WB_PATH .'/'.$sAddonName.'/languages/'.LANGUAGE .'.php');
//}
//    require_once(WB_PATH.'/framework/functions-utf8.php');

    $user_time = true;
    require(ADMIN_PATH.'/interface/timezones.php');
    require(ADMIN_PATH.'/interface/date_formats.php');
    require(ADMIN_PATH.'/interface/time_formats.php');
    $error = [];
    $success = [];

    $sTemplate  = 'preferences_form.htt';
    $sTemplatePath = WB_PATH.'/account/templates/';
    if (file_exists(WB_PATH .'/templates/'.TEMPLATE.'/templates/'.$sTemplate)) {
       $sTemplatePath = WB_PATH .'/templates/'.TEMPLATE.'/templates';
    }
    $template = new \vendor\phplib\Template($sTemplatePath);

    switch($wb->get_post('action')):
        case 'details':
            require_once(WB_PATH .'/account/details.php');
            break;
        case 'email':
            require_once(WB_PATH .'/account/email.php');
            break;
        case 'password':
            require_once(WB_PATH .'/account/password.php');
            break;
        default:
            // do nothing
    endswitch; // switch

// show template
    $template->set_file('page', $sTemplate);
    $template->set_block('page', 'main_block', 'main');

    $template->set_var($oTrans->getLangArray());
    $template->set_ftan(\bin\SecureTokens::getFTAN());

// get existing values from database
    $sql  = 'SELECT `display_name`, `username`, `email` FROM `'.TABLE_PREFIX.'users` '
          . 'WHERE `user_id` = '.(int)$admin->get_user_id();
    $oUsers = $database->query($sql);
    if($database->is_error()) { $error[] = $database->get_error(); }
    $aUser = $oUsers->fetchRow(MYSQLI_ASSOC);

// insert values into form
    $template->set_var('USERNAME', $aUser['username']);
    $template->set_var('DISPLAY_NAME', $aUser['display_name']);
    $template->set_var('EMAIL', $aUser['email']);
    $template->set_var('ACTION_URL', '#');
    $template->set_var('ADMIN_URL',    ADMIN_URL);
    $template->set_var('THEME_URL',    THEME_URL);
    $template->set_var('TEMPLATE_URL',    TEMPLATE_DIR);
// read available languages from table addons and assign it to the template
    $sql  = 'SELECT * FROM `'.TABLE_PREFIX.'addons` '
          . 'WHERE `type` = \'language\' ORDER BY `directory`';
    if( $oLang = $database->query($sql) ) {
        $template->set_block('main_block', 'language_list_block', 'language_list');
        $iCurrentLanguage = (isset($_SESSION['LANGUAGE']) ? $_SESSION['LANGUAGE']: $aUser['language']);
        while( $aLang = $oLang->fetchRow(MYSQLI_ASSOC) )
        {
            $langIcons = (empty($aLang['directory'])) ? 'none' : strtolower($aLang['directory']);
            $template->set_var('CODE',        $aLang['directory']);
            $template->set_var('NAME',        $aLang['name']);
            $template->set_var('FLAG',        $langIcons);
            $template->set_var('SELECTED',    ($iCurrentLanguage == $aLang['directory'] ? ' selected="selected"' : '') );
            $template->parse('language_list', 'language_list_block', true);
        }
    }
// Insert default timezone values
    $template->set_block('main_block', 'timezone_list_block', 'timezone_list');

    if( isset($_SESSION['TIMEZONE'])) {
        $actual_time = time()+ $_SESSION['TIMEZONE'];
        foreach($TIME_FORMATS as $key => &$val) {
            if($key == "system_default") {
                if(isset($oTrans->TEXT_SYSTEM_DEFAULT)) {
                    $val = gmdate(DEFAULT_TIME_FORMAT, $actual_time).' ('.$oTrans->TEXT_SYSTEM_DEFAULT.')';
                } else {
                    $val = gmdate(DEFAULT_TIME_FORMAT, $actual_time).' (System Default)';
                }
            } else {
                $format = str_replace("|", " ", $key);
                $TIME_FORMATS[ $key ] = gmdate( $format, $actual_time);
            }
        }
        // Keep in mind we've also update the Date! (± one day)
        foreach($DATE_FORMATS as $key => &$val) {
            if($key == "system_default") {
                if(isset($oTrans->TEXT_SYSTEM_DEFAULT)) {
                    $val = gmdate(DEFAULT_DATE_FORMAT, $actual_time).' ('.$oTrans->TEXT_SYSTEM_DEFAULT.')';
                } else {
                    $val = gmdate(DEFAULT_DATE_FORMAT, $actual_time).' (System Default)';
                }
            } else {
                $format = str_replace("|", " ", $key);
                $DATE_FORMATS[ $key ] = gmdate( $format, $actual_time);
            }
        }
    }
    $iActualTimezone = ((DEFAULT_TIMEZONE <> 0)  ? DEFAULT_TIMEZONE : 0);
    $iActualTimezone = (($iActualTimezone == $wb->get_timezone())? 'system_default':$wb->get_timezone());
    $iActualTimezone = (($iActualTimezone!='system_default')?intval($iActualTimezone):$iActualTimezone);
    foreach( $TIMEZONES AS $hour_offset => $title )
    {
        $iTmpOffset = (is_numeric($hour_offset)?$hour_offset*3600:$hour_offset);
        $template->set_var('VALUE',    $hour_offset);
        $template->set_var('NAME',     $title);
        $template->set_var('SELECTED', (($iTmpOffset === $iActualTimezone) ? ' selected="selected"' : ''));
        $template->parse('timezone_list', 'timezone_list_block', true);
    }

// Insert date format list
    $template->set_block('main_block', 'date_format_list_block', 'date_format_list');
    $sTempDateFormat = (isset($_SESSION['DATE_FORMAT']) ? $_SESSION['DATE_FORMAT'] : defined('DATE_FORMAT') ? DATE_FORMAT: 'Y-m-d');
    foreach($DATE_FORMATS AS $format => $title) {
        $format = str_replace('|', ' ', $format); // Add's white-spaces (not able to be stored in array key)
        if($format != 'system_default') {
            $template->set_var('VALUE', $format);
        } else {
            $template->set_var('VALUE', '');
        }
        $template->set_var('NAME', $title);
        if($sTempDateFormat == $format && !isset($_SESSION['USE_DEFAULT_DATE_FORMAT'])) {
            $template->set_var('SELECTED', ' selected="selected"');
        } elseif($format == 'system_default' && isset($_SESSION['USE_DEFAULT_DATE_FORMAT'])) {
            $template->set_var('SELECTED', ' selected="selected"');
        } else {
            $template->set_var('SELECTED', '');
        }
        $template->parse('date_format_list', 'date_format_list_block', true);
    }
// Insert time format list
    $template->set_block('main_block', 'time_format_list_block', 'time_format_list');
    $sTimeFormat = (isset($_SESSION['TIME_FORMAT']) ? $_SESSION['TIME_FORMAT']: defined('TIME_FORMAT') ? TIME_FORMAT : 'g:i A');
    foreach($TIME_FORMATS AS $format => $title) {
        $format = str_replace('|', ' ', $format); // Add's white-spaces (not able to be stored in array key)
        if($format != 'system_default') {
            $template->set_var('VALUE', $format);
        } else {
            $template->set_var('VALUE', '');
        }
        $template->set_var('NAME', $title);
        if($sTimeFormat == $format AND !isset($_SESSION['USE_DEFAULT_TIME_FORMAT'])) {
            $template->set_var('SELECTED', ' selected="selected"');
        } elseif($format == 'system_default' AND isset($_SESSION['USE_DEFAULT_TIME_FORMAT'])) {
            $template->set_var('SELECTED', ' selected="selected"');
        } else {
            $template->set_var('SELECTED', '');
        }
        $template->parse('time_format_list', 'time_format_list_block', true);
    }
// insert all translations
    $template->set_var($oTrans->getLangArray());
    $template->set_var('HTTP_REFERER', $redirect_url); //$_SESSION['HTTP_REFERER'],
// Insert error and/or success messages
    $template->set_block('main_block', 'error_block', 'error_list');
    if(sizeof($error)>0){
        foreach($error AS $value){
            $template->set_var('ERROR_VALUE', $value);
            $template->parse('error_list', 'error_block', true);
        }
    } else {
      $template->set_block('error_block','');
    }
    $template->set_block('main_block', 'success_block', 'success_list');
    if(sizeof($success)!=0){
        foreach($success AS $value){
            $template->set_var('SUCCESS_VALUE', $value);
            $template->parse('success_list', 'success_block', true);
        }
    } else {
      $template->set_block('success_block','');
    }
// Parse template for preferences form
    $template->parse('main', 'main_block', false);
    $template->pparse('output', 'page');
