<?php
/**
 *
 * @category        frontend
 * @package         account
 * @author          WebsiteBaker Project
 * @copyright       Ryan Djurovich
 * @copyright       WebsiteBaker Org. e.V.
 * @link            http://websitebaker.org/
 * @license         http://www.gnu.org/licenses/gpl.html
 * @platform        WebsiteBaker 2.10.1
 * @requirements    PHP 5.3.6 and higher
 * @version         $Id: signup.php 68 2018-09-17 16:26:08Z Luisehahne $
 * @filesource      $HeadURL: svn://isteam.dynxs.de/wb/2.12.x/tags/2.12.1/account/signup.php $
 * @lastmodified    $Date: 2018-09-17 18:26:08 +0200 (Mo, 17. Sep 2018) $
 *
 */

if (!defined('SYSTEM_RUN') ){ require(dirname(__DIR__).'/config.php'); }

if (!(int)FRONTEND_SIGNUP || (int)(isset($_SESSION['USER_ID']) ? $_SESSION['USER_ID'] : 0)) {
    if(INTRO_PAGE) {
        $no_intro = true;
    }
    include dirname(__DIR__).'/index.php';
}

if(ENABLED_ASP && isset($_POST['username']) && ( // form faked? Check the honeypot-fields.
    (!isset($_POST['submitted_when']) OR !isset($_SESSION['submitted_when'])) OR
    ($_POST['submitted_when'] != $_SESSION['submitted_when']) OR
    (!isset($_POST['email-address']) OR $_POST['email-address']) OR
    (!isset($_POST['name']) OR $_POST['name']) OR
    (!isset($_POST['full_name']) OR $_POST['full_name'])
)) {
    header($_SERVER['SERVER_PROTOCOL'].' 404 Not Found');
    echo '<!DOCTYPE HTML PUBLIC "-//IETF//DTD HTML 2.0//EN">
    <html><head><title>404 Not Found</title></head><body><h1>Not Found</h1>
    <p>The requested URL '.$_SERVER['SCRIPT_NAME'].' was not found on this server.</p>
    <hr>'.$_SERVER['SERVER_SIGNATURE'].'</body></html>';
    flush(); exit;
}

// Load the language file
if (!file_exists(WB_PATH.'/languages/'.DEFAULT_LANGUAGE.'.php')) {
    exit('Error loading language file '.DEFAULT_LANGUAGE.', please check configuration');
} else {
    require_once(WB_PATH.'/languages/'.DEFAULT_LANGUAGE.'.php');
    $load_language = false;
}
$_SESSION['display_form'] = true;

$page_id = isset($_SESSION['PAGE_ID']) ? $_SESSION['PAGE_ID'] : 0;

// Required page details
// $page_id = 0;
$page_description = '';
$page_keywords = '';
define('PAGE_ID', $page_id);
define('ROOT_PARENT', 0);
define('PARENT', 0);
define('LEVEL', 0);
define('PAGE_TITLE', $TEXT['SIGNUP']);
define('MENU_TITLE', $TEXT['SIGNUP']);
define('MODULE', '');
define('VISIBILITY', 'public');

// Set the page content include file
    define('PAGE_CONTENT', WB_PATH.'/account/signup_form.php');

// Set auto authentication to false
$auto_auth = false;

// Include the index (wrapper) file
require(WB_PATH.'/index.php');
