<?php
/**
 *
 * @category        frontend
 * @package         account
 * @author          WebsiteBaker Project
 * @copyright       Ryan Djurovich
 * @copyright       WebsiteBaker Org. e.V.
 * @link            http://websitebaker.org/
 * @license         http://www.gnu.org/licenses/gpl.html
 * @platform        WebsiteBaker 2.10.1
 * @requirements    PHP 5.3.6 and higher
 * @version         $Id: signup_form.php 68 2018-09-17 16:26:08Z Luisehahne $
 * @filesource      $HeadURL: svn://isteam.dynxs.de/wb/2.12.x/tags/2.12.1/account/signup_form.php $
 * @lastmodified    $Date: 2018-09-17 18:26:08 +0200 (Mo, 17. Sep 2018) $
 *
 */

// Must include code to stop this file being access directly
if (!defined('SYSTEM_RUN')) { header($_SERVER['SERVER_PROTOCOL'].' 404 Not Found'); echo '404 File not found'; flush(); exit;}

// get request method
    $oRequest = (object) filter_input_array (
                (strtoupper ($_SERVER['REQUEST_METHOD']) == 'POST' ? INPUT_POST : INPUT_GET), FILTER_UNSAFE_RAW
    );

    $sCallingScript = WB_URL;
    $redirect_url = ((isset($_SESSION['HTTP_REFERER']) && $_SESSION['HTTP_REFERER'] != '') ? $_SESSION['HTTP_REFERER'] : $sCallingScript );
    $redirect_url = ( isset($redirect) && ($redirect!='') ? $redirect : $redirect_url);
    $error = [];
    $success = [];
    if (!function_exists('captcha_header')) {require(WB_PATH.'/include/captcha/captcha.php');}

    if (!$sSettings = \bin\helpers\ParentList::dsgvoSettings()){
        $sInifile     = '/templates/'.TEMPLATE.'/DataProtection.ini';
        $sIniUserfile = '/templates/'.TEMPLATE.'/DataUserProtection.ini';
        if (is_readable(WB_PATH .$sIniUserfile)){
            $sInifile = $sIniUserfile;
        }
        if (is_readable(WB_PATH .$sInifile)){
            $aTmp = \parse_ini_file(WB_PATH .$sInifile, true, INI_SCANNER_TYPED);
            $aSettings = $aTmp['dsgvo'];
         }
    } else {
      $aSettings = \bin\helpers\ParentList::__unserialize($sSettings);
    }

// load module default language file (EN)
    $sAddonName = basename(__DIR__);
    $oTrans = Translate::getInstance();
    $oTrans->enableAddon('\\account');
    if(isset($oRequest->action) && $oRequest->action=='send') {
        require(__DIR__.'/signup2.php');
    }

/*--------------------------------------------------------------------------------*/
    $sTemplate  = 'signup_form.htt';
// looking for template in frontend templates  otherwise set from account templates folder
    $sTemplatePath = WB_PATH.'/account/templates/';
    if (file_exists(WB_PATH .'/templates/'.TEMPLATE.'/templates/'.$sTemplate)) {
       $sTemplatePath = WB_PATH .'/templates/'.TEMPLATE.'/templates/';
    }

    $template = new \vendor\phplib\Template($sTemplatePath);
    $template->set_file('page', $sTemplate);
    $template->set_block('page', 'main_block', 'main');

    $template->set_block('main_block', 'back_block', 'back');
//    $template->parse('back', 'back_block', true);
    $template->set_block('back_block', '');

    $template->set_block('main_block', 'display_form_block', 'display_form');
    $template->set_block('main_block', 'success_block', 'success');
    if (sizeof($success)>0){
//    $_SESSION['display_form'] = false;
        $template->set_block('success_block', 'success_list_block', 'success_list');
        foreach($success as $value){
            $template->set_var('MESSAGE', xnl2br($value));
            $template->parse('success_list', 'success_list_block', true);
        }
        $template->parse('success', 'success_block', true);
    } else {
        $template->set_block('success_block', '');
    }
//
    if ($_SESSION['display_form']){
    $template->set_block('display_form_block', 'error_block', 'error');
        if (sizeof($error) > 0){
            $template->set_block('error_block', 'error_list_block', 'error_list');
            foreach($error as $value) {
                $template->set_var('MESSAGE', $value);
                $template->parse('error_list', 'error_list_block', true);
            }
            $template->parse('error', 'error_block', true);
        } else {
            $template->set_block('error_block', '');
        }
        // add some honeypot-fields
        $iNow = time(); $_SESSION['submitted_when']=$iNow;
        $template->set_block('display_form_block', 'honeypot_block', 'honeypot');
        if (ENABLED_ASP) {
            $template->set_var('SESSION_SUBMITTED_WHEN', $iNow);
            $template->parse('honeypot', 'honeypot_block', true);
        } else {
            $template->set_block('honeypot_block', '');
        }
// Captcha
        $template->set_block('display_form_block', 'display_captcha_block', 'display_captcha');
        if (ENABLED_CAPTCHA) {
        $aCaptachs['ct_color'] = 1;
        if ($oCaptcha = $database->query('SELECT * FROM `'.TABLE_PREFIX.'mod_captcha_control` ')){
            $aCaptachs = $oCaptcha->fetchRow(MYSQLI_ASSOC);
        }
            $template->set_var('CALL_CAPTCHA', call_captcha('all','','',false,$aCaptachs['ct_color']));
            $template->parse('display_captcha', 'display_captcha_block', false);
        } else{
            $template->set_block('display_captcha_block', '');
        }

        $template->set_block('display_form_block', 'use_data_protection_block', 'use_data_protection');
        if ($aSettings['use_data_protection']) {
#            $target_section_id = $aSettings[LANGUAGE];
#            $target_section_id = $aSettings['data_protection_link'];
#            if ($target_section_id == 0) {}
            $sDataLink = \bin\helpers\ParentList::getDsgvoDefaultLink();
            $template->set_var('CALL_DSGVO_LINK',sprintf($oTrans->MESSAGE_DSGVO, $sDataLink));
            $template->parse('use_data_protection', 'use_data_protection_block', false);
        } else{
            $template->set_block('use_data_protection_block', '');
        }

        $template->parse('display_form', 'display_form_block', true);
    } else {
        $template->set_block('display_form_block', '');
    }

    $template->set_var($oTrans->getLangArray());
    $template->set_var('SIGNUP_URL', WB_URL.'/account/signup.php');
    $template->set_ftan(\bin\SecureTokens::getFTAN());

// Parse template for preferences form
    $template->parse('main', 'main_block', false);
    $template->pparse('output', 'page');

/*--------------------------------------------------------------------------------*/
