<?php
/**
 *
 * @category        admin
 * @package         admintools
 * @author          WebsiteBaker Project
 * @copyright       Ryan Djurovich
 * @copyright       WebsiteBaker Org. e.V.
 * @link            http://websitebaker.org/
 * @license         http://www.gnu.org/licenses/gpl.html
 * @platform        WebsiteBaker 2.10.1
 * @requirements    PHP 5.3.6 and higher
 * @version         $Id: create.php 155 2018-10-12 08:56:04Z Luisehahne $
 * @filesource      $HeadURL: svn://isteam.dynxs.de/wb/2.12.x/tags/2.12.1/admin/media/create.php $
 * @lastmodified    $Date: 2018-10-12 10:56:04 +0200 (Fr, 12. Okt 2018) $
 *
 */

// Print admin header
if (!\defined('SYSTEM_RUN')) {require( (\dirname(\dirname((__DIR__)))).'/config.php');}
// Include the WB functions file
    if (!defined('createFolderProtectFile') ){ require(WB_PATH.'/framework/functions.php');  }

// suppress to print the header, so no new FTAN will be set
    $admin = new \admin('Media', 'media_create', false);

// Get dir name and target location
    $requestMethod = '_'.strtoupper($_SERVER['REQUEST_METHOD']);
    $name = (isset(${$requestMethod}['name'])) ? ${$requestMethod}['name'] : '';

// Remove bad characters
    $name = trim(media_filename($name),'.');

// Target location
    $requestMethod = '_'.strtoupper($_SERVER['REQUEST_METHOD']);
    $target = (isset(${$requestMethod}['create_target'])) ? ${$requestMethod}['create_target'] : '';
    $sBacklinkUrl = ADMIN_URL.'/media/index.php?dir='.$target;

// Check to see if name or target contains ../
    if(strstr($name, '..')) {
        $admin->print_header();
        $admin->print_error($MESSAGE['MEDIA_NAME_DOT_DOT_SLASH'],$sBacklinkUrl);
    }

    if (!$admin->checkFTAN())
    {
        $admin->print_header();
        $admin->print_error($MESSAGE['GENERIC_SECURITY_ACCESS'],$sBacklinkUrl);
    }
// After check print the header
    $admin->print_header();

    if (!check_media_path($target, false)) {
        $admin->print_error($MESSAGE['MEDIA_TARGET_DOT_DOT_SLASH']);
    }

// Create relative path of the new dir name
    $directory = WB_PATH.$target.'/'.$name;
//    $sBacklinkUrl = ADMIN_URL.'/media/index.php?dir='.$directory;

// Check to see if the folder already exists
    if (file_exists($directory)) {
        $admin->print_error($MESSAGE['MEDIA_DIR_EXISTS'],$sBacklinkUrl);
    }

//if ( sizeof(createFolderProtectFile( $directory )) )
    if (!make_dir( $directory ) )
    {
        $admin->print_error($MESSAGE['MEDIA_DIR_NOT_MADE'],$sBacklinkUrl);
    } else {
    //    createFolderProtectFile($directory);
        $usedFiles = array();
        // feature freeze
        // require_once(ADMIN_PATH.'/media/dse.php');
        $admin->print_success($MESSAGE['MEDIA_DIR_MADE'],$sBacklinkUrl);
    }

// Print admin
$admin->print_footer();
