<?php
/**
 *
 * @category        admin
 * @package         media
 * @author          WebsiteBaker Project
 * @copyright       Ryan Djurovich
 * @copyright       WebsiteBaker Org. e.V.
 * @link            http://websitebaker.org/
 * @license         http://www.gnu.org/licenses/gpl.html
 * @platform        WebsiteBaker 2.10.1
 * @requirements    PHP 5.3.6 and higher
 * @version         $Id: rename.php 159 2018-10-14 05:34:52Z Luisehahne $
 * @filesource      $HeadURL: svn://isteam.dynxs.de/wb/2.12.x/tags/2.12.1/admin/media/rename.php $
 * @lastmodified    $Date: 2018-10-14 07:34:52 +0200 (So, 14. Okt 2018) $
 *
 */

if (!\defined('SYSTEM_RUN')){require(\dirname(\dirname((__DIR__))).'/config.php' );}
    $oLang = Translate::getInstance();
    $oLang->enableAddon('modules\\'.\basename(__DIR__));
    $aLang = $oLang->getLangArray();

// Create admin object
    $admin = new \admin('Media', 'media_rename', false);

// Include the WB functions file
    if (!\function_exists('make_dir')){require(WB_PATH.'/framework/functions.php');}
    if (!\function_exists('mediaScanDir')){require('MediaScanDir.inc');}

// Get the current dir
    $directory = $admin->get_get('dir');
    $directory = ($directory == '/') ?  '' : $directory;

    $dirlink = 'browse.php?dir='.$directory;
    $rootlink = 'browse.php?dir=';
    $file_id = ($admin->get_get('id'));

// first Check to see if it contains ..
    if (!check_media_path($directory)) {
        $admin->print_error('['.__LINE__.'] '.$MESSAGE['MEDIA_DIR_DOT_DOT_SLASH'],$rootlink, false);
    }

    $aParentPaths = WB_PATH.MEDIA_DIRECTORY.'/'.$directory;
// Get the temp id
    $file_id = ($admin->checkIDKEY('id', false, $_SERVER['REQUEST_METHOD']));
    if (!$file_id) {
        $admin->print_error($MESSAGE['GENERIC_SECURITY_ACCESS'],$dirlink, false);
    }
/*
    $file_id = \bin\SecureTokens::checkIDKEY('id');
    if (!isset($file_id)) {
        $admin->print_error(sprintf('[%d] '.$MESSAGE['GENERIC_SECURITY_ACCESS'],$file_id),$dirlink, false);
    }
    \trigger_error(sprintf('[%d] Sanitize file_id %s',__LINE__, $file_id), E_USER_NOTICE);
*/
    // scan given dir
    $aListDir = mediaScanDir($directory);
    $rename_file = '';
//    $file_id--;
    if(isset($aListDir)) {
        foreach($aListDir as $temp_id => $name)
        {
            if (($file_id == $temp_id)) {
                $rename_file = $name;
                $type = \is_dir(WB_PATH.MEDIA_DIRECTORY.$directory.'/'.$rename_file) ? 'folder' : 'file';
            }
//            $temp_id++;
        }
    }

    if (!isset($rename_file)) {
        $admin->print_error($MESSAGE['MEDIA_FILE_NOT_FOUND'], $dirlink, false);
    }

    $sExtension = '';
    $sBasename = $rename_file;
    \preg_match (
        '/^(?:.*?[\/])?([^\/]*?)\.([^\.]*)$/iU',
        str_replace('\\', '/', $rename_file),
        $aMatches
    );
    if (\sizeof($aMatches) == 3) {
        $sBasename  = $aMatches[1];
        $sExtension = $aMatches[2];
    }

// Setup template object, parse vars to it, then parse it
// Create new template object
    $template = new \vendor\phplib\Template(dirname($admin->correct_theme_source('media_rename.htt')));
    $template->set_file('page', 'media_rename.htt');
    $template->set_block('page', 'main_block', 'main');
//echo WB_PATH.'/media/'.$directory.'/'.$rename_file;
    if($type == 'folder') {
        $template->set_var('DISPlAY_EXTENSION', 'hide');
        $extension = '';
    } else {
        $template->set_var('DISPlAY_EXTENSION', '');
        $extension = \strstr($rename_file, '.');
    }

    if($type == 'folder') {
        $type = $TEXT['FOLDER'];
    } else {
        $type = $TEXT['FILE'];
    }

    $file_id_key = \bin\SecureTokens::getIDKEY($file_id);
    $template->set_var(array(
                    'THEME_URL' => THEME_URL,
                    'FILENAME' => $rename_file,
                    'BASENAME' => $sBasename,
                    'DIR' => $directory,
                    'FILE_ID' => $file_id_key,
                    'FILE_ID_NUM' => $file_id,
                    'TYPE' => $type,
                    'EXTENSION' => $sExtension,
                    'TEXT_TYPE' => (\is_dir( $aParentPaths.'/'.$rename_file) ? $TEXT['FOLDER'] : $TEXT['FILE']),
                    'FTAN' => $admin->getFTAN()
                )
            );

// Insert language text and messages
    $template->set_var(array(
                    'TEXT_RENAME' => $TEXT['RENAME'],
                    'TEXT_CANCEL' => $TEXT['CANCEL'],
                    'TEXT_UP' => $TEXT['UP'],
                    'TEXT_OVERWRITE_EXISTING' => $TEXT['OVERWRITE_EXISTING']
                )
            );

// Parse template object
    $template->parse('main', 'main_block', false);
    $template->pparse('output', 'page');
