<?php
/**
 *
 * @category        admin
 * @package         media
 * @author          WebsiteBaker Project
 * @copyright       Ryan Djurovich
 * @copyright       WebsiteBaker Org. e.V.
 * @link            http://websitebaker.org/
 * @license         http://www.gnu.org/licenses/gpl.html
 * @platform        WebsiteBaker 2.10.1
 * @requirements    PHP 5.3.6 and higher
 * @version         $Id: rename2.php 159 2018-10-14 05:34:52Z Luisehahne $
 * @filesource      $HeadURL: svn://isteam.dynxs.de/wb/2.12.x/tags/2.12.1/admin/media/rename2.php $
 * @lastmodified    $Date: 2018-10-14 07:34:52 +0200 (So, 14. Okt 2018) $
 *
 */
if (!\defined('SYSTEM_RUN')) {require( (\dirname(\dirname((__DIR__)))).'/config.php');}
// Create admin object
    $admin = new \admin('Media', 'media_rename', false);

// Include the WB functions file
    if (!\function_exists('make_dir')) {require (WB_PATH.'/framework/functions.php');}
    if (!\function_exists('mediaScanDir')){require('MediaScanDir.inc');}
//  Pattern check for potentially malicious files extensions
    $forbidden_file_types  = (''.\preg_replace( '/\s*[,;\|#]\s*/','|',RENAME_FILES_ON_UPLOAD));

// Get the current dir
    $requestMethod = '_'.\strtoupper($_SERVER['REQUEST_METHOD']);
    $directory = (isset(${$requestMethod}['dir'])) ? ${$requestMethod}['dir'] : '';
    $directory = ($directory == '/') ?  '' : $directory;

    $sBacklinkUrl = ADMIN_URL.'/media/index.php';
    $dirlink  = 'browse.php?dir='.$directory;
    $rootlink = 'browse.php?dir=';

// first Check to see if it contains ..
    if (!check_media_path($directory)) {
        $admin->print_error('['.__LINE__.'] '.$MESSAGE['MEDIA_DIR_DOT_DOT_SLASH'],$rootlink, false);
    }
    $file_id = \intval($admin->checkIDKEY('id', false, $_SERVER['REQUEST_METHOD']));
    if (!$file_id) {
    //    $admin->print_error($MESSAGE['GENERIC_SECURITY_ACCESS'],$dirlink, false);
        $admin->print_error(\sprintf('[%d] '.$MESSAGE['GENERIC_SECURITY_ACCESS'],$file_id),$dirlink, false);
    }
/*
    $file_id = \bin\SecureTokens::checkIDKEY('id');
    if (isset($file_id)) {
        $admin->print_error(sprintf('[%d] '.$MESSAGE['GENERIC_SECURITY_ACCESS'],$file_id),$dirlink, false);
    }
*/
// Get home folder not to show
    $home_folders = get_home_folders();

    // scan given dir
    $aListDir = mediaScanDir($directory);
    $rename_file = '';
// Get the temp id
    if(isset($aListDir)) {
//        sort($aListDir, SORT_REGULAR|SORT_FLAG_CASE);
        foreach($aListDir as $temp_id => $name)
        {
            if(($file_id == $temp_id)) {
                $rename_file = $name;
                $type = \is_dir(WB_PATH.MEDIA_DIRECTORY.$directory.'/'.$rename_file) ? 'folder' : 'file';
            }
//            $temp_id++;
        }
    }

    if (!isset($rename_file)) {
        $admin->print_error($MESSAGE['MEDIA_FILE_NOT_FOUND'], $dirlink, false);
    }

    $file_id_key = \bin\SecureTokens::getIDKEY($file_id);

// Check if they entered a new name
    if (media_filename($admin->get_post('name')) == "") {
        $admin->print_error($MESSAGE['MEDIA_BLANK_NAME'], "rename.php?dir=$directory&id=$file_id_key", false);
    } else {
        $old_name = $admin->StripCodeFromText($admin->get_post('old_name'));
        $new_name =  $admin->StripCodeFromText(media_filename($admin->get_post('name')));
    }

// Check if they entered an extension
    if ($type == 'file') {
        if (\strstr($new_name,'.')){
            $new_name = \str_replace('.', '_', $new_name);
        }
        if (media_filename($admin->get_post('extension')) == "") {
            $name = $new_name;
        } else {
            $extension = $admin->StripCodeFromText(media_filename($admin->get_post('extension')));
            $name = $new_name.'.'.\trim($extension,'.');
        }
    } elseif ($type == 'folder') {
        $extension = '';
        $name = $new_name;
    }

// Join new name and extension
    $info = \pathinfo(WB_PATH.MEDIA_DIRECTORY.$directory.'/'.$name);
    $ext  = isset($info['extension']) ? $info['extension'] : '';
    $dots = (\substr($info['basename'], 0, 1) == '.') || (\substr($info['basename'], -1, 1) == '.');

    if (\preg_match('/'.$forbidden_file_types.'$/i', $ext) || $dots == '.' ) {
        $admin->print_error($MESSAGE['MEDIA_CANNOT_RENAME'], "rename.php?dir=$directory&id=$file_id_key", false);
    }

// Check if the name contains ..
    if (\strstr($name, '..')) {
        $admin->print_error('['.__LINE__.'] '.$MESSAGE['MEDIA_NAME_DOT_DOT_SLASH'], "rename.php?dir=$directory&id=$file_id_key", false);
    }

// Check if the name is index.php
    if ($name == 'index.php') {
        $admin->print_error($MESSAGE['MEDIA_NAME_INDEX_PHP'], "rename.php?dir=$directory&id=$file_id_key", false);
    }

// Check that the name still has a value
    if ($name == '') {
        $admin->print_error($MESSAGE['MEDIA_BLANK_NAME'], "rename.php?dir=$directory&id=$file_id_key", false);
    }

    $info = \pathinfo(WB_PATH.MEDIA_DIRECTORY.$directory.'/'.$rename_file);
    $ext  = isset($info['extension']) ? $info['extension'] : '';
    $dots = (\substr($info['basename'], 0, 1) == '.') || (\substr($info['basename'], -1, 1) == '.');

    if (\preg_match('/'.$forbidden_file_types.'$/i', $ext) || $dots == '.' ) {
        $admin->print_error($MESSAGE['MEDIA_CANNOT_RENAME'], "rename.php?dir=$directory&id=$file_id_key", false);
    }

// Check if we should overwrite or not
    if ($admin->get_post('overwrite') != 'yes' && \file_exists(WB_PATH.MEDIA_DIRECTORY.$directory.'/'.$name) == true) {
        if ($type == 'folder') {
            $admin->print_error($MESSAGE['MEDIA_DIR_EXISTS'], "rename.php?dir=$directory&id=$file_id_key", false);
        } else {
            $admin->print_error($MESSAGE['MEDIA_FILE_EXISTS'], "rename.php?dir=$directory&id=$file_id_key", false);
        }
    }

// Try and rename the file/folder
    if (\rename(WB_PATH.MEDIA_DIRECTORY.$directory.'/'.$rename_file, WB_PATH.MEDIA_DIRECTORY.$directory.'/'.$name)) {
        $usedFiles = [];
/*
        echo '
          <script>
          // Set the value of the location object
            parent.document.location.href="'.$dirlink.'"
          </script>
        ';
*/
        // feature freeze
        // require_once(ADMIN_PATH.'/media/dse.php'); $sBacklinkUrl  $rootlink  $dirlink
        $admin->print_success($MESSAGE['MEDIA_RENAMED'], $dirlink);
    } else {
        $admin->print_error($MESSAGE['MEDIA_CANNOT_RENAME'], "rename.php?dir=$directory&id=$file_id_key", false);
    }
