<?php
/*
 * Copyright (C) 2017 Manuela v.d.Decken <manuela@isteam.de>
 *
 * DO NOT ALTER OR REMOVE COPYRIGHT OR THIS HEADER
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, version 2 of the License.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License 2 for more details.
 *
 * You should have received a copy of the GNU General Public License 2
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/**
 * Description of admin/media/upload.php
 *
 * @package      Core
 * @copyright    Manuela v.d.Decken <manuela@isteam.de>
 * @author       Manuela v.d.Decken <manuela@isteam.de>
 * @license      GNU General Public License 2.0
 * @version      2.0.1
 * @revision     $Id: upload.php 159 2018-10-14 05:34:52Z Luisehahne $
 * @since        File available since 04.10.2017
 * @deprecated   no
 * @description  xxx
 */
//declare(strict_types = 1);
//declare(encoding = 'UTF-8');

//namespace ;

// use

if (!\defined('SYSTEM_RUN')){require(\dirname(\dirname((__DIR__))).'/config.php' ); }
// Include the WB functions file
    if (!function_exists('check_media_path')){require(WB_PATH.'/framework/functions.php');}
//if (!class_exists('RESIZEIMAGE', false)){include(__DIR__.'/resize_img.php');}
    if (!class_exists('PhpThumbFactory', false)){include(__DIR__.'/inc/ThumbLib.inc.php');}
// Include the PclZip constant file
    if (!\defined('PCLZIP_ERR_NO_ERROR')) { require(WB_PATH.'/include/pclzip/Constants.php'); }

    if (\is_readable(__DIR__.'/languages/EN.php')) {require(__DIR__.'/languages/EN.php');}
    if (\is_readable(__DIR__.'/languages/'.DEFAULT_LANGUAGE.'.php')) {require(__DIR__.'/languages/'.DEFAULT_LANGUAGE.'.php');}
    if (\is_readable(__DIR__.'/languages/'.LANGUAGE.'.php')) {require(__DIR__.'/languages/'.LANGUAGE.'.php');}

    $bAllowedFileTypes  = 'bmp|gif|jpg|ico|jpeg|png';
    // get from settings and add to forbidden list
    $forbidden_file_types  = \preg_replace( '/\s*[,;\|#]\s*/','|',RENAME_FILES_ON_UPLOAD);

    $width  = $database->get_one('SELECT `value` FROM `'.TABLE_PREFIX.'settings` WHERE `name` = \'media_width\' ');
    $height = $database->get_one('SELECT `value` FROM `'.TABLE_PREFIX.'settings` WHERE `name` = \'media_height\' ');

    /*
     * Callback function to skip files in black-list
        $p_header['filename'] = media_filename($p_header['filename']);
     */
    function pclzipCheckValidFile($p_event, &$p_header)
    {
        global $forbidden_file_types;
// Check for potentially malicious files
        $p_header['filename'] = str_replace(' ', '_', $p_header['filename']);
        $info = \pathinfo($p_header['filename']);
        $ext = isset($info['extension']) ? $info['extension'] : '';
        $dots = (\substr($info['basename'], 0, 1) == '.');
// ---- allowed file types are extracted
        if (($dots != '.')) {
            $bRetVal = !\preg_match('#^.*?\.('.$forbidden_file_types.')?$#is', $p_header['filename'], $aMatches);
        } else {
// ---- all other files are skiped
            $bRetVal = 0;
        }
        return (int)$bRetVal;
    }
/* -------------------------------------------------------------------------- */
    function callbackPostExtract($p_event, &$p_header)
    {
         return 1;
    }


try {
    // suppress to print the header, so no new FTAN will be set
    $admin = new \admin('Media', 'media_upload', false);
    // get request method
    $requestMethod = \strtoupper($_SERVER['REQUEST_METHOD']);
    $aRequestVars  = (isset(${'_'.$requestMethod}) ? ${'_'.$requestMethod} : $_REQUEST);
// get request method
    // Target location
    $target = (isset($aRequestVars['upload_target'])) ? $aRequestVars['upload_target'] : '';

    // Get the current dir   .str_replace(MEDIA_DIRECTORY,'',$directory)
    $directory = (($target == '/') ?  '' : $target);
    $dirlink   = 'index.php?dir='.$directory;
    $rootlink  = 'index.php?dir=';

    $sBacklinkUrl   =  ADMIN_URL.''.'/media/index.php?dir=';
    $sAddonBackUrl  =  ADMIN_URL.''.'/media/index.php?dir=';
    // Create relative path of the target location for the file
        if (!\bin\SecureTokens::checkFTAN ()) {
            $admin->print_header();
    //        $admin->print_error($MESSAGE['GENERIC_SECURITY_ACCESS'],$sBacklinkUrl);
            throw new \Exception ($MESSAGE['GENERIC_SECURITY_ACCESS']);
        }

    $relative = WB_PATH.$target.'/';

    if (!\function_exists('__unserialize')){include(__DIR__.'/parameters.php');}
    // After check print the header
    $admin->print_header();
    // Check to see if target contains ../
    if (!check_media_path($target, false)) {
//        $admin->print_error($MESSAGE['MEDIA_TARGET_DOT_DOT_SLASH'],$sBacklinkUrl);
        throw new \Exception ($MESSAGE['MEDIA_TARGET_DOT_DOT_SLASH']);
    }

    $overwrite = ($admin->get_post('overwrite') != '') ? true : false;

    $sTarget     = \str_replace(MEDIA_DIRECTORY,'', $target);
    $resizepath  = \str_replace(array('/',' '),'_',$sTarget);
    $sParentPath = $resizepath;

    $sTest = \sprintf('$target %1s $sTarget %2s<br />$resizepath %3s MEDIA_DIRECTORY %4s',$target,$sTarget,$resizepath, MEDIA_DIRECTORY);
    // Loop through the files
    $sum_dirs = 0;
    $sum_files = 0;
    $iFolder = 0;
    $iFiles  = 0;
    $good_uploads = 0;
    $iTotaluploads = 0;

    $aFiles = $_FILES['file'];
    $iUploadedsFiles = \sizeof($aFiles);

    for($count = 0; $count <= $iUploadedsFiles; $count++)
    {
        $sFileRequest = ''.$count;
        $sFilename = (isset($aFiles['name'][$sFileRequest]) ? $aFiles['name'][$sFileRequest] : '') ;

        // If file was upload to tmp
        if (($sFilename!=''))
        {
            // Remove bad characters
            $filename = \trim(media_filename($sFilename));
            // Check if there is still a filename left
            // if($filename != '') {
            $info = \pathinfo($filename);
            $ext = isset($info['extension']) ? $info['extension'] : '';
            if (($filename != '') && (\substr($filename, 0, 1) != '.') && !\preg_match("/".$forbidden_file_types."$/i", $ext) )
            {
                $iTotaluploads++;
                // Move to relative path (in media folder)
                if (\is_readable($relative.$filename) && $overwrite == true) {
                    if (\move_uploaded_file($aFiles['tmp_name'][$sFileRequest], $relative.$filename)) {
                        $good_uploads++;
                        $iFiles++;
                        // Chmod the uploaded file
                        change_mode($relative.$filename);
                    }
                } elseif (!\is_readable($relative.$filename)) {
                    if (\move_uploaded_file($aFiles['tmp_name'][$sFileRequest], $relative.$filename)) {
                        $good_uploads++;
                        $iFiles++;
                        // Chmod the uploaded file
                        change_mode($relative.$filename);
                    }
                }
                $bValidFile = (($filename != '') && \preg_match('/' . $bAllowedFileTypes . '$/i', $ext));
                if (\is_readable($relative.$filename)&& $bValidFile) {
//                    if (isset($pathsettings[$resizepath]) && (($pathsettings[$resizepath]['width']&&$pathsettings[$resizepath]['width']) || ($pathsettings[$resizepath]['height']&&$pathsettings[$resizepath]['height']))) {
                        if (isset($pathsettings[$resizepath])
                             && ((isset($pathsettings[$resizepath]['width']) && $pathsettings[$resizepath]['width']!=0) || (isset($pathsettings[$resizepath]['height']) && $pathsettings[$resizepath]['height']!=0))) {
                        $rimg = PhpThumbFactory::create($relative.$filename);
                        $rimg->resize($pathsettings[$resizepath]['width'],$pathsettings[$resizepath]['height'],$relative.$filename);
                        $rimg->save($relative.$filename);
                    } else {
                        if ($width!=0 || $height!=0) {
                            $rimg = PhpThumbFactory::create($relative.$filename);
                            $rimg->resize($width,$height,$relative.$filename);
                            $rimg->save($relative.$filename);
                        }
                    }
                }
                // store file name of first file for possible unzip action
                if ($count == 0) {
                    $sZipFile = $relative.$filename;
                    $sParentPath = $resizepath;
                    if (isset($pathsettings[$sParentPath])) {
                        $width  = ((isset($pathsettings[$resizepath]['width']) && $pathsettings[$resizepath]['width']!=0) ? $pathsettings[$resizepath]['width'] : $width);
                        $height = ((isset($pathsettings[$resizepath]['height']) && $pathsettings[$resizepath]['height']!=0) ? $pathsettings[$resizepath]['height'] : $height);
                    }
                }
            }else {
                $sMessage = \sprintf($MESSAGE['MEDIA_NAME_FILETYPE'],$filename, $sFileRequest);
                throw new \Exception ($sMessage);
            }
        }
    }

    if ($iFiles == 0) {
        $sMessage = \sprintf($MESSAGE['MEDIA_NO_FILE_UPLOADED'], $iTotaluploads );
        throw new \Exception ($sMessage);
    }
    // If the user chose to unzip the first file, unzip into the current folder
    if (isset($aRequestVars['unzip']) && isset($sZipFile) && is_readable($sZipFile) ) {
#     '/'.$forbidden_file_types.'$/i'
        $forbidden_file_types  = \preg_replace( '/\s*[,;\|#]\s*/','|',RENAME_FILES_ON_UPLOAD);
        // Required to unzip file.
        $archive = new \vendor\pclzip\PclZip($sZipFile);
        $list = $archive->extract(
            PCLZIP_OPT_PATH, $relative
            ,PCLZIP_OPT_EXTRACT_DIR_RESTRICTION, WB_PATH.MEDIA_DIRECTORY
//                ,PCLZIP_OPT_BY_PREG, '/^.*?('.$forbidden_file_types.')?$/is'
            ,PCLZIP_CB_PRE_EXTRACT, 'pclzipCheckValidFile'
#            ,PCLZIP_CB_POST_EXTRACT, 'callbackPostExtract'
        );

        $good_uploads = (\is_array($list) ? \sizeof($list) : 0);
        $iFiles = 0;
        $iFolder = 0;
        if( $archive->errorCode() != 0 ) {
            // error while trying to extract the archive (most likely wrong format)
            $admin->print_error('UNABLE TO UNZIP FILE' . $archive->errorInfo(true));
        } else {
            // resize files
            $sArchivFile = '';

            for( $x = 0; $x < $good_uploads; $x++)
            {
                if ($list[$x]['status'] == 'skipped'){continue;}
                $sArchivFile = ($list[$x]['filename']);
                if ($list[$x]['folder']) {$iFolder++;} else {$iFiles++;}
//echo sprintf('[%d] %s <br />Folder %d / Dateien %d <br />',__LINE__, $sArchivFile, $iFolder,$iFiles);
                $info = \pathinfo($sArchivFile);
                $ext = isset($info['extension']) ? $info['extension'] : '';
                $sTmp =  \str_replace(\str_replace('\\','/',WB_PATH.MEDIA_DIRECTORY),'',$sArchivFile);
                $sChildPath = '_'.(\trim((\is_dir($sTmp) ? $sTmp : \dirname($sTmp)),'/'));
                $sChildPath =  \str_replace(array('/',' '),'_',$sChildPath);
                $bValidFile = (($sArchivFile != '') && \preg_match('/' . $bAllowedFileTypes . '$/i', $ext));
                $bChildIsEmpty = (isset($pathsettings[$sChildPath]) && empty($pathsettings[$sChildPath])) || !isset($pathsettings[$sChildPath]);
                $resizepath = ($bChildIsEmpty ? $sParentPath : $sChildPath);
                if (\is_readable($sArchivFile)&& $bValidFile)
                {
//                        if (isset($pathsettings[$resizepath]) && ($pathsettings[$resizepath]['width'] || $pathsettings[$resizepath]['height'])){
                    if (isset($pathsettings[$resizepath])
                         && ((isset($pathsettings[$resizepath]['width']) && $pathsettings[$resizepath]['width']!=0) || (isset($pathsettings[$resizepath]['height']) && $pathsettings[$resizepath]['height']!=0))) {
#echo sprintf('[%d] %s <br />Breite %d px x Höhe %d px<br />',__LINE__, $sArchivFile, $pathsettings[$resizepath]['width'],$pathsettings[$resizepath]['height']);
                        $rimg = PhpThumbFactory::create($sArchivFile);
                        $rimg->resize($pathsettings[$resizepath]['width'],$pathsettings[$resizepath]['height'],$sArchivFile);
                        $rimg->save($sArchivFile);
                    } else {
#echo sprintf('[%d] %s <br />Breite %d px x Höhe %d px<br />',__LINE__, $sArchivFile, $width,$height);
                        if ($width!=0 || $height!=0) {
                            $rimg = PhpThumbFactory::create($sArchivFile);
                            $rimg->resize($width,$height,$sArchivFile);
                            $rimg->save($sArchivFile);
                        }
                    }
                } // readable

           }  // endd for
        }
        if (isset($aRequestVars['delzip'])&& is_readable($sZipFile)) { unlink($sZipFile); }
        unset($list);
    }    // end extract archiv


        if ($iFiles == 1) {
            $sMessage = (!isset($aRequestVars['unzip'])
            ? \sprintf($MESSAGE['MEDIA_SINGLE_UPLOADED'],$iFiles)
            : \sprintf($MESSAGE['MEDIA_ZIP_UPLOADED'],$iFolder,$iFiles));
            $admin->print_success($sMessage,$sBacklinkUrl);
        } elseif($iFiles > 1) {
          $sMessage = (!isset($aRequestVars['unzip'])
          ? \sprintf($MESSAGE['MEDIA_MULTI_UPLOADED'],$iFiles)
          : \sprintf($MESSAGE['MEDIA_ZIP_UPLOADED'],$iFolder,$iFiles));
          $admin->print_success($sMessage,$sBacklinkUrl);
        } else {
            $sMessage = \sprintf($MESSAGE['MEDIA_NO_FILE_UPLOADED'], $iTotaluploads );
            throw new \Exception ($sMessage);
        }

    } catch (\Exception $ex) {

    $sErrMsg = xnl2br(\sprintf('[%d] %s', $ex->getLine(), $ex->getMessage()));
    $admin->print_error ($sErrMsg, $sAddonBackUrl);
    exit;
}

// Print admin
$admin->print_footer();
