<?php
/**
 *
 * @category        admin
 * @package         start
 * @author          WebsiteBaker Project
 * @copyright       Ryan Djurovich
 * @copyright       WebsiteBaker Org. e.V.
 * @link            http://websitebaker.org/
 * @license         http://www.gnu.org/licenses/gpl.html
 * @platform        WebsiteBaker 2.10.1
 * @requirements    PHP 5.3.6 and higher
 * @version         $Id: index.php 141 2018-10-03 19:01:52Z Luisehahne $
 * @filesource      $HeadURL: svn://isteam.dynxs.de/wb/2.12.x/tags/2.12.1/admin/start/index.php $
 * @lastmodified    $Date: 2018-10-03 21:01:52 +0200 (Mi, 03. Okt 2018) $
 *
*/
if (!\defined( 'SYSTEM_RUN') ){ require(\dirname(\dirname((__DIR__))).'/config.php' ); }

$admin = new \admin('Start','start');
// ---------------------------------------
if (\defined('FINALIZE_SETUP')) {
    $sql = 'DELETE FROM `'.TABLE_PREFIX.'settings` WHERE `name`=\'finalize_setup\'';
    if ($database->query($sql)) {unset($sql);}
}
// ---------------------------------------
$msg  = '<br />';
// check if it is neccessary to start the uograde-script
if (($admin->get_user_id()=='1') && \file_exists(WB_PATH.'/upgrade-script.php')) {
    // check if it is neccessary to start the uograde-script
    $oldVersion = '';
    $newVersion = '';
    $oldVersion  = \trim(''.WB_VERSION.'+'.WB_REVISION.'+'.(\defined('WB_SP') ? WB_SP : ''), '+');
    $newVersion  = \trim(''.VERSION.'+'.REVISION.'+'.(\defined('SP') ? SP : ''), '+');
    if ((\version_compare($oldVersion, $newVersion, '<') === true )) {
        if (!\headers_sent()) {
            \header('Location: '.WB_URL.'/upgrade-script.php');
            exit;
        } else {
            echo "<p style=\"text-align:center;\"> The <strong>upgrade script</strong> could not start automatically.\n" .
                 "Please click <a style=\"font-weight:bold;\" " .
                 "href=\"".WB_URL."/upgrade-script.php\">on this link</a> to start the script!</p>\n";
            // Print admin footer
            $admin->print_footer();
            exit;
        }
    }
}
/**
 * delete stored ip adresses default after 30 days
 */
$iSecsPerDay = 86400;
$iTotalDays  = 30;
$sql = 'UPDATE `'.TABLE_PREFIX.'users` SET `login_ip` = \'\' WHERE `login_when` < '.(time()-($iSecsPerDay*$iTotalDays));
if ($database->query($sql)) {
}
// Setup template object, parse vars to it, then parse it
$oLang = Translate::getInstance();
$oLang->enableAddon('templates/'.DEFAULT_THEME);
// Create new template object
$template = new \vendor\phplib\Template(dirname($admin->correct_theme_source('start.htt')));
$template->set_file('page', 'start.htt');
$template->set_block('page', 'main_block', 'main');

// Insert values into the template object
$template->set_var(array(
                    'WELCOME_MESSAGE' => $oLang->MESSAGE_START_WELCOME_MESSAGE,
                    'CURRENT_USER' => $oLang->MESSAGE_START_CURRENT_USER,
                    'DISPLAY_NAME' => $admin->get_display_name(),
                    'ADMIN_URL' => ADMIN_URL,
                    'WB_URL' => WB_URL,
                    'THEME_URL' => THEME_URL,
                    'WB_VERSION' => WB_VERSION,
                    'START_LIST' => ' '
                )
            );
// Insert permission values into the template object
$get_permission = (function($type='preferences', $ParentBlock='main_block') use ($admin, $template){
    $bRetVal = false;
    $template->set_block($ParentBlock, 'show_'.$type.'_block', 'show_'.$type);
    if ($admin->get_permission($type) != true) {
        $template->set_block('show_'.$type, '');
    } else {
        $template->parse('show_'.$type, 'show_'.$type.'_block', true);
        $bRetVal = true;
    }
    return $bRetVal;
});

$get_permission ('pages');
$get_permission ('media');
$get_permission ('addons');
$get_permission ('settings');
$get_permission ('admintools');
$get_permission ('access');

//$msg .= (file_exists(WB_PATH.'/install/')) ?  $MESSAGE['START_INSTALL_DIR_EXISTS'] : $msg;

        $template->set_var('DISPLAY_WARNING', 'display:none;');
// Check if installation directory still exists
if (\file_exists(WB_PATH.'/upgrade-script.php') ) {
// Check if user is part of Adminstrators group / better be a Systemadministrator
//    if ($admin->ami_group_member(1)){
    if ($admin->get_user_id() == 1) {
        $template->set_var('WARNING', $msg );
    } else {
        $template->set_var('DISPLAY_WARNING', 'display:none;');
    }
} else {
    $template->set_var('DISPLAY_WARNING', 'display:none;');
}

// Insert "Add-ons" section overview (pretty complex compared to normal)
$addons_overview = $TEXT['MANAGE'].' ';
$addons_count = 0;
if($admin->get_permission('modules') == true)
{
    $addons_overview .= '<a href="'.ADMIN_URL.'/modules/index.php">'.$oLang->MENU_MODULES.'</a>';
    $addons_count = 1;
}
if($admin->get_permission('templates') == true)
{
    if($addons_count == 1) { $addons_overview .= ', '; }
    $addons_overview .= '<a href="'.ADMIN_URL.'/templates/index.php">'.$oLang->MENU_TEMPLATES.'</a>';
    $addons_count = 1;
}
if($admin->get_permission('languages') == true)
{
    if($addons_count == 1) { $addons_overview .= ', '; }
    $addons_overview .= '<a href="'.ADMIN_URL.'/languages/index.php">'.$oLang->MENU_LANGUAGES.'</a>';
}

// Insert "Access" section overview (pretty complex compared to normal)
$access_overview = $TEXT['MANAGE'].' ';
$access_count = 0;
if($admin->get_permission('users') == true) {
    $access_overview .= '<a href="'.ADMIN_URL.'/users/index.php">'.$oLang->MENU_USERS.'</a>';
    $access_count = 1;
}
if($admin->get_permission('groups') == true) {
    if($access_count == 1) { $access_overview .= ', '; }
    $access_overview .= '<a href="'.ADMIN_URL.'/groups/index.php">'.$oLang->MENU_GROUPS.'</a>';
    $access_count = 1;
}

// Insert section names and descriptions
$template->set_var(array(
                    'PAGES' => $oLang->MENU_PAGES,
                    'MEDIA' => $oLang->MENU_MEDIA,
                    'ADDONS' => $oLang->MENU_ADDONS,
                    'ACCESS' => $oLang->MENU_ACCESS,
                    'PREFERENCES' => $oLang->MENU_PREFERENCES,
                    'SETTINGS' => $oLang->MENU_SETTINGS,
                    'ADMINTOOLS' => $oLang->MENU_ADMINTOOLS,
                    'HOME_OVERVIEW' => $oLang->OVERVIEW_START,
                    'PAGES_OVERVIEW' => $oLang->OVERVIEW_PAGES,
                    'MEDIA_OVERVIEW' => $oLang->OVERVIEW_MEDIA,
                    'ADDONS_OVERVIEW' => $addons_overview,
                    'ACCESS_OVERVIEW' => $access_overview,
                    'PREFERENCES_OVERVIEW' => $oLang->OVERVIEW_PREFERENCES,
                    'SETTINGS_OVERVIEW' => $oLang->OVERVIEW_SETTINGS,
                    'ADMINTOOLS_OVERVIEW' => $oLang->OVERVIEW_ADMINTOOLS
                )
            );

// Parse template object
$template->parse('main', 'main_block', false);
$template->pparse('output', 'page');

// Print admin footer
$admin->print_footer();
