<?php
/**
 *
 * @category        admin
 * @package         users
 * @author          WebsiteBaker Project
 * @copyright       Ryan Djurovich
 * @copyright       WebsiteBaker Org. e.V.
 * @link            http://websitebaker.org/
 * @license         http://www.gnu.org/licenses/gpl.html
 * @platform        WebsiteBaker 2.10.1
 * @requirements    PHP 5.3.6 and higher
 * @version         $Id: add.php 75 2018-09-17 17:26:55Z Luisehahne $
 * @filesource      $HeadURL: svn://isteam.dynxs.de/wb/2.12.x/tags/2.12.1/admin/users/add.php $
 * @lastmodified    $Date: 2018-09-17 19:26:55 +0200 (Mo, 17. Sep 2018) $
 *
 */

// Print admin header
if (!\defined('SYSTEM_RUN')) {require(\dirname(\dirname((__DIR__))).'/config.php');}
// suppress to print the header, so no new FTAN will be set
    $admin = new \admin('Access', 'users_add',false);
    $oTrans = \Translate::getInstance();
    $oTrans->enableAddon(ADMIN_DIRECTORY.'\\users');

    $aInputs = [];
    $groups_id = '';
    $sErrorMessage = '';
    $aErrorMessage = [];
// Create a javascript back link
    $sAddonBackUrl = ADMIN_URL.'/users/index.php';

try {

if( !$admin->checkFTAN() )
{
    $admin->print_header();
    throw new \Exception ($oTrans->MESSAGE_GENERIC_SECURITY_ACCESS);
}
// After check print the header
    $admin->print_header();

//$aInputs = array_merge( $_POST );
    foreach ($_POST as $name=>$value){
        $value = $admin->StripCodeFromText($value);
        switch ($name):
            case 'username_fieldname':
              $username_fieldname = $value;
              $value = $admin->StripCodeFromText($admin->get_post($username_fieldname));
              $username = \preg_replace('/[^a-z0-9&\-.=@_]/i', '',\strtolower($value));
              $aInputs[$username_fieldname] = $username;
              break;
            case 'display_name':
              $display_name = $admin->StripCodeFromText($value);
              $aInputs[$name] = $display_name;
              break;
            case 'password':
              $password = \preg_replace('/[^\x20-\x7E]+$]/', '',$value);
              $aInputs[$name] = $password;
              break;
            case 'password2':
              $password2 = \preg_replace('/[^\x20-\x7E]+$]/', '',$value);
              $aInputs[$name] = $password2;
              break;
            case 'email':
              $email = $value;
              $aInputs[$name] = $email;
              break;
            case 'home_folder':
              $home_folder = $value;
              $aInputs[$name] = $home_folder;
              break;
            case 'groups':
              $aGroups    =  $value;
              $aInputs[$name] = $aGroups;
              $groups_id = (isset($aGroups) ? \implode(",", $aGroups) : '');
              $aInputs['groups_id'] = $groups_id;
              break;
            case 'active':
              $aInputs['active'] = $value;
              $active = \intval( \is_array($aInputs[$name])  ?($aInputs[$name][0]):$aInputs[$name]);
              $aInputs[$name] = $active;
              break;
            default:
        endswitch;
    }

    $_SESSION['users'] = $aInputs;
    $_SESSION['users']['login_name'] = $aInputs[$username_fieldname];

    if (isset($_SESSION['users'])) {
        unset($_SESSION['users'][$username_fieldname]);
        unset($_SESSION['users']['password']);
        unset($_SESSION['users']['password2']);
        unset($aInputs['groups']);
    }

    $default_language = DEFAULT_LANGUAGE;
    $default_timezone = DEFAULT_TIMEZONE;
/*----------------------------------------------------------------------------------------------------*/
    // Check values
    // Check if username already exists
    $sql  = 'SELECT `user_id` FROM `'.TABLE_PREFIX.'users` '
          . 'WHERE `username` = \''.$username.'\' ';
    if ($database->get_one($sql)) {
        $sErrorMessage = $aErrorMessage[] = $oTrans->MESSAGE_USERS_USERNAME_TAKEN;
        throw new \Exception ($sErrorMessage);
    }
    if (!\preg_match('/^[a-z0-9&\-.=@_]{2,}$/i', $username, $match)) {
        $sErrorMessage = $aErrorMessage[] = $oTrans->MESSAGE_USERS_NAME_INVALID_CHARS.'';
        throw new \Exception ($sErrorMessage);
    }
    if (strlen($password) < 2) {
        $sErrorMessage = $aErrorMessage[] = $oTrans->MESSAGE_USERS_PASSWORD_TOO_SHORT;
        throw new \Exception ($sErrorMessage);
    }
    if ($password != $password2) {
        $sErrorMessage = $aErrorMessage[] = $oTrans->MESSAGE_USERS_PASSWORD_MISMATCH;
        throw new \Exception ($sErrorMessage);
    }
    $sql  = 'SELECT COUNT(*) FROM `'.TABLE_PREFIX.'users` ';
    $sql .= 'WHERE  `display_name` LIKE \''.$display_name.'\'';
    if ($database->get_one($sql) > 0) {
        $sErrorMessage = $aErrorMessage[] = ( $oTrans->MESSAGE_USERS_DISPLAYNAME_TAKEN ? : $oTrans->MESSAGE_MEDIA_BLANK_NAME.' ('.$oTrans->TEXT_DISPLAY_NAME.')');
        throw new \Exception ($sErrorMessage);
    }


    if ($email != '')
    {
        // Check if the email already exists
        $sql  = 'SELECT `user_id` FROM `'.TABLE_PREFIX.'users` '
              . 'WHERE `email` = \''.$email.'\' ';
        if ($database->get_one($sql))
        {
            if(isset($oTrans->MESSAGE_USERS_EMAIL_TAKEN))
            {
                $sErrorMessage = $aErrorMessage[] = $oTrans->MESSAGE_USERS_EMAIL_TAKEN;
                throw new \Exception ($sErrorMessage);
            }
            if($admin->validate_email($email) == false)
            {
                $sErrorMessage = $aErrorMessage[] = $oTrans->MESSAGE_USERS_INVALID_EMAIL;
                throw new \Exception ($sErrorMessage);
            }
        }
    } else { // e-mail must be present
        $sErrorMessage = $aErrorMessage[] = $oTrans->MESSAGE_SIGNUP_NO_EMAIL;
        throw new \Exception ($sErrorMessage);
    }
    if($groups_id == '') {
        $sErrorMessage = $aErrorMessage[] = $oTrans->MESSAGE_USERS_NO_GROUP;
        throw new \Exception ($sErrorMessage);
    }
/*----------------------------------------------------------------------------------------------------*/
// choose group_id from groups_id - workaround for still remaining calls to group_id (to be cleaned-up)
    $gid_tmp = \explode(',', $groups_id);
    if (\in_array('1', $gid_tmp)) $group_id = '1'; // if user is in administrator-group, get this group
    else $group_id = $gid_tmp[0]; // else just get the first one
    unset($gid_tmp);

    if (!\sizeof($aErrorMessage)) {
    // MD5 supplied password
    $md5_password = \md5($password);
    $now = \time();
    // Insert the user into the database
    $sql = // add the user
         'INSERT INTO `'.TABLE_PREFIX.'users` SET '
        .    '`group_id`='.\intval($group_id).', '
        .    '`groups_id`=\''.$database->escapeString($groups_id).'\', '
        .    '`active`=\''.$database->escapeString($active).'\', '
        .    '`username`=\''.$database->escapeString($username).'\', '
        .    '`password`=\''.$database->escapeString($md5_password).'\', '
        .    '`remember_key`=\'\', '
        .    '`last_reset`=0, '
        .    '`display_name`=\''.$database->escapeString($display_name).'\', '
        .    '`email`=\''.$database->escapeString($email).'\', '
        .    '`timezone`=\''.$database->escapeString($default_timezone).'\', '
        .    '`date_format`=\''.DEFAULT_DATE_FORMAT.'\', '
        .    '`time_format`=\''.DEFAULT_TIME_FORMAT.'\', '
        .    '`language`=\''.$database->escapeString($default_language).'\', '
        .    '`home_folder`=\''.$database->escapeString($home_folder).'\', '
        .    '`login_when`=\''.$now.'\', '
        .    '`login_ip`=\'\' '
        .    '';
        if (!$database->query($sql)) {}
        if ($database->is_error()) {
            $sErrorMessage = $aErrorMessage[] = $database->get_error();
            throw new \Exception ($sErrorMessage);
        }
    }

    if (isset($_SESSION['users'])) {unset($_SESSION['users']);}
    $admin->print_success($oTrans->MESSAGE_USERS_ADDED, $sAddonBackUrl);

} catch (\Exception $ex) {
    $sAddonBackUrl = ADMIN_URL.'/users/index.php';
    if (!function_exists ('xnl2br')) {require(WB_PATH . '/framework/functions.php');}
    $sErrMsg = xnl2br(\sprintf('[%d] %s', $ex->getLine(), $ex->getMessage()));
    $admin->print_error ($sErrMsg, $sAddonBackUrl);
    exit;
}
// Print admin footer
$admin->print_footer();
