<?php

namespace bin\helpers;

class ParentList
{

// -----------------------------------------------------------------------------
/** prevent class from public instancing and get an object to hold extensions */
    final private function  __construct() {
    }
// -----------------------------------------------------------------------------
/** prevent from cloning existing instance */
    final private function __clone() {}
// -----------------------------------------------------------------------------

/*-------------------------------------------------------------------------------------------*/
    static public function is_serialized($data){
        return (is_string($data) && preg_match("#^((N;)|((a|O|s):[0-9]+:.*[;}])|((b|i|d):[0-9.E-]+;))$#um", $data));
    }

/*-------------------------------------------------------------------------------------------*/
    static public function __unserialize($data) {  // found in php manual :-)
        $aRetval = $data;
        if (self::is_serialized($data)){
            $_ret = preg_replace_callback(
                        '!s:(\d+):"(.*?)";!',
                        function($matches) {return 's:'.strlen($matches[2]).':"'.$matches[2].'";';},
                        $data
                     );
            if ($_ret) {$aRetval = @unserialize($_ret);}
        }
        return $aRetval;
    }

/*-------------------------------------------------------------------------------------------*/
    static public function dsgvoSettings(){
        $oDb = \database::getInstance();
        $sValue = '';
        $sql  = 'SELECT `value` FROM `'.TABLE_PREFIX.'settings` '
              . 'WHERE `name` = \'dsgvo_settings\' ';
        if ($sValue = $oDb->get_one($sql)){;}
        return $sValue;
    }
/*-------------------------------------------------------------------------------------------*/
/*  */

    static public function getDsgvoDefaultLink(){
        $sSettings = self::dsgvoSettings();
        $aSettings = self::__unserialize($sSettings);
        $targetSectionId = $aSettings[LANGUAGE];
        $sDataLink = WB_URL.self::build_access_file($targetSectionId);
        return $sDataLink;
   }

/*-------------------------------------------------------------------------------------------*/
    static public function build_access_file($id=0){
        $oDb   = \database::getInstance();
        $aPage = self::section_picker($id);
        $aRec  = [];
// Query current settings in the db, then loop through them and print them
        $query  = 'SELECT * FROM `'.TABLE_PREFIX.'settings`'
                . 'WHERE `name` IN (\'pages_directory\',\'page_extension\',\'sec_anchor\')';
        if ($oRes  = $oDb->query($query)){
            $aRecs = $oRes->fetchAll(MYSQLI_ASSOC);
            foreach($aRecs as $key => $aVal) {
                $aRec[$aVal['name']] = $aVal['value'];
            }
            $sAnchor = ((trim($aRec['sec_anchor']) === 'none')||($id==0) ? '' : '#'.$aRec['sec_anchor'].$id);
            $sAccessFile = $aRec['pages_directory'].$aPage['link'].$aRec['page_extension'].$sAnchor;
        }
        return $sAccessFile;
    }

/*-------------------------------------------------------------------------------------------*/
    static public function section_picker($id=0){
        $oDb = \database::getInstance();
        $aSectionList = [];
        $table_pages = TABLE_PREFIX."pages";
        $table_sections = TABLE_PREFIX."sections";
        $sUserLang = (\defined('LANGUAGE') ? LANGUAGE : 'EN');
// search valide page
        $sqlWhere = 'WHERE'.(($id != 0) ? '`s`.`section_id` = '.(int)$id.''
                  : '`p`.`parent` = '.(int)$id.'').' AND `p`.`language` = \''.$sUserLang.'\'';
        $sql  = 'SELECT `s`.*, `p`.`link`, `p`.`parent`, `p`.`language` '
              . 'FROM `'.$table_sections.'` s '
              . 'JOIN `'.$table_pages.'` `p` ON (`s`.`page_id` = `p`.`page_id`) '
              . $sqlWhere;
        if (!($oInstances = $oDb->query($sql))) {
            $aErrorMsg[] = $sql.PHP_EOL.$oDb->get_error();
        }
// try to load an existing record
        if (($aRecord = $oInstances->fetchRow(MYSQLI_ASSOC))) {
            $aSectionList = $aRecord;
        }
        return (\sizeof($aSectionList) ? $aSectionList : false);
    }

/*-------------------------------------------------------------------------------------------*/
// this function will fetch the page_tree, recursive
    static public function menulink_make_tree($parent, $tree) {
        global $admin;
        $oDb = \database::getInstance();
        // get list of page-trails, recursive
        $sqlSet = 'SELECT * FROM `'.TABLE_PREFIX.'pages` '
                . ' WHERE `parent`='.(int)$parent.' '
                .    'AND `visibility` NOT IN(\'none\', \'private\', \'deleted\') '
                . ' ORDER BY  `position`'
                . '';
        if ($query_page = $oDb->query($sqlSet)) {
            while($page = $query_page->fetchRow(MYSQLI_ASSOC)) {
                    $tree[$page['page_id']]['menu_title'] = $page['menu_title'];
                    $tree[$page['page_id']]['link']  = $page['link'];  //
                    $tree[$page['page_id']]['level'] = $page['level'];
                    $tree[$page['page_id']]['visibility'] = $page['visibility'];
                    $tree = self::menulink_make_tree($page['page_id'], $tree);
            }
        }
        return($tree);
    }
/*-------------------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------------------*/
    static public function build_sectionlist($parent=0, $this_page=0, &$aSections) {
        $oDb = \database::getInstance();
        $iterated_parents = []; // keep count of already iterated parents to prevent duplicates
        $table_pages = TABLE_PREFIX."pages";
        $table_sections = TABLE_PREFIX."sections";
        if ($query_section_id = $oDb->query("
            SELECT `s`.*, `p`.`link`, `p`.`language`, `p`.`page_title`, `p`.`page_id`, `p`.`level`
            FROM ".$table_sections." s
            JOIN ".$table_pages." `p` ON (`s`.`page_id` = `p`.`page_id`)
            WHERE `p`.`parent` = ".(int)$parent."
              AND `p`.`visibility` IN('hidden', 'public')
            ORDER BY `p`.`level`, `p`.`position` ASC")) {
            while($aRes = $query_section_id->fetchRow(MYSQLI_ASSOC)) {
                $mname = $aRes['module'];
                $mname .= ' ['.((isset($aRes['title']) && $aRes['title']) ? $aRes['title'] : $aRes['section_id']).']';
                if (isset($aRes['namesection']) && $aRes['namesection']){ $mname = $aRes['module'].' ['.$aRes['namesection'].']';}
                $aSections[$aRes['section_id']]['section_id'] = $aRes['section_id'];
                $aSections[$aRes['section_id']]['language'] = $aRes['language'];
                $aSections[$aRes['section_id']]['level'] = $aRes['level'];
                $aSections[$aRes['section_id']]['module'] = $mname;
                $aSections[$aRes['section_id']]['title'] = $aRes['title'];
                $aSections[$aRes['section_id']]['page_title'] = $aRes['page_title'];
                $aSections[$aRes['section_id']]['page_id'] = ''.$aRes['page_id'];
                $aSections[$aRes['section_id']]['this_page'] = ''.$this_page;
                $aSections[$aRes['section_id']]['language'] = ''.$aRes['language'];
/*  */
                if ($aRes['page_id'] != $this_page) {
                    $aSections[$aRes['section_id']]['descr'] = $aRes['section_id'].'|'.str_repeat("-- ",$aRes['level']).$aRes['page_title'].'-- section:'.$mname;
                } else {
                    $aSections[$aRes['section_id']]['descr'] = '|'.\str_repeat("-- ",$aRes['level']).$aRes['page_title'].'-- section:'.$mname;
                }
                if (!\in_array($aRes['page_id'], $iterated_parents)) {
                    self::build_sectionlist($aRes['page_id'], $aRes['page_id'], $aSections);
                    $iterated_parents[] = $aRes['page_id'];
                }
            }
        }
        return($aSections);
    }
/* ---------------------------------------------------------------------------------- */
    static public function tidyFilename($val)
    {
        // whitespace durch Unterstrich ersetzen
    /*
        $sRetval = preg_replace('#(\s+)#', '_', $val);
        $sRetval = preg_replace('/[^A-Za-z0-9]/', '_', $val);
        [<>:"/\\|?*]|            # file system reserved https://en.wikipedia.org/wiki/Filename#Reserved_characters_and_words
    */
        $sRetval = preg_replace(
        '~
        (\s+)|                        # file system reserved
        [\x00-\x1F]|                  # control characters http://msdn.microsoft.com/en-us/library/windows/desktop/aa365247%28v=vs.85%29.aspx
        [\x7F\xA0\xAD]|               # non-printing characters DEL, NO-BREAK SPACE, SOFT HYPHEN
        [#\[\]@!§"$%&\'\?()+,;:=§\/]| # URI reserved https://tools.ietf.org/html/rfc3986#section-2.2
        [{}^\~`]                      # URL unsafe characters https://www.ietf.org/rfc/rfc1738.txt
        ~x',
        '_', $val);
        // Liste aller Umlaute
        $map = array(
                'ä' => 'ae',
                'Ä' => 'ae',
                'ß'=>'ss',
                'ö'=>'oe',
                'Ö' => 'oe',
                'Ü'=>'ue',
                'ü'=>'ue',
                '<'=>'',
                '>'=>'',
                // hier ggf. weitere Zeichen ergänzen, z.B.
                'à' => 'a',
                'é' => 'e',
                'è' => 'e',
            );
//            $sRetval = preg_replace('#^.*?([^/]*?)\.[^\.]*$#i', '\1', $sRetval);
        $sRetval = str_replace('__', '', $sRetval);
        // Umlaute konvertieren
        $sRetval = str_replace(array_keys($map), array_values($map), $sRetval);
        // alle anderen Zeichen verwerfen
    //    $sRetval = preg_replace('#[^a-z0-9_.-]#', '', $sRetval);
        return $sRetval;
    }
}
