<?php
/*
 * Copyright (C) 2018 Dietmar Wöllbrink <dietmar.woellbrink@websitebaker.org>
 *
 * DO NOT ALTER OR REMOVE COPYRIGHT OR THIS HEADER
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, version 2 of the License.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License 2 for more details.
 *
 * You should have received a copy of the GNU General Public License 2
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/**
 * Description of Unbenannt 1
 *
 * @package      core
 * @copyright    Dietmar Wöllbrink <dietmar.woellbrink@websitebaker.org>
 * @author       Dietmar Wöllbrink <dietmar.woellbrink@websitebaker.org>
 * @license      GNU General Public License 2.0
 * @version      0.0.1
 * @revision     $Id: backupMysql.php 68 2018-09-17 16:26:08Z Luisehahne $
 * @since        File available since 12.11.2017
 * @deprecated   no / since 0000/00/00
 * @description  xxx
 */
//declare(strict_types = 1);
//declare(encoding = 'UTF-8');

#namespace backup\lib;

use \backup\text;

    if (!defined('\backup\text\SETNAMES') && is_readable(__DIR__.'/boilerPlates.php')){require __DIR__.'/boilerPlates.php';}
// add given delimter to keys
    if (!function_exists('add_backticks')){
        function addDelimter(&$val, &$key, $vars) { $val = $vars[1].$val.$vars[1]; }
    }

#echo \backup\text\SETNAMES;

  function Export_Database($host,$user,$pass,$name, $sTableFlags = \backup\text\FULL,$tables=[], $sFileName='', $sBackupPath='' )
  {

        $sRetval = false;
        $aValues = [];
        $vars = ['`','`'];
        $sDate = date("Y-m-d").date('_d');

        $sBackupName = (($sFileName!='') ? $sFileName : $name.'_'.$sDate).'.php';
      try {
        if (!defined('\backup\text\SETNAMES') && is_readable(__DIR__.'/boilerPlates.php')){require __DIR__.'/boilerPlates.php';}
        if (!function_exists('make_dir')) {require (WB_PATH.'/framework/functions.php');}
        $sBackupPath = rtrim($sBackupPath,'/');
        make_dir($sBackupPath);
        $sBackupPath .= '/';
        if (!($sRetval = \file_put_contents($sBackupPath.$sBackupName, '-- <?php die(\'Access denied\');?>'.PHP_EOL.\backup\text\SETNAMES))){
            throw new \Exception (sprintf('%s <br />Couldn\'t create %s',\backup\text\SETNAMES, basename($sBackupPath).'/'.$sBackupName));
        }
        $vars = ['`','`'];
        $mysqli = new mysqli($host,$user,$pass,$name);
        $mysqli->select_db($name);
        $mysqli->query("SET NAMES 'utf8'");

        $queryTables = $mysqli->query('SHOW TABLES');
        while($row = $queryTables->fetch_row()) {
            $target_tables[] = $row[0];
        }

        $bCreateSelectedTables = (\is_array($tables) && sizeof($tables) ? true : false);
        if($bCreateSelectedTables) {
            $target_tables = array_intersect( $target_tables, $tables);
        }

        foreach($target_tables as $table)
        {
#            $sTableTitle  = sprintf(\backup\text\TABLETITLE, $table);&\backup\text\FULL
#            $sInsertTitle = sprintf(\backup\text\INSERTTITLE, $table);
            $iFlag = 15;

            $sTableTitle  = '';
            $sInsertDrop  = '';
            $sInsertTitle = '';

            if (($sTableFlags & \backup\text\STRUCT)==\backup\text\STRUCT){
                $sTableTitle  = sprintf(\backup\text\TABLETITLE, $table);
            }
            if (($sTableFlags & \backup\text\DROPTABLE)==\backup\text\DROPTABLE){
                $sInsertDrop  = sprintf(\backup\text\INSERTDROP, $table);
            }
            if (($sTableFlags & \backup\text\DATA)==\backup\text\DATA){
                $sInsertTitle = sprintf(\backup\text\INSERTTITLE, $table);
            }
            if (($sTableFlags & \backup\text\FULL)==\backup\text\FULL){
                $sTableTitle  = sprintf(\backup\text\TABLETITLE, $table);
#                $sInsertDrop  = sprintf(\backup\text\INSERTDROP, $table);
                $sInsertTitle = sprintf(\backup\text\INSERTTITLE, $table);
            }
// CREATE STRUCTURE
            $structure        = (!isset($structure) ?  '' : $structure);
            if ((($sTableFlags & \backup\text\FULL)==\backup\text\FULL)||
                (($sTableFlags & \backup\text\STRUCT)==(\backup\text\STRUCT))){
                $res          = $mysqli->query('SHOW CREATE TABLE `'.$table.'`');
                $TableMLine   = $res->fetch_row();
                $structure    = $structure.$sTableTitle.$sInsertDrop.$TableMLine[1].';'.PHP_EOL.PHP_EOL.$sInsertTitle;
            }
// INSERT INTO
            if ((($sTableFlags & \backup\text\FULL)==(\backup\text\FULL)) ||
                (($sTableFlags & \backup\text\DATA)==(\backup\text\DATA))){
                $sGroup = '';
                $result       = $mysqli->query('SELECT * FROM `'.$table.'`');
                $fields_amount= $result->field_count;
                $rows_num     = $mysqli->affected_rows;

                for ($i = 0, $st_counter = 0; $i < $fields_amount; $i++, $st_counter=0)
                {
//when started (and every after 100 command cycle):
                    while($row = $result->fetch_array(MYSQLI_BOTH))
                    {
                        if ($sGroup != $table){
// change to an associative array
                            $aNumeric = [];
                            for ($i=0; $i<=$fields_amount; $i++) {$aNumeric[]=$i;}
                            $aRows = \array_diff_key($row,$aNumeric);
                            $aFields = \array_keys($aRows);
// add backticks to column
                            $add_backticks =
                            \array_walk(
                                $aFields,
                                function (&$val, &$key) use ($vars) {
                                  $val = $vars[1].$val.$vars[1];
                                });
// prepare column list to add to INSERT INTO
                            $sInserts = ''.\implode(', ', $aFields).') ';
                            $sGroup = $table;
                        }
                        if ($st_counter == 0 ) {
#                        if ($st_counter%100 == 0 || $st_counter == 0 ) {
                            $insert = 'INSERT INTO `'.$table.'` ('.$sInserts.'';
                        }
    // VALUE data row
                        $structure .= $insert.'VALUES (';
                        for($j=0; $j<$fields_amount; $j++) {
                            $aFieldDetails = $result->fetch_field_direct($j);
                            $isInteger = \array_key_exists($aFieldDetails->type, \backup\text\NUMBERTYPES);
                            $row[$j] = \str_replace(["\n","\r"],["\\n","\\r"], \addslashes($row[$j]) );
                            if (!$isInteger) {
                                if (isset($row[$j])) {
                                    $structure .= '\''.$row[$j].'\'';
                                } else {
                                    $structure .= '\'\'';
                                }
                            } else {
                              if (isset($row[$j])){
                                $structure .= $row[$j];
                              } else {
                                  $structure .= 0;
                              }
                            }
                            if ($j<($fields_amount-1)) {
                                $structure.= ', ';
                            }
                        }  // for($j=0; $j<$fields_amount; $j++)
                        $structure .=')';
//    every after 100 command cycle [or at last line] ....p.s. but should be inserted 1 cycle eariler
#                        if ($st_counter+1==$rows_num){
                        if ((($st_counter+1)%100==0 && $st_counter!=0) || $st_counter+1==$rows_num){
                            $structure .= ';'.PHP_EOL;
                        } else {
                            $structure .= ';'.PHP_EOL;
                        }
                        $st_counter++;
                    } // while row
                } // for $fields_amount;
            } // Flag INSERT INTO
            $structure .= PHP_EOL;
        } // foreach $table
        $content = $structure.'-- created '.date("Y-m-d H:i:s").PHP_EOL;
        if (!($sRetval = \file_put_contents($sBackupPath.$sBackupName, $content, FILE_APPEND))){
            throw new \Exception (sprintf('Couldn\'t write  %s',basename($sBackupPath).'/'.$sBackupName));
        }
        echo sprintf('<b>%2$s successfully created</b> at %1$s',date("Y-m-d H:i:s"),basename($sBackupPath).'/'.$sBackupName).'<br />';
        exit;
/*
        header('Content-Type: application/octet-stream');
        header("Content-Transfer-Encoding: Binary");
        header("Content-disposition: attachment; filename=\"".$backup_name."\"");
*/
      } catch (\Exception $ex) {
          $sErrMsg = (\sprintf('[%d] %s', $ex->getLine(), $ex->getMessage()));
#          echo (nl2br($sResult, !defined('XHTML'))).PHP_EOL;
          echo \preg_replace('/[\n\r]/', '',\nl2br($sErrMsg, !\defined('XHTML')));
          exit;
      }
  }

/*-----------------------------------------------------------------------------*/

/*-----------------------------------------------------------------------------*/
    if (!defined('SYSTEM_RUN')) {require( (dirname(dirname((__DIR__)))).'/config.php');}

    $sBackupPath =str_replace(DIRECTORY_SEPARATOR, '/', WB_PATH).'/backup';

//  \backup\text\DATA | \backup\text\FULL | \backup\text\STRUCT | \backup\text\DROPTABLE,
//  multiple tables
    Export_Database(
          DB_HOST,
          DB_USERNAME,
          DB_PASSWORD,
          DB_NAME,
         \backup\text\FULL|\backup\text\DROPTABLE,
          [
//            'wb_mod_procalendar_settings',
//            'wb_mod_procalendar_eventgroups',
//            'wb_mod_procalendar_actions'
          ],
          '',
          $sBackupPath
    );

/*
    Export_Database(
        DB_HOST,
        DB_USERNAME,
        DB_PASSWORD,
        DB_NAME,
        [],
        false,
    );
*/

// end of file
