<?php
/*
 * Copyright (C) 2017 Manuela v.d.Decken <manuela@isteam.de>
 *
 * DO NOT ALTER OR REMOVE COPYRIGHT OR THIS HEADER
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, version 2 of the License.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License 2 for more details.
 *
 * You should have received a copy of the GNU General Public License 2
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/**
 * Description of captcha.php
 *
 * @package      Core
 * @copyright    Manuela v.d.Decken <manuela@isteam.de>
 * @author       Manuela v.d.Decken <manuela@isteam.de>
 * @license      GNU General Public License 2.0
 * @version      2.0.1
 * @revision     $Id: captcha.php 68 2018-09-17 16:26:08Z Luisehahne $
 * @since        File available since 04.10.2017
 * @deprecated   no
 * @description  xxx
 */
//declare(strict_types = 1);
//declare(encoding = 'UTF-8');

//namespace ;

// use

// displays the image or text inside an <iframe>
if(!function_exists('display_captcha_real')) {
    function display_captcha_real($kind='image') {
        $sec_id = '';
        if(isset($_GET['s'])){ $sec_id = (int)$_GET['s'];}
//        if(isset($_GET['cap'])){ $cap  = ($_GET['cap']);}
        $_SESSION['captcha'.$sec_id] = '';
        $t = time();
/*
        $output  = "<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Transitional//EN\" ";
        $output .= "\"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd\">\n";
        $output .= "<html xmlns=\"http://www.w3.org/1999/xhtml\" xml:lang=\"";
        $output .= strtolower(LANGUAGE)."\" lang=\"".strtolower(LANGUAGE)."\">\n";
        $output .= "\t<head>\n\t\t<meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\"/>\n";
        $output .= "\t\t<title>captcha</title>\n\t</head>\n\t<body style=\"margin: 0.925em auto;\">\n";
*/
$output  = '
<!DOCTYPE HTML>
<html lang="en">
    <head>
        <meta charset="utf-8">
        <title>captcha</title>
        <link rel="stylesheet" type="text/css" href="/templates/DefaultTemplate/css/3/w3.css" media="screen" />
    </head>
    <body style="margin: 0.925em auto;">
';

$output  .= '
        <div class="display-middle" id="sec'.$sec_id.'">
';

        $_SESSION['captcha_time'] = $t;
        if($kind=='image') {
$output .= '
            <a title="reload" href="'.WB_URL.'/include/captcha/captcha.php?display_captcha_X986E21=2&s='.$sec_id.'">
                <img src="'.WB_URL.'/include/captcha/captchas/'.CAPTCHA_TYPE.'.php?t='.$t.'" alt="Captcha" />
            </a>
';
        } else {
$output .= '
          <h2>Captcha error</h2>
';
        }
$output .= '
        </div>
    </body>
</html>
';
        echo $output;
    }
}

// called from an <iframe> deprecated
if (isset($_GET['display_captcha_X986E21'])) {
    require( dirname(dirname(__DIR__)).'/config.php');
    switch(CAPTCHA_TYPE) {
        case 'calc_image':
        case 'calc_ttf_image':
        case 'ttf_image':
        case 'old_image':
            display_captcha_real('image');
            break;
    }
    exit(0);
}

// Make sure page cannot be accessed directly
if (!defined('SYSTEM_RUN')) { header($_SERVER['SERVER_PROTOCOL'].' 404 Not Found'); flush(); exit; }

// check if module language file exists for the language set by the user (e.g. DE, EN)
// no module language file exists for the language set by the user, include default module language file EN.php
$sAbsAddonPath = WB_PATH.'/modules/captcha_control/';
if (is_readable($sAbsAddonPath.'/languages/EN.php')) {require($sAbsAddonPath.'/languages/EN.php');}
if (is_readable($sAbsAddonPath.'/languages/'.DEFAULT_LANGUAGE.'.php')) {require($sAbsAddonPath.'/languages/'.DEFAULT_LANGUAGE.'.php');}
if (is_readable($sAbsAddonPath.'/languages/'.LANGUAGE.'.php')) {require($sAbsAddonPath.'/languages/'.LANGUAGE.'.php');}

global $MOD_CAPTCHA,$MOD_CAPTCHA_CONTROL,$sec_id;

// output-handler for image-captchas to determine size of image
if(!function_exists('captcha_header')) {
    function captcha_header() {
        header("Expires: Mon, 1 Jan 1990 05:00:00 GMT");
        header("Last-Modified: ".gmdate("D, d M Y H:i:s")." GMT");
        header("Cache-Control: no-store, no-cache, must-revalidate, proxy-revalidate");
        header("Pragma: no-cache");
        header("Content-type: image/png");
        return;
    }
}

// get list of available CAPTCHAS for the dropdown-listbox in admin-tools
if(extension_loaded('gd') && function_exists('imagepng') && function_exists('imagettftext')) {
    $useable_captchas = array(
        'calc_text'      => $MOD_CAPTCHA_CONTROL['CALC_TEXT'],
        'calc_image'     => $MOD_CAPTCHA_CONTROL['CALC_IMAGE'],
        'calc_ttf_image' => $MOD_CAPTCHA_CONTROL['CALC_TTF_IMAGE'],
        'ttf_image'      => $MOD_CAPTCHA_CONTROL['TTF_IMAGE'],
//        'old_image'      => $MOD_CAPTCHA_CONTROL['OLD_IMAGE'],
        'text'           => $MOD_CAPTCHA_CONTROL['TEXT']
    );
} elseif(extension_loaded('gd') && function_exists('imagepng')) {
    $useable_captchas = array(
        'calc_text'      => $MOD_CAPTCHA_CONTROL['CALC_TEXT'],
        'calc_image'     => $MOD_CAPTCHA_CONTROL['CALC_IMAGE'],
//        'old_image'      => $MOD_CAPTCHA_CONTROL['OLD_IMAGE'],
        'text'           => $MOD_CAPTCHA_CONTROL['TEXT']
    );
} else {
    $useable_captchas = array(
        'calc_text'      => $MOD_CAPTCHA_CONTROL['CALC_TEXT'],
        'text'           => $MOD_CAPTCHA_CONTROL['TEXT']
    );
}

if(!function_exists('call_captcha')) {
    function call_captcha($action='all', $style='', $sec_id='',$bPrint=true, $col=1) {
        global $MOD_CAPTCHA,$MOD_CAPTCHA_CONTROL;

        ob_start();
        $t = time();
        $_SESSION['captcha_time'] = $t;
        $retVal = '';
        // get width and height of captcha image for use in <iframe>
        $captcha_width  = 250;
        $captcha_height =  54;
        switch(CAPTCHA_TYPE) {
        case 'calc_image':
            break;
        case 'calc_ttf_image':
            break;
        case 'ttf_image':
            break;
        case 'old_image':
            break;
        default:
            $captcha_width  = 250;
            $captcha_height = 54;
        }
//        $sFtan = \bin\SecureTokens::getFTAN();
//        $sFtan = $admin->getFTAN();
/*
        $sFtanQuery = $sFtan['name']=$sFtan['value'];
*/
        if ($action=='all') {
            switch(CAPTCHA_TYPE) {
              case 'text': // text-captcha
                    ?><div class="captcha_table" style="width: 100%; margin-top: 0.825em;" >
                      <div class="text_captcha <?php echo CAPTCHA_TYPE;?>" >
                      <?php include(WB_PATH.'/include/captcha/captchas/'.CAPTCHA_TYPE.'.php'); ?></div>
                      <div style="width:100%"><input type="text" name="captcha" maxlength="50"  /></div>
                      <div class="captcha_expl" ><?php echo $MOD_CAPTCHA['VERIFICATION_INFO_QUEST']; ?></div>
                    </div><?php
                    break;
                case 'calc_text': // calculation as text
                    ?><div class="captcha_table" style="width: 100%; margin-top: 0.825em;">
                        <div class="text_captcha medium  <?php echo CAPTCHA_TYPE;?>" style="min-height: <?php echo $captcha_height;?>px;">
                            <?php include(WB_PATH.'/include/captcha/captchas/'.CAPTCHA_TYPE.'.php'); ?>
                            <a style="cursor: pointer;" onclick="window.location.reload()">
                            <img alt="" src="<?php echo WB_URL.'/include/captcha/captchas/create_'.CAPTCHA_TYPE.'.php?cap='.$cap.'&amp;col='.$col;?>" />
                            </a>
                        </div>
                        <div class="captcha-input"><input value="" type="text" name="captcha" maxlength="10" /></div>
                        <div class="captcha_expl"><?php echo $MOD_CAPTCHA['VERIFICATION_INFO_RES']; ?></div>
                    </div><?php
                    break;
                case 'calc_image': // calculation with image (old captcha)
                case 'calc_ttf_image': // calculation with varying background and ttf-font
                  ?><div class="captcha_table" style="width: 100%; margin-top: 0.825em; ">
                    <div class="image_captcha  <?php echo CAPTCHA_TYPE;?>" style="max-width: <?php echo $captcha_width+20;?>px;min-height: <?php echo $captcha_height;?>px;">
                            <?php include(WB_PATH.'/include/captcha/captchas/'.CAPTCHA_TYPE.'.php'); ?>
                            <a style="cursor: pointer;" onclick="window.location.reload()">
                            <img alt="" src="<?php echo WB_URL.'/include/captcha/captchas/create_'.CAPTCHA_TYPE.'.php?cap='.$cap;?>"/>
                            </a>
                    </div>
                    <div class="captcha-input"><input type="text" name="captcha" maxlength="10" />
                    <label class="captcha_expl" style="display: inline;"><?php echo $MOD_CAPTCHA['VERIFICATION_INFO_RES']; ?></label></div>
                   </div><?php
                    break;
                // normal images
                case 'old_image': // old captcha
                    break;
                case 'ttf_image': // captcha with varying background and ttf-font
//                  $sIframeUrl = WB_URL . '/include/captcha/captcha.php?display_captcha_X986E21=1&amp;s='.$sec_id;
                  ?><div class="captcha_table" style="width: 100%; margin-top: 0.825em;">
                    <div class="image_captcha  <?php echo CAPTCHA_TYPE;?>" style="max-width: <?php echo $captcha_width+20;?>px;min-height: <?php echo $captcha_height;?>px;">
                        <?php include(WB_PATH.'/include/captcha/captchas/'.CAPTCHA_TYPE.'.php'); ?>
                        <a style="cursor: pointer;" onclick="window.location.reload()">
                        <img alt="" src="<?php echo WB_URL.'/include/captcha/captchas/create_'.CAPTCHA_TYPE.'.php?text='.$cap;?>"/>
                        </a>
                    </div>
                    <div><input type="text" name="captcha" maxlength="10" />
                    <label class="captcha_expl" style="display: block;"><?php echo $MOD_CAPTCHA['VERIFICATION_INFO_TEXT']; ?></label></div>
                   </div><?php
                    break;
            }
        } elseif($action=='image') {
            switch(CAPTCHA_TYPE) {
                case 'text': // text-captcha
                case 'calc_text': // calculation as text
                    break;
                    echo ($style?"<span $style>":'');
                    include(WB_PATH.'/include/captcha/captchas/'.CAPTCHA_TYPE.'.php');
                    echo ($style?'</span>':'');
                case 'calc_image': // calculation with image (old captcha)
                case 'calc_ttf_image': // calculation with varying background and ttf-font
                case 'ttf_image': // captcha with varying background and ttf-font
                case 'old_image': // old captcha
                    break;
                    echo "<img $style src=\"".WB_URL.'/include/captcha/captchas/'.CAPTCHA_TYPE.".php?t=$t&s=$sec_id\" />";
            }
        } elseif($action=='image_iframe') {
            switch(CAPTCHA_TYPE) {
                case 'text': // text-captcha
                    echo ($style?"<span $style>":'');
?>
                      <?php include(WB_PATH.'/include/captcha/captchas/'.CAPTCHA_TYPE.'.php'); ?>
                      <a style="cursor: pointer;" onclick="window.location.reload()">
                      <img alt="<?php echo rawurldecode($cap);?>" src="<?php echo WB_URL.'/include/captcha/captchas/create_'.CAPTCHA_TYPE.'.php?cap='.$cap;?>"/>
                      </a>
<?php
                    echo ($style?'</span>':'');
                    break;
                case 'calc_text': // calculation as text
?>
                      <?php include(WB_PATH.'/include/captcha/captchas/'.CAPTCHA_TYPE.'.php'); ?>
                      <a style="cursor: pointer;" onclick="window.location.reload()">
                      <img alt="<?php echo rawurldecode($cap);?>" src="<?php echo WB_URL.'/include/captcha/captchas/create_'.CAPTCHA_TYPE.'.php?cap='.$cap;?>"/>
                      </a>
<?php
                    break;
                case 'calc_image': // calculation with image (old captcha)
                case 'calc_ttf_image': // calculation with varying background and ttf-font
                case 'ttf_image': // captcha with varying background and ttf-font
                case 'old_image': // old captcha
?>
                      <?php include(WB_PATH.'/include/captcha/captchas/'.CAPTCHA_TYPE.'.php'); ?>
                      <a style="cursor: pointer;" onclick="window.location.reload()">
                      <img alt="<?php echo rawurldecode($cap);?>" src="<?php echo WB_URL.'/include/captcha/captchas/create_'.CAPTCHA_TYPE.'.php?cap='.$cap;?>"/>
                      </a>
<?php
                    break;
            }
        } elseif($action=='input') {
            switch(CAPTCHA_TYPE) {
                case 'text': // text-captcha
                    echo '<input type="text" name="captcha" '.($style?$style:'style="width:150px;" maxlength="50"').' />';
                    break;
                case 'calc_text': // calculation as text
                case 'calc_image': // calculation with image (old captcha)
                case 'calc_ttf_image': // calculation with varying background and ttf-font
                    echo '<input type="text" name="captcha" '.($style?$style:'style="width:20px;" maxlength="10"').' />';
                    break;
                case 'ttf_image': // captcha with varying background and ttf-font
                case 'old_image': // old captcha
                    echo '<input type="text" name="captcha" '.($style?$style:'style="width:50px;" maxlength="10"').' />';
                    break;
            }
        } elseif($action=='text') {
            echo ($style?"<span $style>":'');
            switch(CAPTCHA_TYPE) {
                case 'text': // text-captcha
                    echo $MOD_CAPTCHA['VERIFICATION_INFO_QUEST'];
                    break;
                case 'calc_text': // calculation as text
                case 'calc_image': // calculation with image (old captcha)
                case 'calc_ttf_image': // calculation with varying background and ttf-font
                    echo $MOD_CAPTCHA['VERIFICATION_INFO_RES'];
                    break;
                case 'ttf_image': // captcha with varying background and ttf-font
                case 'old_image': // old captcha
                    echo $MOD_CAPTCHA['VERIFICATION_INFO_TEXT'];
                    break;
            }
            echo ($style?'</span>':'');
        }
        $retVal = ob_get_clean();
        if ($bPrint){echo $retVal;} else {return $retVal;}
    }
}
