<?php
/**
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Description of Translate
 *
 * @category     Addon
 * @package      Addon package
 * @subpackage   Name of subpackage if needed
 * @copyright    Dietmar Wöllbrink <dietmar.woellbrink@websitebaker@org>
 * @author       Manuela v.d.Decken <manuela@isteam.de>
 * @author       Dietmar Wöllbrink <dietmar.woellbrink@websitebaker@org>
 * @license      GNU General Public License 3.0
 * @version      1.0.0-dev.1
 * @revision     $Revision: 136 $
 * @lastmodified $Date: 2018-10-01 21:10:54 +0200 (Mo, 01. Okt 2018) $
 * @since        File available since 02.12.2017
 * @deprecated   no
 * @description  xxx
 */

if (!\defined('SYSTEM_RUN')) {\header($_SERVER['SERVER_PROTOCOL'].' 404 Not Found'); echo '404 File not found'; \flush(); exit;}

if (!\function_exists('LangPageId')){
    function LangPageId($sLang){
        global $wb;
        $sLang = \strtoupper($sLang);
        if (\is_readable(dirname(__DIR__).'/SimpleRegister.php')){
          require \dirname(__DIR__).'/SimpleRegister.php';
        } else {
            throw new \Exception('Call of an invalid WebsiteBaker Version ['.WB_VERSION.' '.WB_SP.'] failed!');
        }
// have to be enabled
        if (!$oReg->PageLanguages) {return false;}
        $oReg->PageLanguages = \filter_var($oReg->PageLanguages, \FILTER_VALIDATE_BOOLEAN);
        $oPageLang = new \addon\WBLingual\Lingual($oReg);
        $aLink = $oPageLang->getPageLangDetails();
// return page_id given by $sLang || valide page_id
        return (isset($aLink[$sLang])? $aLink[$sLang]['page_id'] : $oReg->App->page_id );
    }
}

if (!\function_exists('language_menu'))
{
    function language_menu($sExtension = "auto", $bOutput=true)
    {
        if (\is_readable(dirname(__DIR__).'/SimpleRegister.php')){
          require \dirname(__DIR__).'/SimpleRegister.php';
        } else {
            throw new \Exception('Call of an invalid WebsiteBaker Version ['.WB_VERSION.' '.WB_SP.'] failed!');
        }

        $oReg->PageLanguages = \filter_var($oReg->PageLanguages, \FILTER_VALIDATE_BOOLEAN);
        if (!$oReg->PageLanguages) {return false;}
        $sExtension = \strtolower($sExtension);
        switch($sExtension)
        {
            case 'gif':
            case 'png':
            case 'svg':
                break;
            default:
                $sExtension = 'auto';
        }
        $oPageLang = new \addon\WBLingual\Lingual($oReg);
        $oPageLang->setExtension($sExtension);
        $sRetVal = \trim($oPageLang->getLangMenu());
        if ($bOutput){echo $sRetVal;}
        return $sRetVal;
    }
}
