<?php
/**
 *
 * @category        modules
 * @package         captcha_control
 * @author          WebsiteBaker Project
 * @copyright       WebsiteBaker Org. e.V.
 * @link            http://websitebaker.org/
 * @license         http://www.gnu.org/licenses/gpl.html
 * @platform        WebsiteBaker 2.8.3
 * @requirements    PHP 5.3.6 and higher
 * @version         $Id: tool.php 87 2018-09-17 20:32:28Z Luisehahne $
 * @filesource      $HeadURL: svn://isteam.dynxs.de/wb/2.12.x/tags/2.12.1/modules/captcha_control/tool.php $
 * @lastmodified    $Date: 2018-09-17 22:32:28 +0200 (Mo, 17. Sep 2018) $
 *
 */

// prevent this file from being accessed directly
/* -------------------------------------------------------- */
// Must include code to stop this file being accessed directly
if (!defined('SYSTEM_RUN')) {header($_SERVER['SERVER_PROTOCOL'].' 404 Not Found'); echo '404 File not found'; flush(); exit;}
/* -------------------------------------------------------- */
// check if module language file exists for the language set by the user (e.g. DE, EN)
    $sAddonsPath = basename(__DIR__);
    $sModulName = $sAddonsPath;
    if (is_readable(__DIR__.'/languages/EN.php')) {require(__DIR__.'/languages/EN.php');}
    if (is_readable(__DIR__.'/languages/'.DEFAULT_LANGUAGE.'.php')) {require(__DIR__.'/languages/'.DEFAULT_LANGUAGE.'.php');}
    if (is_readable(__DIR__.'/languages/'.LANGUAGE.'.php')) {require(__DIR__.'/languages/'.LANGUAGE.'.php');}

    $oTrans = Translate::getInstance();
    $oTrans->enableAddon('modules\\'.$sAddonsPath);

    $js_back = ADMIN_URL.'/admintools/tool.php';
    $ToolUrl = ADMIN_URL.'/admintools/tool.php?tool=captcha_control';
    if (!$admin->get_permission($sModulName,'module' ) ) {
        $admin->print_error($MESSAGE['ADMIN_INSUFFICIENT_PRIVELLIGES'], $js_back);
    }

    $table = TABLE_PREFIX.'mod_captcha_control';

// check if data was submitted
    if ($doSave) {
        if (!$admin->checkFTAN()){
        // show title if not function 'save' is requested
            if(!$admin_header) { $admin->print_header(); }
         // show title if not function 'save' is requested
            print '<h4 style="margin:0!important;font-size:1.25em!important;"><a href="'.ADMIN_URL.'/admintools/index.php" '.
                  'title="'.$HEADING['ADMINISTRATION_TOOLS'].'">'.
                  $HEADING['ADMINISTRATION_TOOLS'].'</a>'.
                  '&nbsp;&raquo;&nbsp;'.$toolName.'</h4>'."\n";
            $admin->print_error($MESSAGE['GENERIC_SECURITY_ACCESS'], $js_back );
        }
        // get configuration settings
        $enabled_captcha = (isset($_POST['enabled_captcha']) && $_POST['enabled_captcha'] == '1') ? '1' : '0';
        $enabled_asp = (isset($_POST['enabled_asp']) && $_POST['enabled_asp'] == '1') ? '1' : '0';
        $captcha_type = $admin->StripCodeFromText($admin->get_post('captcha_type'));
        $ct_color = abs($admin->StripCodeFromText($admin->get_post('ct_color')));
        // update database settings
        $sql_captcha = '';
        if($captcha_type == 'text') { // ct_text
            $text_qa = isset($_POST['text_qa']) ? $_POST['text_qa'] :'calc_text';
            if(!preg_match('/### .*? ###/isU', $text_qa)) {
                $sql_captcha = ', `ct_text` = \''.$database->escapeString($text_qa).'\' ';
            }
        }

        $sqlSet  = '`'.TABLE_PREFIX.'mod_captcha_control` SET '
              .'`enabled_captcha` = '.$database->escapeString($enabled_captcha).', '
              .'`enabled_asp` = '.$database->escapeString($enabled_asp).', '
              .'`captcha_type` = \''.$database->escapeString($captcha_type).'\', '
              .'`ct_color` = '.(int)$ct_color.' '
              .$sql_captcha;
        $sql = 'SELECT COUNT(*) FROM `'.TABLE_PREFIX.'mod_captcha_control`';
        if ($database->get_one($sql)) {
        // if matching record already exists run UPDATE
            $sql  = 'UPDATE '.$sqlSet;
        } else {
        // if no matching record exists INSERT new record
            $sql = 'INSERT INTO '.$sqlSet;
        }
        // check if there is a database error, otherwise say successful
        if (!$database->query($sql)){
            $aErrorMessage[] = $database->get_error();
        }
    //  show title if not function 'save' is requested
        if(!$admin_header) { $admin->print_header(); }
         // show title if not function 'save' is requested
            print '<h4 style="margin:0!important;font-size:1.25em!important;"><a href="'.ADMIN_URL.'/admintools/index.php" '.
                  'title="'.$HEADING['ADMINISTRATION_TOOLS'].'">'.
                  $HEADING['ADMINISTRATION_TOOLS'].'</a>'.
                  '&nbsp;&raquo;&nbsp;'.$toolName.'</h4>'."\n";

        if($database->is_error()) {
//            echo $admin->format_message($database->get_error(),'error', $ToolUrl);
            $admin->print_error($database->get_error(), $ToolUrl);
        } else {
//            echo $admin->format_message($MESSAGE['PAGES_SAVED'],'ok', $ToolUrl);
            $admin->print_success($MESSAGE['PAGES_SAVED'], $ToolUrl);
        }

    }
    // include captcha-file
    if (!function_exists('call_captcha')){require(WB_PATH .'/include/captcha/captcha.php');}

    // load text-captchas
    $text_qa='';
    if($query = $database->query("SELECT `ct_text` FROM `$table`")) {
        $data = $query->fetchRow(MYSQLI_ASSOC);
        $text_qa = $data['ct_text'];
    }
    if($text_qa == '')
        $text_qa = $MOD_CAPTCHA_CONTROL['CAPTCHA_TEXT_DESC'];

// script to load image
?>
<script>
    var pics = new Array();

    pics["ttf_image"] = new Image();
    pics["ttf_image"].src = "<?php echo WB_URL.'/include/captcha/captchas/ttf_image.png'?>";

    pics["calc_image"] = new Image();
    pics["calc_image"].src = "<?php echo WB_URL.'/include/captcha/captchas/calc_image.png'?>";

    pics["calc_ttf_image"] = new Image();
    pics["calc_ttf_image"].src = "<?php echo WB_URL.'/include/captcha/captchas/calc_ttf_image.png'?>";

    pics["old_image"] = new Image();
    pics["old_image"].src = "<?php echo WB_URL.'/include/captcha/captchas/old_image.png'?>";

    pics["calc_text"] = new Image();
    pics["calc_text"].src = "<?php echo WB_URL.'/include/captcha/captchas/calc_text.png'?>";

    pics["text"] = new Image();
    pics["text"].src = "<?php echo WB_URL.'/include/captcha/captchas/text.png'?>";
    function load_captcha_image() {
        var captcha = document.querySelector('form#store_settings').captcha_type.value,
            example = document.getElementById('captcha_example');
        example.src = pics[captcha].src;
//console.log(captcha) ;
        toggle_text_color();
        toggle_text_qa();
    }

    function toggle_text_color() {
        if(document.querySelector('form#store_settings').captcha_type.value == 'calc_text' ) {
            document.getElementById('text_color').style.display = '';
        } else {
            document.getElementById('text_color').style.display = 'none';
        }
    }

    function toggle_text_qa() {
        if(document.querySelector('form#store_settings').captcha_type.value == 'text' ) {
            document.getElementById('text_qa').style.display = '';
        } else {
            document.getElementById('text_qa').style.display = 'none';
        }
    }

</script>
<?php

    // connect to database and read out captcha settings
    if($query = $database->query("SELECT * FROM $table")) {
        $data = $query->fetchRow(MYSQLI_ASSOC);
        $enabled_captcha = $data['enabled_captcha'];
        $enabled_asp = $data['enabled_asp'];
        $captcha_type = $data['captcha_type'];
        $ct_color = $data['ct_color'];
    } else {
        // something went wrong, use dummy value
        $enabled_captcha = '1';
        $enabled_asp = '1';
        $captcha_type = 'calc_text';
        $ct_color = '1';
    }
?>
<div class="block-outer">
    <h2> <?php echo $MOD_CAPTCHA_CONTROL['HEADING'];?></h2>
    <p> <?php echo $MOD_CAPTCHA_CONTROL['HOWTO'];?></p>
    <h4 class="w3-text-indigo  w3-large"><?php echo $MOD_CAPTCHA_CONTROL['CAPTCHA_CONF'];?></h4>
            <div class="w3-container">
                <div class="w3-rest w3-panel w3-leftbar w3-sand w3-large w3-serif ">
                    <p><?php echo $MOD_CAPTCHA_CONTROL['CAPTCHA_EXP'];?></p>
                </div>
            </div>

    <form id="store_settings" action="<?php echo $ToolUrl; ?>" method="post">
        <?php echo $admin->getFTAN(); ?>
            <div class="w3-container">
                <div class="w3-third cpt-setting_name">
                  <?php echo $MOD_CAPTCHA_CONTROL['CAPTCHA_TYPE'];?>&nbsp;
                </div>
                <div class="w3-quarter">
                  <select class="w3-select w3-border" name="captcha_type" id="captcha_type" onchange="load_captcha_image()" style="width: 98%;">
            <?php foreach($useable_captchas AS $key=>$text) {
              $sSelected = (($captcha_type==$key)?'selected="selected"':'');
              ?>
                  <option value="<?php echo $key;?>" <?php echo $sSelected;?>><?php echo $text;?></option>
            <?php } ?>
                  </select>
                </div>

            <div class="w3-quarter">
                    <img alt="captcha_example" id="captcha_example" height="40" src="<?php echo WB_URL.'/include/captcha/captchas/'.$captcha_type.'.png'?>" />
            </div>
            </div>

            <div class="w3-container w3-padding" id="text_qa" style="display:<?php if($captcha_type=='text'){ echo '';} else {echo 'none';}?>;">
                <div class="w3-third cpt-setting_name">
        <?php echo $MOD_CAPTCHA_CONTROL['CAPTCHA_ENTER_TEXT'];?>&nbsp;
                </div>
                <div class="w3-quarter">
                  <textarea name="text_qa" cols="60" rows="10"><?php echo $text_qa; ?></textarea>
                </div>
            </div>

            <div class="w3-container w3-padding">
                <div class="w3-third cpt-setting_name w3-padding">
                  <?php echo $MOD_CAPTCHA_CONTROL['USE_SIGNUP_CAPTCHA'];?>&nbsp;
                </div>
                <div class="w3-quarter">
                    <input class="w3-radio w3-padding" type="radio" <?php echo ($enabled_captcha=='1') ?'checked="checked"' :'';?> id="enable_captcha" name="enabled_captcha" value="1" />
                <label class="w3-validate" for="enable_captcha"><?php echo $MOD_CAPTCHA_CONTROL['ENABLED'];?></label>
                    <input class="w3-radio w3-padding" type="radio" <?php echo ($enabled_captcha=='0') ?'checked="checked"' :'';?> id="disable_captcha" name="enabled_captcha" value="0" />
                <label class="w3-validate" for="disable_captcha"><?php echo $MOD_CAPTCHA_CONTROL['DISABLED'];?></label>
                </div>
            </div>
            <div class="w3-container w3-padding" id="text_color" style="display:<?php if ($captcha_type=='calc_text'){ echo '';} else {echo 'none';}?>;;">
                <div class="w3-third cpt-setting_name w3-padding">
                  <?php echo $MOD_CAPTCHA_CONTROL['USE_COLOR_CAPTCHA'];?>&nbsp;
                </div>
                <div class="w3-quarter">
                    <input class="w3-radio w3-padding" type="radio" <?php echo ($ct_color=='1') ?'checked="checked"' :'';?> id="text_white" name="ct_color" value="1" />
                <label class="w3-validate" for="text_white"><?php echo $MOD_CAPTCHA_CONTROL['USE_COLOR_CAPTCHA_BLACK'];?></label>
                    <input class="w3-radio w3-padding" type="radio" <?php echo ($ct_color=='0') ?'checked="checked"' :'';?> id="text_black" name="ct_color" value="0" />
                <label class="w3-validate" for="text_black"><?php echo $MOD_CAPTCHA_CONTROL['USE_COLOR_CAPTCHA_WHITE'];?></label>
                </div>
            </div>
            <div class="w3-container w3-padding">&nbsp;
            </div>
            <h4 class="w3-text-indigo"><?php echo $MOD_CAPTCHA_CONTROL['ASP_CONF'];?></h4>
            <div class="w3-container w3-padding">
                <div class="w3-rest w3-panel w3-leftbar w3-sand w3-large w3-serif">
        <p><?php echo $MOD_CAPTCHA_CONTROL['ASP_EXP'];?></p>
                </div>
            </div>
            <div class="w3-container w3-padding">
                <div class="w3-third cpt-setting_name">&nbsp;
        <?php echo $MOD_CAPTCHA_CONTROL['ASP_TEXT'];?>&nbsp;
                </div>
                <div class="w3-quarter">
            <input class="w3-radio" type="radio" <?php echo ($enabled_asp=='1') ?'checked="checked"' :'';?> id="enable_asp" name="enabled_asp" value="1" />
                <label class="w3-validate" for="enable_asp"><?php echo $MOD_CAPTCHA_CONTROL['ENABLED'];?></label>
            <input class="w3-radio" type="radio" <?php echo ($enabled_asp=='0') ?'checked="checked"' :'';?> id="disable_asp" name="enabled_asp" value="0" />
                <label class="w3-validate" for="disable_asp"><?php echo $MOD_CAPTCHA_CONTROL['DISABLED'];?></label>
                </div>
            </div>

            <div class="w3-container w3-padding-8">
                <div class="w3-quarter">
                    <input type="submit" name="SaveSettings" class="btn w3-blue-wb w3-hover-green" value="<?php echo $TEXT['SAVE']; ?>" />
                </div>
                <div class="w3-quarter">&nbsp;
                </div>
            </div>

</form>
</div>
