<?php
/**
 *
 * @category        modules
 * @package
 * @subpackage
 * @author          WebsiteBaker Project
 * @copyright       WebsiteBaker Org. e.V.
 * @link            http://websitebaker.org/
 * @license         http://www.gnu.org/licenses/gpl.html
 * @platform        WebsiteBaker 2.8.3
 * @requirements    PHP 5.3.6 and higher
 * @version         $Id: upgrade.php 121 2018-09-28 18:50:28Z Luisehahne $
 * @filesource      $HeadURL: svn://isteam.dynxs.de/wb/2.12.x/tags/2.12.1/modules/captcha_control/upgrade.php $
 * @lastmodified    $Date: 2018-09-28 20:50:28 +0200 (Fr, 28. Sep 2018) $
 *
 */
/* -------------------------------------------------------- */
// Must include code to stop this file being accessed directly
if (!defined('SYSTEM_RUN')) { header($_SERVER['SERVER_PROTOCOL'].' 404 Not Found'); echo '404 File not found'; flush(); exit;}
/* -------------------------------------------------------- */
if (!function_exists('rm_full_dir')){require WB_PATH.'/framework/functions.php';}

if (!function_exists('mod_captcha_control_upgrade')){
    function mod_captcha_control_upgrade($bDebug=false) {
        global $OK ,$FAIL;
        $oDb = ( $GLOBALS['database'] ?: null );
        $msg = [];
        $aOutputMsg = [];
        $sAddonPath = __DIR__;
        $sAddonName = basename($sAddonPath);
// check if upgrade startet by upgrade-script to echo a message
        $globalStarted = preg_match('/upgrade\-script\.php$/', $_SERVER["SCRIPT_NAME"]);
        $sWbVersion = ($globalStarted && defined('VERSION') ? VERSION : WB_VERSION);
        if (version_compare($sWbVersion, '2.11.0', '<')){
            throw new Exception ('It is not possible to upgrade from WebsiteBaker Versions before 2.11.0');
        }

        $sInstallStruct = __DIR__.'/install-struct.sql';
// try to create table if not exists
        if (!$oDb->SqlImport($sInstallStruct, TABLE_PREFIX, 'upgrade')){
            $msg[] = $oDb->get_error();
        }

        $sTable = TABLE_PREFIX.'mod_captcha_control';
        if (($sOldType = $oDb->getTableEngine($sTable))) {
            if(('myisam' != strtolower($sOldType))) {
                if(!$oDb->query('ALTER TABLE `'.$sTable.'` Engine = \'MyISAM\' ')) {
                    $msg[] = $oDb->get_error();
                }
            }
        } else {
            $msg[] = $oDb->get_error();
        }

// remove obselete files and folder
    $aRemoveList = [
        '/themes/default/css/backend.css',
        ];
    $sAbsAddonPath = \str_replace('\\','',__DIR__);
    foreach ($aRemoveList as $sFilename){
        if (is_writeable($sAbsAddonPath.$sFilename)) {
            if (substr($sFilename, -1)==='/'){
                rm_full_dir ($sAbsAddonPath.$sFilename);
            } else {
                \unlink($sAbsAddonPath.$sFilename);
            }
        }
    } // end foreach

        $msg[] = 'Form upgrade successfull finished '.$OK;
        return ($globalStarted ?: $msg);
    }
}
// ------------------------------------

    $bDebugModus = ((isset($bDebugModus)) ? $bDebugModus : false);
    if( is_array($msg = mod_captcha_control_upgrade($bDebugModus))) {
        if (!$bDebugModus){
            echo '<b>'.implode('<br />',$msg).'</b><br />';
        }
    }
// ------------------------------------
