<?php
/**
 *
 * @category        modules
 * @package         code
 * @author          WebsiteBaker Project
 * @copyright       WebsiteBaker Org. e.V.
 * @link            http://www.websitebaker.org/
 * @license         http://www.gnu.org/licenses/gpl.html
 * @platform        WebsiteBaker 2.8.3
 * @requirements    PHP 5.3.6 and higher
 * @version         $Id: upgrade.php 90 2018-09-19 07:28:48Z Luisehahne $
 * @filesource      $HeadURL: svn://isteam.dynxs.de/wb/2.12.x/tags/2.12.1/modules/code/upgrade.php $
 * @lastmodified    $Date: 2018-09-19 09:28:48 +0200 (Mi, 19. Sep 2018) $
 *
 */

/* -------------------------------------------------------- */
// Must include code to stop this file being accessed directly
if (!\defined('SYSTEM_RUN')) {\header($_SERVER['SERVER_PROTOCOL'].' 404 Not Found'); echo '404 File not found'; \flush(); exit;}
/* -------------------------------------------------------- */
    $msg = [];
    $globalStarted = \preg_match('/upgrade\-script\.php$/', $_SERVER["SCRIPT_NAME"]);
    $sWbVersion = ($globalStarted && \defined('VERSION') ? VERSION : WB_VERSION);
    if (\version_compare($sWbVersion, '2.11.0', '<')){
        throw new \Exception ('It is not possible to upgrade from WebsiteBaker Versions before 2.11.0');
    }
    $sTable = TABLE_PREFIX.'mod_code';
    if(($sOldType = $database->getTableEngine($sTable))) {
        if(('myisam' != \strtolower($sOldType))) {
            if(!$database->query('ALTER TABLE `'.$sTable.'` Engine = \'MyISAM\' ')) {
                $msg[] = $database->get_error();
            }
        }
        $sInstallStruct = __DIR__.'/install-struct.sql';
        if (!$database->SqlImport($sInstallStruct, TABLE_PREFIX, 'upgrade' )){
            $msg[] = $database->get_error();
        }
    } else {
        $msg[] = $database->get_error();
    }
// ------------------------------------