<?php
/**
 *
 * @category        module
 * @package         droplet
 * @author          Ruud Eisinga (Ruud) John (PCWacht)
 * @author          WebsiteBaker Project
 * @copyright       Ryan Djurovich
 * @copyright       WebsiteBaker Org. e.V.
 * @link            http://www.websitebaker.org/
 * @license         http://www.gnu.org/licenses/gpl.html
 * @platform        WebsiteBaker 2.12.1
 * @requirements    PHP 5.6.x and higher
 * @version         $Id: install.php 92 2018-09-20 18:04:03Z Luisehahne $
 * @filesource      $HeadURL: svn://isteam.dynxs.de/wb/2.12.x/tags/2.12.1/modules/droplets/install.php $
 * @lastmodified    $Date: 2018-09-20 20:04:03 +0200 (Do, 20. Sep 2018) $
 *
 */

if (!\defined('SYSTEM_RUN')) {\header($_SERVER['SERVER_PROTOCOL'].' 404 Not Found'); echo '404 File not found'; \flush(); exit;}

    $globalStarted = \preg_match('/upgrade\-script\.php$/', $_SERVER["SCRIPT_NAME"]);
    $sWbVersion = (\defined('VERSION') ? VERSION : WB_VERSION);
    if (\version_compare($sWbVersion, '2.11.0', '<')){
        throw new \Exception ('It is not possible to install from WebsiteBaker Versions before 2.11.0');
    }
    // create tables from sql dump file
    if (\is_readable(__DIR__.'/install-struct.sql')) {
        $database->SqlImport(__DIR__.'/install-struct.sql', TABLE_PREFIX, __FILE__ );
    }
    if (!\function_exists('insertDropletFile')) { require('droplets.functions.php'); }
    $msg = array();
    $sBaseDir = \rtrim(\str_replace('\\', '/',\realpath(\dirname(__FILE__).'/example/')), '/').'/';
    $aDropletFiles = getDropletFromFiles($sBaseDir);
    $bOverwriteDroplets = false;
    insertDropletFile($aDropletFiles, $database, $admin,$msg,$bOverwriteDroplets);
