<?php
/**
 *
 * @category        module
 * @package         droplet
 * @author          Ruud Eisinga (Ruud) John (PCWacht)
 * @author          WebsiteBaker Project
 * @copyright       Ryan Djurovich
 * @copyright       WebsiteBaker Org. e.V.
 * @link            http://websitebaker.org/
 * @license         http://www.gnu.org/licenses/gpl.html
 * @platform        WebsiteBaker 2.8.3
 * @requirements    PHP 5.3.6 and higher
 * @version         $Id: upgrade.php 92 2018-09-20 18:04:03Z Luisehahne $
 * @filesource      $HeadURL: svn://isteam.dynxs.de/wb/2.12.x/tags/2.12.1/modules/droplets/upgrade.php $
 * @lastmodified    $Date: 2018-09-20 20:04:03 +0200 (Do, 20. Sep 2018) $
 *
 */

/* -------------------------------------------------------- */
// Must include code to stop this file being accessed directly
if (!\defined('SYSTEM_RUN')) {
    \header($_SERVER['SERVER_PROTOCOL'].' 404 Not Found'); \flush(); exit;
} else {
/* -------------------------------------------------------- */
    $globalStarted = \preg_match('/upgrade\-script\.php$/', $_SERVER["SCRIPT_NAME"]);
    $sWbVersion = ($globalStarted && defined('VERSION') ? VERSION : WB_VERSION);
    if (\version_compare($sWbVersion, '2.11.0', '<')){
        throw new \Exception ('It is not possible to upgrade from WebsiteBaker Versions before 2.11.0');
    }
    if (!\function_exists('insertDropletFile')) {require('droplets.functions.php');}
    $msg = [];
    $sTableName = TABLE_PREFIX.'mod_droplets';
    if ($database->index_exists($sTableName,'droplet_name')){$database->index_remove($sTableName,'droplet_name');}
    // create tables from sql dump file
    if (\is_readable(__DIR__.'/install-struct.sql')) {
        if (!$database->SqlImport(__DIR__.'/install-struct.sql', TABLE_PREFIX, 'upgrade' )){
            echo $msg[] = $database->get_error();
        } else {
        }
        $sBaseDir = \realpath(dirname(__FILE__).'/example/');
        $sBaseDir = \rtrim(\str_replace('\\', '/', $sBaseDir), '/').'/';
        $aDropletFiles = getDropletFromFiles($sBaseDir);
        $bOverwriteDroplets = false;
        insertDropletFile($aDropletFiles, $database, $admin,$msg,$bOverwriteDroplets);
    }
    $sAddonPath = (__DIR__);
    $aRemoveFiles = [
        '/SimpleCommandDispatcher.inc',
        ];
    foreach ($aRemoveFiles as $sFilename){
        if (\is_writeable($sAddonPath.$sFilename)) {
            \unlink($sAddonPath.$sFilename);
        }
    } // end foreach

}
