<?php
/**
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * @category        xyz
 * @package         xyz
 * @subpackage      xyz
 * @copyright       WebsiteBaker Org. e.V.
 * @author          Dietmar Wöllbrink <dietmar.woellbrink@websitebaker.org>
 * @author          Manuela v.d.Decken <manuela@isteam.de>
 * @link            http://websitebaker.org/
 * @license         http://www.gnu.org/licenses/gpl.html
 * @platform        WebsiteBaker 2.10.x
 * @requirements    PHP 5.6.x and higher
 * @version         $Id: field_export.php 68 2018-09-17 16:26:08Z Luisehahne $
 * @filesource      $HeadURL: svn://isteam.dynxs.de/wb/2.12.x/tags/2.12.1/modules/form/field_export.php $
 * @lastmodified    $Date: 2018-09-17 18:26:08 +0200 (Mo, 17. Sep 2018) $
 * @since           File available since 2017 sept 21
 * @description     xyz
 */
/* -------------------------------------------------------- */
if (!function_exists('FieldExport')){
    function FieldExport ($aRequestVars) {
        $admin = $GLOBALS['admin'];
#        $database = $GLOBALS['database'];
        $database = database::getInstance();
        $requestMethod = strtoupper($_SERVER['REQUEST_METHOD']);

        $sAddonPath = (__DIR__);
        $sAddonName = basename($sAddonPath);
        $sAddonRel = '/modules/'.$sAddonName.'/';
        $sTargetAbsPath = $sAddonPath.'/data/fields/';
        $aMessage = [];

        $oLang = Translate::getInstance();
        $oLang->enableAddon('modules\\'.$sAddonName);
        $aLang = $oLang->getLangArray();

        $removeExtension = (function  ($sFilename){
            $sRetval = '';
            return preg_replace('#^.*?([^/]*?)\.[^\.]*$#i', '\1', $sFilename);
        });

        $getUniqueName = (function ($sName, $sPattern='*.xml') use ($sTargetAbsPath) {
            if (!empty($sName)){
                $sBaseName = preg_replace('/^(.*?)(\_[0-9]+)?$/', '$1', $sName);
                $aMaxNames = glob($sTargetAbsPath.$sBaseName.$sPattern, GLOB_NOSORT);
                sort($aMaxNames);
                $sMaxName  = basename(end($aMaxNames));
                $iCount    = intval(preg_replace('/[^0-9\.]/', '', $sMaxName))+1;
                $sName     = $sBaseName.sprintf('_%03d', $iCount++);
            }
            return $sName;
        });
// create Variables from request
        foreach ($aRequestVars as $index=>$value){
            $$index = $value;
        }
        $title = $removeExtension($title);
        $file  = $removeExtension($xml_file);

        $sSectionIdPrefix = (defined( 'SEC_ANCHOR' ) && ( SEC_ANCHOR != '' )  ? SEC_ANCHOR : 'Sec' );
        $sBackUrl = ADMIN_URL.'/pages/modify.php?page_id='.$page_id;  // .'#'.$sSectionIdPrefix.$section_id;
        $sBacklink  = WB_URL.$sAddonRel.'modify_backup.php';
        if (!$admin->checkFTAN($requestMethod)){
             $admin->print_error( 'checkFTAN ::'.$oLang->MESSAGE_GENERIC_SECURITY_ACCESS, $sBackUrl );
        }

        /* ---------------------------------------------------------------------------------- */
        $TidyFilename = (function ($val)
        {
            // whitespace durch Unterstrich ersetzen
        /*
            $sRetval = preg_replace('#(\s+)#', '_', $val);
            $sRetval = preg_replace('/[^A-Za-z0-9]/', '_', $val);
            [<>:"/\\|?*]|            # file system reserved https://en.wikipedia.org/wiki/Filename#Reserved_characters_and_words
        */
            $sRetval = preg_replace(
            '~
            (\s+)|                        # file system reserved
            [\x00-\x1F]|                  # control characters http://msdn.microsoft.com/en-us/library/windows/desktop/aa365247%28v=vs.85%29.aspx
            [\x7F\xA0\xAD]|               # non-printing characters DEL, NO-BREAK SPACE, SOFT HYPHEN
            [#\[\]@!§"$%&\'\?()+,;:=§\/]| # URI reserved https://tools.ietf.org/html/rfc3986#section-2.2
            [{}^\~`]                      # URL unsafe characters https://www.ietf.org/rfc/rfc1738.txt
            ~x',
            '_', $val);
            // Liste aller Umlaute
            $map = array(
                    'ä' => 'ae',
                    'Ä' => 'ae',
                    'ß'=>'ss',
                    'ö'=>'oe',
                    'Ö' => 'oe',
                    'Ü'=>'ue',
                    'ü'=>'ue',
                    '<'=>'',
                    '>'=>'',
                    // hier ggf. weitere Zeichen ergänzen, z.B.
                    'à' => 'a',
                    'é' => 'e',
                    'è' => 'e',
                );
//            $sRetval = preg_replace('#^.*?([^/]*?)\.[^\.]*$#i', '\1', $sRetval);
            $sRetval = str_replace('__', '', $sRetval);
            // Umlaute konvertieren
            $sRetval = str_replace(array_keys($map), array_values($map), $sRetval);
            // alle anderen Zeichen verwerfen
        //    $sRetval = preg_replace('#[^a-z0-9_.-]#', '', $sRetval);
            return $sRetval;
        });

        $version  = '1.0';
        $encoding = 'utf-8';

        $sOldFilename    = $TidyFilename($admin->StripCodeFromText($file));
        $sFilename = $TidyFilename($admin->StripCodeFromText($title));

        $IDKEY = '&frm_id='.$admin->getIDKEY($section_id);
        $sBacklink   .= '?page_id='.$page_id.$IDKEY;

        $sFilename    = (($sFilename==$sOldFilename) ? $getUniqueName($sOldFilename) : $sFilename);
        $sDownloadUrl = '';
        $sDescription = ''.$admin->StripCodeFromText($aRequestVars['description']);
        $sDescription = !empty($sDescription)?$sDescription:'Beschreibung des Formulars…';

        if (!file_exists($sTargetAbsPath)&&!make_dir($sTargetAbsPath)){
            $aMessage[] = sprintf('%1$.04d ) Couldn\'t create /'.$sAddonName.'/data/fields/.', __LINE__);
        } else {
            if (!empty($sFilename)){
                $sFilename .= '.xml'; //'_'.$section_id.
                $sAbsFilename = $sTargetAbsPath.$sFilename;
                $sql  = 'SELECT COUNT(*) FROM `'.TABLE_PREFIX.'mod_form_fields` '
                      . 'WHERE `section_id` = '.(int)$section_id.' '
                      . '';
                if ($database->get_one($sql)==0){
                    $aMessage[] = sprintf('%1$.04d ) Couldn\'t export, there no existing form fields in this section '.$section_id, __LINE__);
                } else {
                    try {
                        $dom = new DOMDocument($version,$encoding);
                        $dom->preserveWhiteSpace = true;
                        $dom->formatOutput = true;
                        $root = $dom->createElement("root");
                        $oSectionId    = $dom->createElement("section_id", $section_id);
                        $oPageId       = $dom->createElement("page_id", $page_id);
                        $oDescription  = $dom->createElement("description", $sDescription);
                        $root->appendChild($oSectionId);
                        $root->appendChild($oPageId);
                        $root->appendChild($oDescription);
                        $fields = $dom->createElement('fields');
                    } catch ( Exception $e ){
                        $aMessage[] = sprintf('%1$.04d ) Tried to set root in DOMElement!<br />'.$e, __LINE__);
                    }
                    // Select all the fields in the form table
                    $sql  = 'SELECT * FROM `'.TABLE_PREFIX.'mod_form_fields` '
                          . 'WHERE `section_id` = '.(int)$section_id.' '
                          . 'ORDER BY `position` ASC';
                    if (!$oRes = $database->query($sql)) {
                      die('Invalid query: ' . $database->get_error());
                    }
                    // Iterate through the rows, adding XML nodes for each
                    while ($aXml = $oRes->fetchRow(MYSQLI_ASSOC)){
                        // Add to XML document node
                        $new_node = $dom->createElement('field');
                        $attr_field_id = new DOMAttr('id', $aXml['field_id']);
                        $new_node->setAttributeNode($attr_field_id);
                        foreach ($aXml as $key=>$value){
                            switch ($key):
                                case 'field_id':
                                case 'page_id':
                                case 'section_id':
                                  break;
                                default:
                                $child_node = $dom->createElement($key, $value);
                                $new_node->appendChild($child_node);
                            endswitch;
                        }
                        $fields->appendChild($new_node);
                    }// end while fetchRow
                    $root->appendChild($fields);
                    $dom->appendChild($root);
                    $dom->save($sAbsFilename);
                } // no existing form fields
            } // $sFilename
            else {
                $admin->print_error($oLang->FORM_MESSAGE_FILE_TITLE_VALUE, $sBacklink);
            }
        } // end make_dir

        if (!sizeof($aMessage)){
            $admin->print_success(sprintf($oLang->FORM_MESSAGE_EXPORT_SUCCESS,$sFilename), $sBacklink);
            return true;
        } else {
            $admin->print_error(implode('<br />',$aMessage), $sBacklink);
        }
    }
}

/*---------------------------------------------------------------------------------*/
if (!defined( 'WB_PATH' ) ){ require( dirname(dirname((__DIR__))).'/config.php' ); }
if (!function_exists('make_dir')){require WB_PATH.'/framework/functions.php';}
    $print_info_banner = true;
// suppress to print the header, so no new FTAN will be set
    $admin_header = true;
// Tells script to update when this page was last updated
    $update_when_modified = true;
// Include WB admin wrapper script
    require(WB_PATH.'/modules/admin.php');
    $requestMethod = strtoupper($_SERVER['REQUEST_METHOD']);
    $aRequestVars  = (isset(${'_'.$requestMethod}) ? ${'_'.$requestMethod} : $_REQUEST);

    FieldExport($aRequestVars);
// Print admin footer
    $admin->print_footer($admin,$database);
// end of file
