<?php
/**
 *
 * @category        module
 * @package         Form
 * @author          WebsiteBaker Project
 * @copyright       WebsiteBaker Org. e.V.
 * @link            http://websitebaker.org/
 * @license         http://www.gnu.org/licenses/gpl.html
 * @platform        WebsiteBaker 2.8.3
 * @requirements    PHP 5.3.6 and higher
 * @version         $Id: EN.php 68 2018-09-17 16:26:08Z Luisehahne $
 * @filesource      $HeadURL: svn://isteam.dynxs.de/wb/2.12.x/tags/2.12.1/modules/form/languages/EN.php $
 * @lastmodified    $Date: 2018-09-17 18:26:08 +0200 (Mo, 17. Sep 2018) $
 * @description
 */
/* -------------------------------------------------------- */
// Must include code to prevent this file from being accessed directly
if(defined('WB_PATH') == false) { die('Cannot access '.basename(__DIR__).'/'.basename(__FILE__).' directly'); }
/* -------------------------------------------------------- */

//Modul Description
$module_description = 'This module allows you to create customized online forms, such as a feedback form. Thank-you to Rudolph Lartey who help enhance this module, providing code for extra field types, etc.';

//Variables for the  backend
$MOD_FORM['SETTINGS']              = 'Form Settings';
$MOD_FORM['CONFIRM']               = 'Confirmation';
$MOD_FORM['SUBMIT_FORM']           = 'Submit';
$MOD_FORM['EMAIL_SUBJECT']         = 'You have received a form via {{WEBSITE_TITLE}}';
$MOD_FORM['SUCCESS_EMAIL_SUBJECT'] = 'Your form has been submitted to {{WEBSITE_TITLE}}';

$MOD_FORM['SUCCESS_EMAIL_TEXT']    = 'Thank you for sending your message to {{WEBSITE_TITLE}}! '.PHP_EOL;
$MOD_FORM['SUCCESS_EMAIL_TEXT']   .= 'We will contact you as soon as possible';

$MOD_FORM['SUCCESS_EMAIL_TEXT_GENERATED'] = "\n"
."**************************************************************************************\n"
."This is an automatically generated e-mail. The sender address of this e-mail\n"
."is furnished only for dispatch, not to receive messages!\n"
."If you have received this e-mail by mistake, please contact us and delete this message\n"
."**************************************************************************************\n";


$MOD_FORM['REPLYTO'] = 'E-Mail reply to';
$MOD_FORM['FROM']    = 'Sender';
$MOD_FORM['TO']      = 'Recipient';

$MOD_FORM['EXCESS_SUBMISSIONS'] = 'Sorry, this form has exceeded the maximum hourly submissions. Please retry in the next hour.';
$MOD_FORM['INCORRECT_CAPTCHA']  = 'The verification number (also known as Captcha) that you entered is incorrect. If you are having problems reading the Captcha, please email the <a href="mailto:{{WEBMASTER_EMAIL}}">webmaster</a>';

$MOD_FORM['PRINT']     = 'Sending an e-mail confirmation is not possible. ';
$MOD_FORM['PRINT']     = 'Dispatch to unchecked e-mail addresses is not possible! '.PHP_EOL;
$MOD_FORM['PRINT']    .= 'Please print this page, if a copy is desired for your records.';
$MOD_FORM['LOAD_LAYOUT'] = 'Load Default Layout';
$MOD_FORM['CAPTCHA_PLACEHOLDER'] = 'New placeholder for embedding captcha in the layout';
$MOD_FORM['DSGVO_PLACEHOLDER'] = 'New placeholder for embedding data protection in the layout';

$MOD_FORM['RECIPIENT'] = 'E-mail confirmations will only be sent to registered users!';

$MOD_FORM['ERROR']           = 'E-Mail could not send!!';
$MOD_FORM['SPAM']            = 'Caution! Answering an unchecked email can be perceived as spamming and carry the risk of receiving a cease-and-desist warning! ';
$MOD_FORM['REQUIRED_FIELDS'] = 'You must enter details for the following fields';
$MOD_FORM['DSGVO'] = 'Missing confirmation and agreement to the Data Protection Directive';

$MOD_FORM['DSGVO_ENABLED'] = 'Consent to the Privacy Policy %s';
$MOD_FORM['DSGVO_DIABLED'] = 'Lack of consent to the Privacy Policye %s';
$MOD_FORM['DSGVO_NOT_INUSE'] = 'Privacy policy consent is disabled %s';

$MESSAGE['INCORRECT_CAPTCHA']  = 'The verification number (also known as Captcha) that you entered is incorrect. If you are having problems reading the Captcha, please email the <a href="mailto:{{WEBMASTER_EMAIL}}">webmaster</a>';
$MESSAGE['FIELD_DELETED'] = 'Field <b>[%s]</b> deleted successfully';

$TEXT['GUEST']       = 'Guest';
$TEXT['UNKNOWN']     = 'unknown';
$TEXT['PRINT_PAGE']  = 'Print page';
$TEXT['REQUIRED_JS'] = 'Required Javascript';
$TEXT['SUBMISSIONS_PERPAGE'] = 'Show submissions rows per page';
$TEXT['ADMIN'] = 'Admin';
$MENU['USERS'] = 'Users';
$TEXT['BACKUP'] = 'Frontend Layouts Export/Import';
$TEXT['EXPORT'] = 'Export';
$TEXT['IMPORT'] = 'Import';
$TEXT['FORM_NONE_FOUND'] = 'No Entries found';
$TEXT['MODIFY_FIELD'] = 'Modify Field';
$TEXT['ADD_FIELD'] = 'Add Field';
$TEXT['MODIFY_DELETE_FIELD'] = 'Modify or delete Field';
$TEXT['ADD_GROUP'] = 'Add Group';
$TEXT['MODIFY_DELETE_GROUP'] = 'Modify or delete Field';
$TEXT['DSGVO'] = 'Data Protection Directive';
$TEXT['DSGVO_LINK'] = 'Data Protection Url';
$TEXT['EMPTY'] = '&#160;';
$TEXT['EXTRA'] = 'Extra Fields';

$FORM_MESSAGE = array (
    'ARCHIVE_DELETED' => 'Zip(s) deleted successfully.',
    'ARCHIVE_NOT_DELETED' => 'Cannot delete the selected Zip(s).',
    'CONFIRM_FIELD_DELETING' => 'Are you sure you want to delete the selected field?',
    'DELETED' => 'Field deleted successfully.',
    'ALL_DELETED' => 'All Fields deleted successfully.',
    'DELETE_FIELDS' => 'Delete Fields',
    'MISSING_UNMARKED_ARCHIVE_FILES' => 'No Fields-File selected to import.',
    'GENERIC_MISSING_ARCHIVE_FILE' => 'No Zip-File selected to delete!',
    'GENERIC_MISSING_TITLE' => 'Insert a Field name.',
    'GENERIC_LOCAL_DOWNLOAD' => 'Download Zip',
    'GENERIC_LOCAL_UPLOAD' => 'Load and restore a locale Zip',
    'DELETE_LAYOUT' => 'Remove all Form Fields.',
    'CONFIRM_DELETE_LAYOUT' => 'Are you sure you want to delete all fields?',
    'CAPTCHA_STYLE' => 'Captcha Style Attribute',
    'CAPTCHA_ACTION' => 'Captcha Output',
    'ALL' => 'Output a div container with varying columns (default).',
    'IMAGE' => 'Output the <img>-tag for the image only.',
    'IMAGE_IFRAME' => 'Output only an <img>-tag.',
    'INPUT' => 'Output only the input-field, you can add style="...;" or class="..." Attribute',
    'TEXT' => 'Text Output',

    'FILE_TITLE_VALUE' => 'Missing the file name!',
    'LSETTINGS' => 'Layout Settings',
    'TEXT_SELECT_BOX' => 'Choose Layout',
    'LAYOUT_TITLE' => 'Layout file name',
    'LAYOUT_TITLE_NEW' => 'New Layout file name',
    'LAYOUT_DESCRIPTION' => 'Layout Description',
    'LAYOUT_SETTINGS' => 'Layout Settings',
    'LAYOUT' => 'Layout Output',
    'DOWNLOAD' => 'Download',
    'IMPORT_DELETED' => '%s has been successfully deleted',
    'IMPORT_SUCCESS' => '%s has been successfully imported',
    'EXPORT_SUCCESS' => '%s has been successfully exported',
    'DSGVO' => 'I confirme, that i have read and agree to the <a href="%s" target="_blank" rel="noopener">Data Protection Directive</a>  by submitting the form',
    );

$FORM_HELP['IMPORT_FIELDS'] = 'Import form fields stored in an xml file to add to an empty form. Select a file and download to your local machine. Select a file, and you are able to delete the file';
$FORM_HELP['ADD_FIEDS'] = 'Import form fields and add to an empty form.';

