<?php
/**
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * @category        xyz
 * @package         xyz
 * @subpackage      xyz
 * @copyright       WebsiteBaker Org. e.V.
 * @author          Dietmar Wöllbrink <dietmar.woellbrink@websitebaker.org>
 * @author          Manuela v.d.Decken <manuela@isteam.de>
 * @link            http://websitebaker.org/
 * @license         http://www.gnu.org/licenses/gpl.html
 * @platform        WebsiteBaker 2.10.x
 * @requirements    PHP 5.6.x and higher
 * @version         $Id: layout_import.php 68 2018-09-17 16:26:08Z Luisehahne $
 * @filesource      $HeadURL: svn://isteam.dynxs.de/wb/2.12.x/tags/2.12.1/modules/form/layout_import.php $
 * @lastmodified    $Date: 2018-09-17 18:26:08 +0200 (Mo, 17. Sep 2018) $
 * @since           File available since  2017 sept 21
 * @description     xyz
 */
/* -------------------------------------------------------- */
if ( !defined( 'WB_PATH' ) ){ require( dirname(dirname((__DIR__))).'/config.php' ); }

$sAddonPath = (__DIR__);
$sAddonName = basename($sAddonPath);
$aMessage = [];
// suppress to print the header, so no new FTAN will be set
$admin_header = true;
// Tells script to update when this page was last updated
$update_when_modified = true;
// Include WB admin wrapper script
require(WB_PATH.'/modules/admin.php');

$requestMethod = strtoupper($_SERVER['REQUEST_METHOD']);
$aRequestVars  = (isset(${'_'.$requestMethod}) ? ${'_'.$requestMethod} : $_REQUEST);

$removeExtension = (function  ($sFilename){
    $sRetval = '';
    return preg_replace('#^.*?([^/]*?)\.[^\.]*$#i', '\1', $sFilename);
});

$sSectionIdPrefix = (defined( 'SEC_ANCHOR' ) && ( SEC_ANCHOR != '' )  ? SEC_ANCHOR : 'Sec' );
$sBackUrl = ADMIN_URL.'/pages/modify.php?page_id='.$page_id.'#'.$sSectionIdPrefix.$section_id;

if (is_readable(__DIR__.'/languages/EN.php')) {require(__DIR__.'/languages/EN.php');}
if (is_readable(__DIR__.'/languages/'.DEFAULT_LANGUAGE.'.php')) {require(__DIR__.'/languages/'.DEFAULT_LANGUAGE.'.php');}
if (is_readable(__DIR__.'/languages/'.LANGUAGE.'.php')) {require(__DIR__.'/languages/'.LANGUAGE.'.php');}

if (!$admin->checkFTAN($requestMethod)){
    $admin->print_error( 'checkFTAN ::'.$MESSAGE['GENERIC_SECURITY_ACCESS'], $sBackUrl );
}

$FTAN = $admin->getFTAN('GET');
$sBacklink  = WB_URL.'/modules/'.$sAddonName.'/modify_settings.php';
$sBacklink .= '?page_id='.$page_id.'&section_id='.$section_id.'&'.$FTAN;

$version  = '1.0';
$encoding = 'utf-8';

$sFilename = $removeExtension(''.$admin->StripCodeFromText($aRequestVars['file']));

if ($sFilename==''){
    $sFilename = $removeExtension(''.$admin->StripCodeFromText($aRequestVars['file']));
#    $aMessage[] = sprintf('%1$.04d ) Couldn\'t import, because no layout has been selected', __LINE__);
}

$sTargetPath  = $sAddonPath.'/data/layouts/';
$sAbsFilename = $sTargetPath.$sFilename.'.xml';

$action = 'cancel';
$action = (isset($aRequestVars['import'])?'import':$action);
$action = (isset($aRequestVars['delete'])?'delete':$action);

try {
    if (isset($aRequestVars['cmd'])&&(is_file($sAbsFilename)||($sFilename!=''))) {
        switch ($action):
            case 'import':
                    // insert all the fields in the form table
//                    $sXmlStr = file_get_contents($sAbsFilename);
                    $sLayout = \preg_replace('#^.*?([^/]*?)\.[^\.]*$#i', '\1', basename($sAbsFilename));
                    if ($oXml = simplexml_load_file($sAbsFilename)) {
                        $title = $oXml->title;
                        $description = $oXml->description;
                        foreach ($oXml->fields as $field) {
                            $header     = $field->header;
                            $field_loop = $field->field_loop;
                            $extra      = $field->extra;
                            $footer     = $field->footer;
    //                        print '<hr>'.$field->title.' Typ = '.$field->type;
                        }// end foreach
                            $sql  = 'UPDATE `'.TABLE_PREFIX.'mod_form_settings` SET '
                                  . '`header` = \''.$database->escapeString($header).'\', '
                                  . '`field_loop` = \''.$database->escapeString($field_loop).'\', '
                                  . '`extra`  = \''.$database->escapeString($extra).'\', '
                                  . '`footer` = \''.$database->escapeString($footer).'\', '
                                  . '`layout` = \''.$database->escapeString($sLayout).'\' '
                                  . 'WHERE `section_id` = '.(int)$section_id.' '
                                  . '';
                            if (!$oRes = $database->query($sql)) {
                              $aMessage[] = $sql.'<br />';
                              $aMessage[] = 'Invalid query: ' . $database->get_error();
                            }
                    } else {
                        $aMessage[] = 'Invalid simplexml: '. libxml_get_errors();
                    }

                break;
            case 'delete':
    //          unset($_REQUEST['cmd']);
              if (!unlink($sAbsFilename)){
                  $aMessage[] = sprintf('%1$.04d ) Couldn\'t delete %2$s '.'<br />', __LINE__,$sFilename);
              }
              break;
            default:
        $aMessage[] = sprintf('%1$.04d ) Couldn\'t do anything for file %2$s '.'!<br />', __LINE__, $sFilename);
        endswitch;
    } else {
        $aMessage[] = sprintf('%1$.04d ) Couldn\'t find file %2$s for import or delete '.'!<br />', __LINE__, $sFilename);
    }
} catch ( Exception $e ){
    $aMessage[] = sprintf('%1$.04d ) Tried to set form in DOMElement!<br />'.$e, __LINE__);
}

    if (!sizeof($aMessage)){
        switch ($action):
            case 'import':
                $admin->print_success(sprintf($FORM_MESSAGE['IMPORT_SUCCESS'],$sFilename), $sBacklink);
                break;
            case 'delete':
                $admin->print_success(sprintf($FORM_MESSAGE['IMPORT_DELETED'],$sFilename), $sBacklink);
                break;
            default:
        endswitch;
    } else {
      $admin->print_error(implode('<br />',$aMessage), $sBackUrl);
    }

// Print admin footer
    $admin->print_footer();
// end of file
//