<?php
/**
 *
 * @category        modules
 * @package         menu_link
 * @author          WebsiteBaker Project
 * @copyright       WebsiteBaker Org. e.V.
 * @link            http://websitebaker.org/
 * @license         http://www.gnu.org/licenses/gpl.html
 * @platform        WebsiteBaker 2.8.3
 * @requirements    PHP 5.3.6 and higher
 * @version         $Id: save.php 68 2018-09-17 16:26:08Z Luisehahne $
 * @filesource      $HeadURL: svn://isteam.dynxs.de/wb/2.12.x/tags/2.12.1/modules/menu_link/save.php $
 * @lastmodified    $Date: 2018-09-17 18:26:08 +0200 (Mo, 17. Sep 2018) $
 *
*/

if (!defined('SYSTEM_RUN')) {require( dirname(dirname((__DIR__))).'/config.php');}
if (!function_exists('xnl2br')){require(WB_PATH.'/framework/functions.php');}

if (is_readable(__DIR__.'/languages/EN.php')) {require(__DIR__.'/languages/EN.php');}
if (is_readable(__DIR__.'/languages/'.DEFAULT_LANGUAGE.'.php')) {require(__DIR__.'/languages/'.DEFAULT_LANGUAGE.'.php');}
if (is_readable(__DIR__.'/languages/'.LANGUAGE.'.php')) {require(__DIR__.'/languages/'.LANGUAGE.'.php');}

    $admin_header = false;
    // Tells script to update when this page was last updated
    $update_when_modified = true;
    // Include WB admin wrapper script
    require(WB_PATH.'/modules/admin.php');

try {

    $sAddonBackUrl = ADMIN_URL.'/pages/modify.php?page_id='.(int)$page_id;
    if (!\bin\SecureTokens::checkFTAN ()) {
        throw new \Exception ($MESSAGE['GENERIC_SECURITY_ACCESS']);
    }

// Update id, anchor and target
    if (isset($_POST['menu_link'])) {
        $iTargetPageId = intval($admin->get_post('menu_link'));
        $iRedirectType = intval($admin->get_post('r_type'));
        $anchor = ($admin->get_post('page_target'));
        $sTarget = $admin->get_post('target');
        $extern='';
// sanitize/validate url
        if (isset($_POST['extern'])) {
            $extern=$_POST['extern'];
            include_once WB_PATH.'/include/idna_convert/idna_convert.class.php';
            $oIdn = new idna_convert();
            // first add the local URL if there is no one
            $sNewUrl = ltrim(str_replace('\\', '/', $extern), '/');
            $extern = $admin->StripCodeFromText($oIdn->encode($sNewUrl));
            if (isset($extern)){
                $mValue = filter_var($extern
                      ,FILTER_VALIDATE_URL
                      ,FILTER_FLAG_SCHEME_REQUIRED
                      |FILTER_FLAG_HOST_REQUIRED
//                      |FILTER_FLAG_PATH_REQUIRED
                    );
                if (!$mValue) {
                    $sMessage = sprintf($MOD_MENU_LINK['FQDN_ERROR'], $oIdn->decode($extern));
                    throw new \Exception ($sMessage);
                }
            }
            $extern = $oIdn->decode($extern);
            unset($oIdn);
            if (!preg_match('/^https?:\/\/.*$/si', $extern)) {
                $extern = WB_URL.'/'.$extern;
            }
            // replace local host by SYSVAR-Tag
            $extern = preg_replace(
                '/^'.preg_quote(str_replace('\\', '/', WB_URL).'/', '/').'/si',
                '{SYSVAR:AppUrl}',
                ltrim(str_replace('\\', '/', $extern), '/')
            );
        } else {
          $extern = '';
        }

        $table_pages = TABLE_PREFIX.'pages';
        $sql  = 'UPDATE `'.TABLE_PREFIX.'pages` SET '
              .'`target` = \''.$database->escapeString($sTarget).'\' '
              .'WHERE `page_id` = '.$page_id;
        $database->query($sql);

        $sql  = 'UPDATE `'.TABLE_PREFIX.'mod_menu_link` SET '
              .'`target_page_id` = '.$iTargetPageId.', '
              .'`redirect_type`  = '.$iRedirectType.', '
              .'`anchor` = \''.$database->escapeString($anchor).'\', '
              .'`extern` = \''.$database->escapeString($extern).'\' '
              .'WHERE `page_id` = '.$page_id;
        $database->query($sql);
    }

// Check if there is a database error, otherwise say successful
    if($database->is_error()) {
        throw new \Exception ($database->get_error());
    } else {
        $admin->print_header();
        $admin->print_success($MESSAGE['PAGES_SAVED'],$sAddonBackUrl );
    }

}catch (\Exception $ex) {

    $admin->print_header();
    $sErrMsg = xnl2br(\sprintf('[%d] %s', $ex->getLine(), $ex->getMessage()));
    $admin->print_error ($sErrMsg, $sAddonBackUrl);
    exit;
}

// Print admin footer
$admin->print_footer();
