<?php
/**
 *
 * @category        modules
 * @package         news
 * @author          WebsiteBaker Project
 * @copyright       WebsiteBaker Org. e.V.
 * @link            http://websitebaker.org/
 * @license         http://www.gnu.org/licenses/gpl.html
 * @platform        WebsiteBaker 2.8.3
 * @requirements    PHP 5.3.6 and higher
 * @version         $Id: modify_settings.php 120 2018-09-28 18:47:10Z Luisehahne $
 * @filesource      $HeadURL: svn://isteam.dynxs.de/wb/2.12.x/tags/2.12.1/modules/news/modify_settings.php $
 * @lastmodified    $Date: 2018-09-28 20:47:10 +0200 (Fr, 28. Sep 2018) $
 *
 */

if (!defined('SYSTEM_RUN') ){ require( dirname(dirname((__DIR__))).'/config.php' );}

// suppress to print the header, so no new FTAN will be set
//$admin_header = false;
// Tells script to update when this page was last updated
$update_when_modified = false;
// show the info banner
$print_info_banner = true;
// Include WB admin wrapper script
require(WB_PATH.'/modules/admin.php');

$requestMethod = strtoupper($_SERVER['REQUEST_METHOD']);
$aRequestVars  = (isset(${'_'.$requestMethod}) ? ${'_'.$requestMethod} : $_REQUEST);

$sAddonName = basename(__DIR__);
$ModuleRel  = '/modules/'.$sAddonName;
$ModuleUrl  = WB_URL.$ModuleRel;
$ModulePath = WB_PATH.$ModuleRel;
$sSelect    = ' selected="selected"';
$sSectionIdPrefix = (defined( 'SEC_ANCHOR' ) && ( SEC_ANCHOR != 'none' )  ? '#'.SEC_ANCHOR.$section_id : '' );
$sBacklink = ADMIN_URL.'/pages/modify.php?page_id='.$page_id.$sSectionIdPrefix;

if (!$admin->checkFTAN($requestMethod)) { $admin->print_error($MESSAGE['GENERIC_SECURITY_ACCESS'], $sBacklink);}

// include core functions of WB 2.7 to edit the optional module CSS files (frontend.css, backend.css)
if (!function_exists('edit_module_css')) {include(WB_PATH .'/framework/module.functions.php');}
// check if module language file exists for the language set by the user (e.g. DE, EN)

    if (is_readable(__DIR__.'/languages/EN.php')) {require(__DIR__.'/languages/EN.php');}
    if (is_readable(__DIR__.'/languages/'.DEFAULT_LANGUAGE.'.php')) {require(__DIR__.'/languages/'.DEFAULT_LANGUAGE.'.php');}
    if (is_readable(__DIR__.'/languages/'.LANGUAGE.'.php')) {require(__DIR__.'/languages/'.LANGUAGE.'.php');}
    $oLang = Translate::getInstance();
    $oLang->enableAddon('modules\\'.basename(__DIR__));

// Get header and footer
    $sql  = 'SELECT * FROM '.TABLE_PREFIX.'mod_news_settings '
          . 'WHERE section_id = '.(int)$section_id;
    $oSettings = $database->query( $sql );
    $aSetting = $oSettings->fetchRow( MYSQLI_ASSOC );
    $old_page_id = $page_id;
    $target_section_id = $aSetting['data_protection_link'];
    if (isset($aRequestVars['install_layout'])) {
        if (isset($aRequestVars)){
          if (!empty($aRequestVars['layout'])){
            $sLayoutFilename = $admin->StripCodeFromText($aRequestVars['layout']);
          }
          if (is_readable(__DIR__.'/presets/'.$sLayoutFilename.'.inc.php')){
              require (__DIR__.'/presets/'.$sLayoutFilename.'.inc.php');
          } else {
              require (__DIR__.'/presets/default_layout.inc.php');
          }
        }

        foreach ($aSetting as $sKey=>$sValue){
          if (!isset(${$sKey})) {continue;}
          $aSetting[$sKey] = ${$sKey};
        }
    }

    $aSelectLayout = [];
    $aLayouts = \glob(__DIR__.'/presets/*.inc.php');
    $sPattern = '/^.*?([^\/]*?)\.[^\.]*\.[^\.]*$/is';
    foreach($aLayouts as $sFilename){
        $aSelectLayout[] = preg_replace($sPattern,'$1',$sFilename);
    }

$FTAN  = $admin->getFTAN('');
$sFtan = $FTAN['name'].'='.$FTAN['value'];

//$aSetting
// Set raw html <'s and >'s to be replace by friendly html code
$raw = array('<', '>');
$friendly = array('&lt;', '&gt;');
?>
<?php
if ($print_info_banner) {
?>
    </div><!--end class="block-outer" -->
<?php } ?>
<?php
    $aSelectSections = [];
    $aSelectSections = \bin\helpers\ParentList::build_sectionlist(0, $page_id, $aSelectSections);
// include the button to edit the optional module CSS files (function added with WB 2.7)
// Note: CSS styles for the button are defined in backend.css (div class="mod_moduledirectory_edit_css")
// Place this call outside of any <form></form> construct!!!
?>
<div class="w3-padding w3-row w3-panel">
  <div class="w3-container w3-col m4 w3-padding">
    <h2 style="margin: 0.425em 0 0;"><?php echo $MOD_NEWS['SETTINGS']; ?></h2>
  </div>
<div class="w3-container w3-col m4 w3-margin-top">
    <form action="<?php echo WB_URL; ?>/modules/<?php echo $sAddonName;?>/modify_settings.php" method="get" >
        <input type="hidden" value="<?php echo $page_id; ?>" name="page_id">
        <input type="hidden" value="<?php echo $section_id; ?>" name="section_id">
        <input type="hidden" value="<?php echo $FTAN['value'];?>" name="<?php echo $FTAN['name'];?>">
        <input type="hidden" value="<?php echo $aSetting['layout']; ?>" name="layout">
        <ul class="w3-navbar" style="width: 100%;">
            <li>
            <select name="layout" class="w3-select w3-border">
            <?php foreach($aSelectLayout as $sLayout) {
              $sSelected = (($sLayout==$aSetting['layout']) ? ' selected="selected"' : '');
            ?>
            <option<?php echo $sSelected;?>><?php echo $sLayout;?></option>
            <?php } ?>
            </select>
            </li>
            <li>
            <input type="submit" name="install_layout" value="<?php echo $MOD_NEWS['LOAD']; ?>" class="btn btn-default w3-blue-wb w3-round-small w3-hover-green w3-medium w3-padding-4" style="min-width:8.525em;margin-left: 0.525em;" />
            </li>
        </ul>

    </form>
</div>
<div class="w3-container w3-col m4 w3-margin-top">
<?php
if(function_exists('edit_module_css')){ edit_module_css($sAddonName);}
?>
</div>
<form name="modify" action="<?php echo $ModuleUrl; ?>/save_settings.php" method="post" style="margin: 0;">
  <input type="hidden" name="section_id" value="<?php echo $section_id; ?>" />
  <input type="hidden" name="page_id" value="<?php echo $page_id; ?>" />
  <input type="hidden" value="<?php echo $aSetting['layout']; ?>" name="layout">
  <?php echo $admin->getFTAN(); ?>
  <div class="block-outer">
      <table class="news">
        <caption class="news-header"><?php echo $HEADING['GENERAL_SETTINGS']; ?></caption>
        <tbody>
            <tr>
               <td class="setting_name"><?php echo $TEXT['HEADER']; ?></td>
               <td class="setting_value">
                  <textarea name="header" rows="5" cols="1" style="width: 98%;"><?php echo ($aSetting['header']); ?></textarea>
               </td>
            </tr>
            <tr>
               <td class="setting_name"><?php echo $TEXT['POST'].' '.$TEXT['LOOP']; ?></td>
               <td class="setting_value">
                  <textarea name="post_loop" rows="10" cols="1" style="width: 98%;"><?php echo ($aSetting['post_loop']); ?></textarea>
               </td>
            </tr>
            <tr>
               <td class="setting_name"><?php echo $TEXT['FOOTER']; ?></td>
               <td class="setting_value">
                  <textarea name="footer" rows="10" cols="1" style="width: 98%;"><?php echo str_replace($raw, $friendly, ($aSetting['footer'])); ?></textarea>
               </td>
            </tr>
            <tr>
               <td class="setting_name"><?php echo $TEXT['POST_HEADER']; ?></td>
               <td class="setting_value">
                  <textarea name="post_header" rows="10" cols="1" style="width: 98%;"><?php echo str_replace($raw, $friendly, ($aSetting['post_header'])); ?></textarea>
               </td>
            </tr>
            <tr>
               <td class="setting_name"><?php echo $TEXT['POST_FOOTER']; ?></td>
               <td class="setting_value">
                  <textarea name="post_footer" rows="5" cols="1" style="width: 98%;"><?php echo str_replace($raw, $friendly, ($aSetting['post_footer'])); ?></textarea>
               </td>
            </tr>
            <tr>
               <td class="setting_name"><?php echo $TEXT['POSTS_PER_PAGE']; ?></td>
               <td class="setting_value">
                  <select class="w3-select w3-border" name="posts_per_page">
                     <option value="0"><?php echo $TEXT['UNLIMITED']; ?></option>
<?php
                     for($i = 1; $i <= 20; $i++) {
                        if($aSetting['posts_per_page'] == ($i*5)) { $selected = ' selected="selected"'; } else { $selected = ''; }
                        echo '<option value="'.($i*5).'"'.$selected.'>'.($i*5).'</option>';
                     }
?>
                  </select>
               </td>
            </tr>
            <tr>
               <td class="setting_name"><?php echo $MOD_NEWS['TEXT_ORDER_FROM']; ?></td>
               <td class="setting_value">
                  <select class="w3-select w3-border" name="order_field" >
<?php
                     $sOrderField['published_when']  = $MOD_NEWS['TEXT_PUBLISHED_WHEN'];
                     $sOrderField['title']  = $TEXT['TITLE'];
                     $sOrderField['position']  = $MOD_NEWS['TEXT_POSITION'];
                     foreach($sOrderField AS $key => $name) {
                        if($aSetting['order_field'] == $key) {
?>
                    <option value="<?php echo $key;?>" selected="selected" ><?php echo $name;?></option>
<?php } else { ?>
                    <option value="<?php echo $key;?>" ><?php echo $name;?></option>
<?php }
                     }
?>
                  </select>
               </td>
            </tr>
            <tr>
               <td class="setting_name"><?php echo $MOD_NEWS['TEXT_ORDER_TO']; ?></td>
               <td class="setting_value">
                  <select class="w3-select w3-border" name="order" >
                     <?php
                     $sOrder['DESC']  = $MOD_NEWS['TEXT_ORDER_DESC'];
                     $sOrder['ASC']   = $MOD_NEWS['TEXT_ORDER_ASC'];
                     foreach($sOrder AS $key => $name) {
                        if($aSetting['order'] == $key) {
?>
                    <option value="<?php echo $key;?>" selected="selected" ><?php echo $name;?></option>
<?php } else { ?>
                    <option value="<?php echo $key;?>" ><?php echo $name;?></option>
<?php }
                     }
?>
                  </select>
               </td>
            </tr>
        </tbody>
      </table>
      </div>

    <div class="news block-outer" style="margin-top: 2.225em;">
     <table class="news file-ext">
      <caption class="news-header">
      <?php echo $TEXT['COMMENTS']; ?>
      </caption>
        <tbody>
        <tr>
           <td class="setting_name"><?php echo $TEXT['COMMENTING']; ?></td>
           <td class="setting_value">
              <select class="w3-select w3-border" name="commenting">
                 <option value="none"><?php echo $TEXT['DISABLED']; ?></option>
                 <option value="public" <?php if($aSetting['commenting'] == 'public') { echo ' selected="selected"'; } ?>><?php echo $TEXT['PUBLIC']; ?></option>
                 <option value="private" <?php if($aSetting['commenting'] == 'private') { echo 'selected="selected"'; } ?>><?php echo $TEXT['PRIVATE']; ?></option>
              </select>
           </td>
        </tr>
        <tr>
           <td class="setting_name"><?php echo $TEXT['CAPTCHA_VERIFICATION']; ?></td>
           <td>
              <input type="radio" name="use_captcha" id="use_captcha_true" value="1"<?php if($aSetting['use_captcha'] == true) { echo ' checked="checked"'; } ?> />
              <label for="use_captcha_true"><?php echo $TEXT['ENABLED']; ?></label>
              <input type="radio" name="use_captcha" id="use_captcha_false" value="0"<?php if($aSetting['use_captcha'] == false) { echo ' checked="checked"'; } ?> />
              <label for="use_captcha_false"><?php echo $TEXT['DISABLED']; ?></label>
           </td>
        </tr>
        <tr>
           <td class="setting_name"><?php echo $TEXT['DSGVO']; ?></td>
           <td>
              <input type="radio" name="use_data_protection" id="use_data_protection_true" value="1"<?php if($aSetting['use_data_protection'] == true) { echo ' checked="checked"'; } ?> />
              <label for="use_data_protection_true"><?php echo $TEXT['ENABLED']; ?></label>
              <input type="radio" name="use_data_protection" id="use_data_protection_false" value="0"<?php if($aSetting['use_data_protection'] == false) { echo ' checked="checked"'; } ?> />
              <label for="use_data_protection_false"><?php echo $TEXT['DISABLED']; ?></label>
           </td>
        </tr>

        <tr>
           <td class="setting_name"><?php echo $TEXT['DSGVO_LINK']; ?></td>
           <td>
            <select name="data_protection_link" size="3" style="font-family:monospace;font-size: 16px;width:98%;" />
                <option value="0"><?php echo $TEXT['PLEASE_SELECT']; ?></option>
<?php           foreach($aSelectSections as $aRes) {
                    $option_link = explode('|',$aRes['descr']);
                    $sDisabled = $option_link[0] ? '':' disabled="disabled"';
                    $sSelected = (($option_link[0] == $target_section_id) ? $sSelect : '');
                    $sFlagUrl  = WB_URL.'/modules/WBLingual/flags/png/'.strtolower($aRes['language']);  // {ADDON_LANG_URL}flags/png/{PAGE_LANG}
?>
                    <option <?php echo $sDisabled ;?>value="<?php echo $option_link[0];?>"<?php echo $sSelected;?> class="flag-box" style="background-image: url(<?php echo $sFlagUrl;?>-24.png);"><?php echo $option_link[1];?></option>
<?php
                }?>
            </select>
           </td>
        </tr>

        <?php if(extension_loaded('gd') AND function_exists('imageCreateFromJpeg')) { /* Make's sure GD library is installed */ ?>
        <tr>
           <td class="setting_name"><?php echo $TEXT['RESIZE_IMAGE_TO']; ?>:</td>
           <td class="setting_value">
              <select class="w3-select w3-border" name="resize" style="width: 98%;" >
                 <option value="0"><?php echo $TEXT['NONE']; ?></option>
                 <?php
                 $SIZES['50']  = '50x50px';
                 $SIZES['75']  = '75x75px';
                 $SIZES['100'] = '100x100px';
                 $SIZES['125'] = '125x125px';
                 $SIZES['150'] = '150x150px';
                 foreach($SIZES AS $size => $size_name) {
                    if($aSetting['resize'] == $size) { $selected = ' selected="selected"'; } else { $selected = ''; }
                    echo '<option value="'.$size.'"'.$selected.'>'.$size_name.'</option>';
                 }
                 ?>
              </select>
           </td>
        </tr>
        <?php } ?>
        <tr>
           <td class="setting_name"><?php echo $TEXT['COMMENTS'].' '.$TEXT['HEADER']; ?></td>
           <td class="setting_value">
              <textarea name="comments_header" rows="4" cols="1" style="width: 98%;"><?php echo str_replace($raw, $friendly, ($aSetting['comments_header'])); ?></textarea>
           </td>
        </tr>
        <tr>
           <td class="setting_name w3-cell-middle"><?php echo $TEXT['COMMENTS'].' '.$TEXT['LOOP']; ?></td>
           <td class="setting_value">
              <textarea name="comments_loop" rows="8" cols="1" style="width: 98%;"><?php echo str_replace($raw, $friendly, ($aSetting['comments_loop'])); ?></textarea>
           </td>
        </tr>
        <tr>
           <td class="setting_name w3-cell-middle"><?php echo $TEXT['COMMENTS'].' '.$TEXT['FOOTER']; ?></td>
           <td class="setting_value">
              <textarea name="comments_footer" rows="3" cols="1" style="width: 98%;"><?php echo str_replace($raw, $friendly, ($aSetting['comments_footer'])); ?></textarea>
           </td>
        </tr>
        <tr>
           <td class="setting_name w3-cell-middle"><?php echo $TEXT['COMMENTS'].' '.$TEXT['PAGE']; ?></td>
           <td class="setting_value">
              <textarea name="comments_page" rows="4" cols="1" style="width: 98%;"><?php echo str_replace($raw, $friendly, ($aSetting['comments_page'])); ?></textarea>
           </td>
        </tr>
        </tbody>
     </table>
    </div><!--  -->

<div class="w3-cell-row w3-margin-top"></div>
    <div class="w3-container w3-cell w3-mobile">
         <input style="min-width: 12.5em;" class="btn btn-default w3-blue-wb w3-round w3-hover-green w3-medium w3-padding-4" name="save" type="submit" value="<?php echo $TEXT['SAVE']; ?>" >
    </div>
    <div class="w3-container w3-cell w3-mobile">
        <input style="min-width: 13.5em;" class="btn btn-default w3-blue-wb w3-round w3-hover-green w3-medium w3-padding-4" name="save_pagetree" type="submit" value="<?php echo $TEXT['SAVE'].' & '.$TEXT['CLOSE']; ?>">
    </div>
    <div class="w3-container w3-cell w3-mobile">
        <input style="min-width: 12.5em;" id="cancel" class="btn btn-default w3-blue-wb w3-round w3-hover-green w3-medium w3-padding-4" type="button" value="<?php echo $TEXT['CLOSE']; ?>" onclick="window.location='<?php echo $sBacklink; ?>';" />
    </div>
</form>
</div><!--end class="news" -->

<?php
if ($print_info_banner) { ?>
<?php
}
// Print admin footer
$admin->print_footer();
