<?php
/**
 *
 * @category        modules
 * @package         news
 * @author          WebsiteBaker Project
 * @copyright       2009-2011, Website Baker Org. e.V.
 * @link            http://www.websitebaker2.org/
 * @license         http://www.gnu.org/licenses/gpl.html
 * @platform        WebsiteBaker 2.8.3
 * @requirements    PHP 5.3.6 and higher
 * @version         $Id: save_settings.php 68 2018-09-17 16:26:08Z Luisehahne $
 * @filesource      $HeadURL: svn://isteam.dynxs.de/wb/2.12.x/tags/2.12.1/modules/news/save_settings.php $
 * @lastmodified    $Date: 2018-09-17 18:26:08 +0200 (Mo, 17. Sep 2018) $
 *
 */

if (!defined('SYSTEM_RUN')) {require( dirname(dirname((__DIR__))).'/config.php');}
// Include WB admin wrapper script
$update_when_modified = true; // Tells script to update when this page was last updated
$admin_header = false;
require(WB_PATH.'/modules/admin.php');

$requestMethod = strtoupper($_SERVER['REQUEST_METHOD']);
$aRequestVars  = (isset(${'_'.$requestMethod}) ? ${'_'.$requestMethod} : $_REQUEST);

$sAddonName = basename(__DIR__);
$ModuleRel  = '/modules/'.$sAddonName;
$ModuleUrl  = WB_URL.$ModuleRel;
$ModulePath = WB_PATH.$ModuleRel;

$sSectionIdPrefix = (defined( 'SEC_ANCHOR' ) && ( SEC_ANCHOR != 'none' ) ? '#'.SEC_ANCHOR.$section_id : '' );
$sBacklink = ADMIN_URL.'/pages/modify.php?page_id='.$page_id;

if (!$admin->checkFTAN($requestMethod))
{
    $admin->print_header();
    $admin->print_error($MESSAGE['GENERIC_SECURITY_ACCESS'], $sBacklink.$sSectionIdPrefix);
}
$FTAN = $admin->getFTAN('GET');
$sBackUrl = $ModuleUrl.'/modify_settings.php?page_id='.$page_id.'&section_id='.$section_id.'&'.$FTAN;
$sBacklink = (isset($_REQUEST['save_pagetree'])? $sBacklink.$sSectionIdPrefix : $sBackUrl );

$admin->print_header();

// This code removes any <?php tags and adds slashes
$friendly = array('&lt;', '&gt;', '?php');
$raw = array('<', '>', '');

$iAdminRights = (($admin->ami_group_member('1')||$admin->get_permission('settings_view')) ? 29 : 26);
$layout = $admin->StripCodeFromText( $admin->get_post('layout'),$iAdminRights);
$header = $admin->StripCodeFromText( $admin->get_post('header'),$iAdminRights);
$post_loop = $admin->StripCodeFromText( $admin->get_post('post_loop'),$iAdminRights);
$footer = $admin->StripCodeFromText( $admin->get_post('footer'),$iAdminRights);
$post_header = $admin->StripCodeFromText( $admin->get_post('post_header'),$iAdminRights);
$post_footer = $admin->StripCodeFromText( $admin->get_post('post_footer'),$iAdminRights);

$comments_header = $admin->StripCodeFromText( $admin->get_post('comments_header'));
$comments_loop = $admin->StripCodeFromText( $admin->get_post('comments_loop'));
$comments_footer = $admin->StripCodeFromText( $admin->get_post('comments_footer'));
$comments_page = $admin->StripCodeFromText( $admin->get_post('comments_page'));
$sOrder = $admin->StripCodeFromText( $admin->get_post('order'));
$sOrderField = $admin->StripCodeFromText( $admin->get_post('order_field'));
$commenting = $admin->StripCodeFromText($admin->get_post('commenting'));
$posts_per_page = intval($admin->get_post('posts_per_page'));
$use_captcha = intval($admin->get_post('use_captcha'));
$use_data_protection = intval($admin->get_post('use_data_protection'));
$data_protection_link = $admin->StripCodeFromText($admin->get_post('data_protection_link'));
if(extension_loaded('gd') AND function_exists('imageCreateFromJpeg')) {
    $resize = (int)$admin->get_post('resize');
} else {
    $resize = 0;
}
$sql  = 'UPDATE '.TABLE_PREFIX.'mod_news_settings SET '
      . '`layout` = \''.$database->escapeString($layout).'\', '
      . '`header`=\''.$database->escapeString($header).'\', '
      . '`post_loop`=\''.$database->escapeString($post_loop).'\', '
      . '`footer`=\''.$database->escapeString($footer).'\', '
      . '`posts_per_page`= '.(int)($posts_per_page).', '
      . '`post_header`=\''.$database->escapeString($post_header).'\', '
      . '`post_footer`=\''.$database->escapeString($post_footer).'\', '
      . '`comments_header`=\''.$database->escapeString($comments_header).'\', '
      . '`comments_loop`=\''.$database->escapeString($comments_loop).'\', '
      . '`comments_footer`=\''.$database->escapeString($comments_footer).'\', '
      . '`comments_page`=\''.$database->escapeString($comments_page).'\', '
      . '`commenting`=\''.$database->escapeString($commenting).'\', '
      . '`resize`= '.(int)($resize).', '
      . '`use_captcha`= '.(int)($use_captcha).', '
      . '`order_field`=\''.$database->escapeString($sOrderField).'\', '
      . '`use_data_protection`= '.(int)($use_data_protection).', '
      . '`data_protection_link`='.(int)($data_protection_link).', '
      . '`order`=\''.$database->escapeString($sOrder).'\' '
      . 'WHERE `section_id`='.$database->escapeString($section_id).' '
      . '';

// Update settings
if (!$database->query($sql)){
    $admin->print_error($database->get_error(), $sBacklink.'#'.$sSectionIdPrefix.$section_id);
}
    $admin->print_success($TEXT['SUCCESS'], $sBacklink.'#'.$sSectionIdPrefix.$section_id);

// Print admin footer
$admin->print_footer();
