<?php
/* -------------------------------------------------------- */
// Must include code to stop this file being accessed directly
if (!defined('SYSTEM_RUN')) {header($_SERVER['SERVER_PROTOCOL'].' 404 Not Found'); echo '404 File not found'; flush(); exit;}
/* -------------------------------------------------------- */
?><?php
/**
 *
 * @category        modules
 * @package         output_filter
 * @copyright       WebsiteBaker Org. e.V.
 * @author          Manuela v.d.Decken <manuela@isteam.de>
 * @link            http://websitebaker.org/
 * @license         http://www.gnu.org/licenses/gpl.html
 * @platform        WebsiteBaker 2.8.3
 * @requirements    PHP 5.3.6 and higher
 * @version         $Id: cmdInstall.inc 93 2018-09-20 18:09:30Z Luisehahne $
 * @filesource      $HeadURL: svn://isteam.dynxs.de/wb/2.12.x/tags/2.12.1/modules/output_filter/cmd/cmdInstall.inc $
 * @lastmodified    $Date: 2018-09-20 20:09:30 +0200 (Do, 20. Sep 2018) $
 *
 */

    $globalStarted = preg_match('/upgrade\-script\.php$/', $_SERVER["SCRIPT_NAME"]);
    $sWbVersion = (defined('VERSION') ? VERSION : WB_VERSION);
    if (version_compare($sWbVersion, '2.11.0', '<')){
        throw new Exception ('It is not possible to install from WebsiteBaker Versions before 2.11.0');
    }
    Translate::getInstance ()->disableAddon ('modules\\'.$sAddonName);
    Translate::getInstance()->enableAddon(ADMIN_DIRECTORY.'\\addons');
    if (is_writable(WB_PATH.'/temp/cache')) {
        Translate::getInstance()->clearCache();
    }
    $sTable = TABLE_PREFIX.'mod_output_filter';
    $i = (!isset($i) ? 1 : $i);
    $OK   = "<span class=\"ok\">OK</span>";
    $FAIL = "<span class=\"error\">FAILED</span>";
    $iErr = false;
    $msg = array(
        '<div style="margin:1em auto;font-size:1.1em;">',
        '<h4>Step '.$i++.': Installing Output Filter Settings</h4>'
    );
    if (is_writable($sAddonPath.'/filters/filterShortUrl.php')){
        unlink($sAddonPath.'/filters/filterShortUrl.php');
    }
    // create tables from sql dump file
    $sInstallStruct = $sAddonPath.'/install-struct.sql';
    if ( !is_readable($sInstallStruct)) {
        $msg[] = '<strong>\'missing or not readable file [install-struct.sql]\'</strong> '.$FAIL.'<br />';
        $iErr = true;
    } else {
        $getDefaultSettings = (function() use ( $sAddonName ){
            $aDefaults = array(
                'at_replacement'  => '[at]',
                'dot_replacement' => '[dot]',
                'email_filter'    => '1',
                'mailto_filter'   => '1'
            );
            $aFiles = glob(WB_PATH.'/modules/'.$sAddonName.'/filters/*', \GLOB_MARK);
            $aInactiveList = ['OpF', 'RelUrl', 'JqueryUI'];
            foreach ( $aFiles  as $sFilterFile) {
                if (substr(str_replace('\\', '/', $sFilterFile), -1) == '/') {
                    $key = basename($sFilterFile);
                } else {
                    $key = preg_replace('=^.*?filter([^\.\/\\\\]+)(\.[^\.]+)?$=is', '\1', $sFilterFile);
                }
                if (in_array($key,$aInactiveList)){
                    $aDefaults[$key] = '0';
                } else {
                    $aDefaults[$key] = '1';
                }
            }
          ksort($aDefaults);
          return $aDefaults;
        });
        $aDefaults =  $getDefaultSettings();

        // drop old table and create new one
        if ($database->SqlImport($sInstallStruct, TABLE_PREFIX, false)) {
            if ($aDefaults) {
            // restore old settings if there any
                $sNameValPairs = '';
                foreach ($aDefaults as $index => $val) {
                    $sNameValPairs .= ', (\''.$index.'\', \''.$database->escapeString($val).'\')';
                }
                $sValues = ltrim($sNameValPairs, ', ');
                $sql = 'INSERT INTO `'.$sTable.'` (`name`, `value`) '
                     . 'VALUES '.$sValues;
                if (!$database->query($sql)) {
                    $msg[] = '<strong>\'Output Filter install settings\'</strong> '.$FAIL.'<br />';
                    $iErr = true;
                } else {
                    $msg[] = '<strong>\'Output Filter settings successful installed\'</strong> '.$OK.'<br />';
                }
            }
        } else {
          $msg[] = '<strong>\'installing or not readable file [install-struct.sql]\'</strong> '.$FAIL.'<br />';
          $iErr = true;
        }
        unset($getDefaultSettings);
    }
    $msg[] = '</div>';
//    print implode("\n", $msg)."\n";
