<?php
/**
 *
 * @category        modules
 * @package         output_filter
 * @author          WebsiteBaker Project
 * @copyright       2004-2009, Ryan Djurovich
 * @copyright       2009-2011, Website Baker Org. e.V.
 * @link            http://www.websitebaker2.org/
 * @license         http://www.gnu.org/licenses/gpl.html
 * @platform        WebsiteBaker 2.8.x
 * @requirements    PHP 5.2.2 and higher
 * @version         $Id: DE.php 93 2018-09-20 18:09:30Z Luisehahne $
 * @filesource        $HeadURL: svn://isteam.dynxs.de/wb/2.12.x/tags/2.12.1/modules/output_filter/themes/default/languages/DE.php $
 * @lastmodified    $Date: 2018-09-20 20:09:30 +0200 (Do, 20. Sep 2018) $
 *
 */

// Deutsche Modulbeschreibung
$module_description                     = 'Dieses Modul erlaubt die Filterung von Inhalten vor der Anzeige im Frontendbereich. Unterstützt die Filterung von Emailadressen in mailto Links und Text.';

// Ueberschriften und Textausgaben
$MOD_MAIL_FILTER['HEADING']             = 'Optionen: Ausgabe Filterung';
$MOD_MAIL_FILTER['HOWTO']               = 'Über nachfolgende Optionen kann die Ausgabefilterung konfiguriert werden.<b>Tipp: </b>Mailto Links können mit einer Javascript Routine verschlüsselt werden. Ohne diese Änderungen wird nur das @ Zeichen im Text ersetzt.';
$MOD_MAIL_FILTER['WARNING']             = 'Erfassen der eigenen Filter in der Reihenfolge wie Output Filter diese abarbeiten soll. Diese private Liste ist optional und wird beim Upgrade nicht überschrieben und an die Liste der Standardfilter angehängt. Hinweis: Bei einer leeren privaten Filterliste bleiben die Standardfilter erhalten.';
// Text von Form Elementen
$MOD_MAIL_FILTER['SET_ACTIVE']          = 'Filter aktivieren/deaktivieren';
$MOD_MAIL_FILTER['BASIC_CONF']          = 'Grundeinstellungen';
$MOD_MAIL_FILTER['SYS_REL']             = 'Frontendausgabe mit relativen Urls';
$MOD_MAIL_FILTER['opf']                 = 'Output filter Dashboard';
$MOD_MAIL_FILTER['EMAIL_FILTER']        = 'Filtere E-Mail Adressen im Text';
$MOD_MAIL_FILTER['MAILTO_FILTER']       = 'Filtere E-Mail Adressen in mailto';
$MOD_MAIL_FILTER['ENABLED']             = 'Aktiviert';
$MOD_MAIL_FILTER['DISABLED']            = 'Ausgeschaltet';

$MOD_MAIL_FILTER['REPLACEMENT_CONF']    = 'Email Ersetzungen';
$MOD_MAIL_FILTER['AT_REPLACEMENT']      = 'Ersetze "@" durch';
$MOD_MAIL_FILTER['DOT_REPLACEMENT']     = 'Ersetze "." durch';

$TEXT['SAVE_LIST']  = 'Liste Speichern';
$TEXT['ADD_LIST']   = 'Liste Anlegen';
$TEXT['EMPTY_LIST'] = 'Liste Leeren';

$output_filter_help = [
                'Droplets'=>'Führt Droplets aus',
                'Email'=>'Macht E-Mail Links zum ausspähen schwerer lesbar',
                'SnippetCss'=>'Lädt externe Snippet/Tool Style Files mit <code>register_frontend_modfiles("css")</code> in den HEAD',
                'FrontendCss'=>'Lädt externe Seitenmodul Style Files mit <code>register_frontend_modfiles("css")</code> in den HEAD',
                'ScriptVars'=>'Setzt Javascript Variablen für die weitere Bearbeitung in den HEAD.',
                'FrontendJs'=>'Lädt externe Seitenmodul Script Files in den HEAD',
                'SnippetBodyJs'=>'Lädt externe Snippet/Tool Script Files mit <code>register_frontend_modfiles_body("js")</code> vor BODY Ende.<br />'
                                . 'Es ist nicht nötig RegisterModFiles einzuschalten',
                'LoadOnFly'=>'Lädt DomReady sowie LoadOnFLy Script in den HEAD zum dynamischen Laden von externen Styles',
                'Jquery'=>'Aktiviert die Einbindung von jquery<br />'
                        . '<ol start="1">'
                        . '<li>1) RegisterModFiles eingeschaltet</li>'
                        . '<ul style="padding-left: 1.525em;">'
                        . '<li>Laden von jQuery über <code>register_frontend_modfiles("jquery")</code> in den HEAD</li>'
                        . '<li><code>register_frontend_modfiles_body("jquery")</code> vor BODY Ende. (RegisterModFiles muss eingeschaltet sein)</li>'
                        . '</ul>'
                        . '<li>2) RegisterModFiles ausgeschaltet</li>'
                        . '<ul style="padding-left: 1.525em;">'
                        . '<li>jQuery in den HEAD laden</li>'
                        . '<li>über <code>register_frontend_modfiles("css")</code></li>'
                        . '</ul>'
                        . '</ol>'
                        . '</span> ',
                'JqueryUI'=>'Aktiviert JqueryUi zum Jquery',
                'SnippetJs'=>'Lädt externe Snippet/Tool Script Files in den HEAD',
                'FrontendBodyJs'=>'Lädt externe Seitenmodul Script Files mit <code>register_frontend_modfiles_body("js")</code> vor BODY Ende.<br />'
                                . 'Es ist nicht nötig RegisterModFiles einzuschalten',
                'OpF'=>'Output filter Dashboard',
                'RegisterModFiles'=>'<p>Zur Unterstützung älterer Templates und Abwärtskompabilität '
                                  . 'unterstützt der Filter die <code>register_frontend_modfiles...</code> </p>'
                                  . '<ol>'
                                  . '<li>1) RegisterModFiles eingeschaltet</li>'
                                  . '<ul style="padding-left: 1.525em;">'
                                  . '<li>Laden der externen Scripte mit <code>register_frontend_modfiles("js") oder ("jquery")</code>.'
                                  . '</ul>'
                                  . '<li>2) RegisterModFiles ausgeschaltet</li>'
                                  . '<ul style="padding-left: 1.525em;">'
                                  . '<li>Lädt alle externen Styles und Scripte über <code>register_frontend_modfiles("css")</code> in den HEAD.</li>'
                                  . '</ul>'
                                  . '</ol>'
                                  . '<p>Einbinden <code>register_frontend_modfiles_body("js")</code> vor BODY Ende zum Laden der externen front_body.js Scripte.<br />'
                                  . 'Es ist dafür nicht nötig RegisterModFiles einzuschalten</p>',
                'at_replacement'=>'',
                'dot_replacement'=>'',
                'RelUrl'=>'Ändert absolute in relative Urls',
                'OutputFilterMode'=>'',
                'ReplaceSysvar'=>'',
                'WbLink'=>'',
                'email_filter'=>'',
                'mailto_filter'=>'',
                'CssToHead'=>'',
        ];
$MOD_MAIL_FILTER['HELP_MISSING'] = 'Für dieses Filter gibt es keine Hilfe';
