<?php
/**
 *
 * @category        modules
 * @package         output_filter
 * @author          WebsiteBaker Project
 * @copyright       2004-2009, Ryan Djurovich
 * @copyright       2009-2011, Website Baker Org. e.V.
 * @link            http://www.websitebaker2.org/
 * @license         http://www.gnu.org/licenses/gpl.html
 * @platform        WebsiteBaker 2.8.x
 * @requirements    PHP 5.6.x and higher
 * @version         $Id: EN.php 93 2018-09-20 18:09:30Z Luisehahne $
 * @filesource      $HeadURL: svn://isteam.dynxs.de/wb/2.12.x/tags/2.12.1/modules/output_filter/themes/default/languages/EN.php $
 * @lastmodified    $Date: 2018-09-20 20:09:30 +0200 (Do, 20. Sep 2018) $
 *
 */

// Deutsche Modulbeschreibung
$module_description                     = 'This module allows filtering of content before it is displayed in the frontend area. Supports filtering of email addresses in mailto links and text.';

// Ueberschriften und Textausgaben
$MOD_MAIL_FILTER['HEADING']             = 'Options: Output Filtering';
$MOD_MAIL_FILTER['HOWTO']               = 'Output filtering can be configured via the following options.<b>Tip: </b>Mailto links can be encrypted with a Javascript routine. Without these changes, only the @ sign in the text will be replaced.';
$MOD_MAIL_FILTER['WARNING']             = 'Enter your own filters in the order in which they should be processed. This private list is optional and is not overwritten during the upgrade and is appended to the list of default filters. Note: In case of an empty private filter list, the default filters are retained.';
// Text von Form Elementen
$MOD_MAIL_FILTER['SET_ACTIVE']          = 'Activate/deactivate filter';
$MOD_MAIL_FILTER['BASIC_CONF']          = 'Default settings';
$MOD_MAIL_FILTER['SYS_REL']             = 'Frontend output with relative urls';
$MOD_MAIL_FILTER['opf']                 = 'Output filter Dashboard';
$MOD_MAIL_FILTER['EMAIL_FILTER']        = 'Filter email addresses in the text';
$MOD_MAIL_FILTER['MAILTO_FILTER']       = 'Filter email addresses in mailto';
$MOD_MAIL_FILTER['ENABLED']             = 'Enabled';
$MOD_MAIL_FILTER['DISABLED']            = 'Disabled';

$MOD_MAIL_FILTER['REPLACEMENT_CONF']    = 'Email replacements';
$MOD_MAIL_FILTER['AT_REPLACEMENT']      = 'Replace "@" with';
$MOD_MAIL_FILTER['DOT_REPLACEMENT']     = 'Replace "." with';

$TEXT['SAVE_LIST']  = 'Save list';
$TEXT['ADD_LIST']   = 'Create List';
$TEXT['EMPTY_LIST'] = 'Empty list';

$output_filter_help = [
                'Droplets'=>'Executes Droplets',
                'Email'=>'Makes e-mail links more difficult to read and spy out.',
                'SnippetCss'=>'Loads external snippet/tool style files with <code>register_frontend_modfiles("css")</code> into the HEAD',
                'FrontendCss'=>'Loads external page module style files with <code>register_frontend_modfiles("css")</code> into the HEAD',
                'ScriptVars'=>'Sets Javascript variables for further processing in the HEAD',
                'FrontendJs'=>'Loads external page module script files into HEAD',
                'SnippetBodyJs'=>'Loads external snippet/tool script files with <code>register_frontend_modfiles_body("js")</code> before BODY end.<br />'
                                . 'It is not necessary to switch on the filter RegisterModFiles',
                'LoadOnFly'=>'Loads DomReady and LoadOnFLy script into HEAD for dynamic loading of external styles',
                'Jquery'=>'Activates the integration of jQuery <br />'
                        . '<ol start="1">'
                        . '<li>1) RegisterModFiles switched on</li>'
                        . '<ul style="padding-left: 1.525em;">'
                        . '<li>Loading of jQuery via <code>register_frontend_modfiles("jquery")</code> into the HEAD</li>'
                        . '<li><code>register_frontend_modfiles_body("jquery")</code> before BODY end. (RegisterModFiles must be switched on)</li>'
                        . '</ul>'
                        . '<li>2) RegisterModFiles off</li>'
                        . '<ul style="padding-left: 1.525em;">'
                        . '<li>Load jQuery into the HEAD</li>'
                        . '<li>via <code>register_frontend_modfiles("css")</code></li>'
                        . '</ul>'
                        . '</ol>'
                        . '',
                'JqueryUI'=>'Activates JqueryUi for Jquery',
                'SnippetJs'=>'Loads external snippet/tool script files into HEAD',
                'FrontendBodyJs'=>'Loads external page module script files with <code>register_frontend_modfiles_body("js")</code> before BODY end.<br />'
                                . 'It is not necessary to enable the RegisterModFiles',
                'OpF'=>'Output filter Dashboard',
                'RegisterModFiles'=>'<p>To support older templates and backward compatibility'
                                  . 'the filter supports <code>register_frontend_modfiles....</code> </p>'
                                  . '<ol>'
                                  . '<li>1) RegisterModFiles enabled</li>'
                                  . '<ul style="padding-left: 1.525em;">'
                                  . '<li>Load the external scripts with <code>register_frontend_modfiles("js") or ("jquery")</code>.'
                                  . '</ul>'
                                  . '<li>2) RegisterModFiles disabled</li>'
                                  . '<ul style="padding-left: 1.525em;">'
                                  . '<li>Loads all external styles and scripts via <code>register_frontend_modfiles("css")</code> into the HEAD.</li>'
                                  . '</ul>'
                                  . '</ol>'
                                  . '<p>Include <code>register_frontend_modfiles_body("js")</code> before BODY End to load the external frontend_body.js scripts.<br />'
                                  . 'It is not necessary to enable the RegisterModFiles</p>',
                'at_replacement'=>'',
                'dot_replacement'=>'',
                'RelUrl'=>'Changes absolute to relative urls',
                'OutputFilterMode'=>'',
                'ReplaceSysvar'=>'',
                'WbLink'=>'',
                'email_filter'=>'',
                'mailto_filter'=>'',
                'CssToHead'=>'',
        ];
$MOD_MAIL_FILTER['HELP_MISSING'] = 'There is no help for this filter yet';
