<?php
/**
 *
 * @category        modules
 * @package         wysiwyg
 * @author          WebsiteBaker Project
 * @copyright       WebsiteBaker Org. e.V.
 * @link            https://websitebaker.org/
 * @license         http://www.gnu.org/licenses/gpl.html
 * @platform        WebsiteBaker 2.8.3
 * @requirements    PHP 5.6 and higher
 * @version         $Id: upgrade.php 183 2018-11-15 07:01:37Z Luisehahne $
 * @filesource      $HeadURL: svn://isteam.dynxs.de/wb/2.12.x/tags/2.12.1/modules/wysiwyg/upgrade.php $
 * @lastmodified    $Date: 2018-11-15 08:01:37 +0100 (Do, 15. Nov 2018) $
 *
 */

/* -------------------------------------------------------- */
// Must include code to stop this file being accessed directly
if (!\defined('SYSTEM_RUN')) {\header($_SERVER['SERVER_PROTOCOL'].' 404 Not Found'); echo '404 File not found'; \flush(); exit;}
/* -------------------------------------------------------- */
    $globalStarted = \preg_match('/upgrade\-script\.php$/', $_SERVER["SCRIPT_NAME"]);
    $sWbVersion = ($globalStarted && \defined('VERSION') ? VERSION : WB_VERSION);
    if (version_compare($sWbVersion, '2.11.0', '<')){
        throw new \Exception ('It is not possible to install from WebsiteBaker Versions before 2.11.0');
    }
    $msg = '';
    $sInstallStruct = __DIR__.'/install-struct.sql';
    if (!$database->SqlImport($sInstallStruct, TABLE_PREFIX, 'upgrade' )){
        $msg = $database->get_error();
    }
// sanitize URLs inside mod_wysiwyg.content ----------------------------
    $msg = '';
    $sql = 'SELECT `content`, `section_id` FROM `'.TABLE_PREFIX.'mod_wysiwyg`';
    if (($oInstances = $database->query($sql))) {
        while (($aInstance = $oInstances->fetchRow(MYSQLI_ASSOC))) {
            // add $sDocumentRootUrl to relative URLs
            $sContent = $admin->ReplaceAbsoluteMediaUrl($aInstance['content']);
            // migrate old placeholder SYSVAR:MEDIA_REL to new format
            $sContent = str_replace (['{SYSVAR:MEDIA_REL}/'],['{SYSVAR:AppUrl.MediaDir}'],$sContent);
            $sText = strip_tags($sContent);
            $sql = 'UPDATE `'.TABLE_PREFIX.'mod_wysiwyg` '
                 . 'SET `content`=\''.$database->escapeString($sContent).'\', '
                . '`text`=\''.$database->escapeString($sText).'\' '
                 . 'WHERE `section_id`='.(int)$aInstance['section_id'];
            if (!$database->query($sql)) {
                $msg = $database->get_error();
                break;
            }
        }// end while
    } else { $msg = $database->get_error(); }

// ---------------------------------------------------------------------
